2026-01-29  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 1.0.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 1.0.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.
	* gettext-tools/examples/hello-*/autogen.sh: Copy remove-potcdate.sed from the
	new location in the source tree. Copy also the no-op fetch-po.
	* gettext-tools/examples/hello-*/autoclean.sh: Remove also fetch-po.

2026-01-29  Bruno Haible  <bruno@clisp.org>

	Prepare for 1.0 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-tools/wizard/po-templates/traditional/Makefile.in.in: Update Origin.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:6:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:7:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 6:0:6.
	* gettext-tools/autotools/autopoint.in: Accept version 1.0.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 1.0.
	* gettext-tools/autotools/archive.dir.tar: Regenerated.

2026-01-29  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.

2026-01-29  Bruno Haible  <bruno@clisp.org>

	msginit: Don't backup when mergeing a PO file and --no-translator is given.
	* gettext-tools/src/msginit.c (main): Don't create a backup file if
	--no-translator is specified.

2026-01-29  Bruno Haible  <bruno@clisp.org>

	msginit: Fix handling of --properties-output when producing a merged PO file.
	* gettext-tools/src/msgl-merge.h (merge): Add definitions_file_syntax parameter.
	Rename input_syntax parameter to references_file_syntax.
	* gettext-tools/src/msgl-merge.c (merge): Likewise.
	* gettext-tools/src/msginit.c (main): New variable output_file_input_syntax.
	Fix merge() call.
	* gettext-tools/src/msgmerge.c (main): Update merge() call.

2026-01-28  Bruno Haible  <bruno@clisp.org>

	po: Distribute the fetch-po file.
	This is somewhat tricky, because it is also a phony Makefile target.

	* gettext-tools/wizard/po-templates/traditional/Makefile.in.in (dist2):
	Distribute 'fetch-po'.
	* gettext-tools/examples/po/Makefile.am (distdir1): Distribute 'fetch-po'.
	* gettext-tools/examples/hello-*/po/Makefile.am (distdir1): Likewise.

2026-01-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2026-01-28  Bruno Haible  <bruno@clisp.org>

	xgettext: PHP: Fix parsing of strings and heredocs with embedded expressions.
	Reported by Gert Jan Schoneveld <gertjan@facilityapps.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-08/msg00007.html>
	and by Benoit Waldmann <benoit.waldmann@siagilus.fr>
	at <https://savannah.gnu.org/bugs/index.php?item_id=67948>.

	* gettext-tools/src/x-php.c (enum token_type_ty): New enum values
	token_type_lbrace, token_type_rbrace.
	(struct php_extractor): New field brace_nesting_depth.
	(php_extractor_init_rest): Initialize it.
	(extract_balanced): Forward-declare.
	(process_dquote_or_heredoc): Change handling of embedded expressions.
	(phase4_get): Recognize token_type_lbrace, token_type_rbrace.
	(extract_balanced): Recurse also for token_type_lbrace.
	(extract_php_input): Remove function.
	(extract_php): Inline it here.
	* gettext-tools/tests/xgettext-php-1: Add more tests of embedded expressions.

2026-01-28  Bruno Haible  <bruno@clisp.org>

	Update "Written by ..." lines in --version output.
	* gettext-tools/src/msgfmt.c (main): Add me and Daiki Ueno as co-authors.
	* gettext-runtime/src/ngettext.c (main): Add me as co-author.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-tools/wizard/gettextize.in (func_version): Likewise. Terminate the
	'Written by' line with a '.'.
	* gettext-tools/autotools/autopoint.in (func_version): Terminate the
	'Written by' line with a '.'.
	* gettext-tools/autotools/convert-archive.in (func_version): Likewise.
	* gettext-tools/misc/po-fetch.in (func_version): Likewise.
	* gettext-runtime/src/gettext.sh.in (func_version): Likewise.
	* libtextstyle/gnulib-local/build-aux/moopp (func_version): Likewise.

2026-01-27  Bruno Haible  <bruno@clisp.org>

	po-mode: Prepare for inclusion in GNU ELPA.
	Suggested by Stefan Monnier <monnier@iro.umontreal.ca> in
	<https://lists.gnu.org/archive/html/bug-gettext/2026-01/msg00086.html>.

	* gettext-tools/emacs/po-mode.el: Add meta-information field 'Version:',
	required by ELPA. Move meta-information after the copyright and license notice.
	(po-mode-version-string): Move definition.
	* gettext-tools/emacs/po-compat.el: Move meta-information after the copyright
	and license notice. Convert the file to UTF-8 encoding.

2026-01-27  Bruno Haible  <bruno@clisp.org>

	Update "Written by ..." lines and authorship notices in source files.

2026-01-26  Bruno Haible  <bruno@clisp.org>

	Update email address in copyright notices.

2026-01-26  Bruno Haible  <bruno@clisp.org>

	Use the common comment style.

2026-01-25  Bruno Haible  <bruno@clisp.org>

	Fix a small memory leak in libgettextpo.
	Reported by <gemmaro.dev@gmail.com> at
	<https://savannah.gnu.org/bugs/index.php?item_id=67892>
	and by Albert Astals Cid <aacid@kde.org> in
	<https://lists.gnu.org/archive/html/bug-gettext/2026-01/msg00071.html>.

	* gettext-tools/src/read-po-lex.h: Include str-list.h.
	(lex_start): Add arena parameter.
	* gettext-tools/src/read-po-lex.c (lex_start): Add arena parameter. Add the
	heap-allocated file_name to the arena.
	* gettext-tools/src/read-catalog-abstract.h: Include str-list.h.
	(struct catalog_input_format): Add arena parameter to parse() method.
	(catalog_reader_parse): Add arena parameter.
	* gettext-tools/src/read-properties.c (properties_parse): Add arena parameter.
	* gettext-tools/src/read-stringtable.c (stringtable_parse): Add arena parameter.
	* gettext-tools/src/read-po.c (po_parse): Add arena parameter. Update lex_start
	call.
	* gettext-tools/src/read-catalog-abstract.c (catalog_reader_parse): Add arena
	parameter. Update parse() method call.
	* gettext-tools/src/read-catalog.h: Include str-list.h.
	(read_catalog_stream): Add arena parameter.
	* gettext-tools/src/read-catalog.c (read_catalog_stream): Add arena parameter.
	Update catalog_reader_parse call.
	* gettext-tools/src/read-catalog-file.c: Include str-list.h.
	(read_catalog_file): Update read_catalog_stream call.
	* gettext-tools/src/read-csharp.c: Include str-list.h.
	(execute_and_read_po_output): Update read_catalog_stream call.
	* gettext-tools/src/read-java.c: Include str-list.h.
	(execute_and_read_po_output): Update read_catalog_stream call.
	* gettext-tools/src/read-resources.c: Include str-list.h.
	(execute_and_read_po_output): Update read_catalog_stream call.
	* gettext-tools/src/read-tcl.c: Include str-list.h.
	(msgdomain_read_tcl): Update read_catalog_stream call.
	* gettext-tools/libgettextpo/gettext-po.c: Include str-list.h.
	(struct po_file): Add field 'arena'.
	(po_file_create): Initialize it.
	(po_file_read): Likewise. Update read_catalog_stream call.
	(po_file_free): Destroy the arena.
	* gettext-tools/src/msgfmt.c (read_catalog_file_msgfmt): Update
	catalog_reader_parse call.
	* gettext-tools/src/x-po.c: Include str-list.h.
	(extract): Update catalog_reader_parse call.
	* gettext-tools/src/xgettext.c (read_exclusion_file): Update
	catalog_reader_parse call.

2026-01-25  Bruno Haible  <bruno@clisp.org>

	doc: Explain translation projects.
	* gettext-tools/doc/gettext.texi (Interfacing with the Translators): New
	section.

2026-01-25  Bruno Haible  <bruno@clisp.org>

	Fix warnings with gcc 15 and glibc 2.43.
	* libtextstyle/gnulib-local/lib/glib/gstrfuncs.in.h (g_strstr_len): Change
	return type to 'const gchar *'.
	* libtextstyle/gnulib-local/lib/glib/gstrfuncs.c (g_strstr_len): Likewise.
	* libtextstyle/gnulib-local/lib/libcroco/cr-rgb.c (cr_rgb_set_from_name): Change
	type of 'result'.
	* gettext-tools/src/cldr-plurals.c (extract_rules): Cast the sb_xcontents_c
	result to 'char *'.

2026-01-17  Bruno Haible  <bruno@clisp.org>

	Fix some -Wzero-as-null-pointer-constant warnings.
	* gnulib-local/lib/backupfile.c (max_backup_version, backup_args, get_version):
	Write NULL instead of 0.
	* gettext-tools/src/x-go.c (add_to_hash_table): Likewise.

2026-01-15  Bruno Haible  <bruno@clisp.org>

	build: Fix "make installcheck" on MSVC.
	Reported by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2026-01/msg00042.html>.

	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): New variable
	INTL_WINDOWS_LIBS. Add it to LIBINTL and LTLIBINTL.
	* gettext-runtime/configure.ac (INSTALLED_LIBINTL): Add $INTL_WINDOWS_LIBS.
	* gettext-tools/configure.ac (INSTALLED_LIBINTL): Likewise.
	* libtextstyle/configure.ac (INSTALLED_LIBTEXTSTYLE): New variable.
	* libtextstyle/install-tests/Makefile.am (installcheck-local): Link with
	$INSTALLED_LIBTEXTSTYLE instead of -ltextstyle.

2026-01-13  Bruno Haible  <bruno@clisp.org>

	Prepare for 1.0-pre2 prerelease.
	* gettext-runtime/src/envsubst.c (main): Update copyright year in --version
	output.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/gettext.sh.in (func_version): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-runtime/src/printf_gettext.c (main): Likewise.
	* gettext-runtime/src/printf_ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgpre.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/spit.c (main): Likewise.
	* gettext-tools/src/spit.py.in (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-tools/autotools/convert-archive.in (func_version): Likewise.
	* gettext-tools/autotools/autopoint.in (func_version): Likewise.
	* gettext-tools/wizard/gettextize.in (func_version): Likewise.

2026-01-13  Michele Locati  <michele@locati.it>

	cldr-plurals: Fix parsing of plurals.xml from CLDR 38 or newer.
	Reported by Michele Locati at <https://savannah.gnu.org/bugs/?66378>.

	* gettext-tools/src/cldr-plural-exp.c (eval_relation): Accept operands 'c', 'e'.
	* gettext-tools/src/cldr-plural.y (yylex): Likewise.
	* gettext-tools/src/cldr-plurals.c (extract_rules): Test for type='cardinal'.
	(get_XcY_end, force_spaces, remove_XcY, remove_empty_examples): New functions.
	(main): Invoke force_spaces, remove_XcY, remove_empty_examples.
	* gettext-tools/tests/cldr-plurals-1: Add more tests.
	* AUTHORS: Add Michele Locati.

2026-01-12  Bruno Haible  <bruno@clisp.org>

	Document a libcurl requirement.
	Reported by Michele Locati <michele@locati.it> in
	<https://lists.gnu.org/archive/html/bug-gettext/2026-01/msg00029.html>.

	* DEPENDENCIES: Mention special requirements of libcurl on Windows.

2026-01-11  Bruno Haible  <bruno@clisp.org>

	Improve support for clang on native Windows.
	* gettext-tools/src/write-mo.c (roundup): Treat clang like GCC.

2026-01-11  Bruno Haible  <bruno@clisp.org>

	Improve support for clang on native Windows.
	* gettext-runtime/intl/libgnuintl.in.h (_INTL_REDIRECT_ASM): Treat clang like
	GCC.

2026-01-11  Bruno Haible  <bruno@clisp.org>

	Improve support for clang on native Windows.
	Reported by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2026-01/msg00021.html>.

	* libtextstyle/gnulib-local/lib/ostream.oo.h (ostream_printf, ostream_vprintf):
	Treat clang like GCC.
	* gettext-runtime/libasprintf/vasprintf.h (__attribute__, __format__,
	__printf__): Likewise.
	* gettext-runtime/libasprintf/autosprintf.in.h (_AUTOSPRINTF_ATTRIBUTE_FORMAT):
	Likewise.
	* gettext-tools/src/format.h (formatstring_error_logger_t): Likewise.
	* gettext-tools/src/if-error.h (if_error, if_verror): Likewise.
	* gettext-tools/src/msgl-check.c (formatstring_error_logger): Likewise.
	* gettext-tools/src/msgl-merge.c (silent_error_logger): Likewise.
	* gettext-tools/src/po-error.h (__attribute__, __format__, __printf__, po_error,
	po_error_at_line): Likewise.
	* gettext-tools/src/read-po-lex.h (__attribute__, __format__, __printf__):
	Likewise.
	* gettext-tools/src/xg-check.c (formatstring_error_logger): Likewise.
	* gettext-tools/libgettextpo/gettext-po.in.h (struct po_error_handler):
	Likewise.

2026-01-10  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Assume a working <stdbool.h>.
	* libtextstyle/lib/textstyle.h: Include <stdbool.h> instead of
	<textstyle/stdbool.h>.
	* libtextstyle/lib/Makefile.am (nobase_nodist_include_HEADERS): Don't add
	textstyle/stdbool.h.
	(textstyle/stdbool.h): Remove rule.
	(BUILT_SOURCES, MOSTLYCLEANFILES, CLEANFILES): Update accordingly.
	(EXTRA_DIST): Remove stdbool.mini.h.
	* libtextstyle/lib/stdbool.mini.h: Remove file.
	* gettext-tools/src/Makefile.am (textstyle/stdbool.h): Remove target.
	(BUILT_SOURCES, MOSTLYCLEANFILES): Remove textstyle/stdbool.h.

2026-01-10  Bruno Haible  <bruno@clisp.org>

	xgettext: Allow inhibiting the warnings about URLs and email addresses.
	Reported at <https://savannah.gnu.org/bugs/?67672>.

	* gettext-tools/src/message.h (enum syntax_check_type): Add sc_url, sc_email.
	(NSYNTAXCHECKS): Increase by 2.
	* gettext-tools/src/message.c (syntax_check_name): Update.
	* gettext-tools/src/xgettext.h (default_syntax_check): Add comment.
	* gettext-tools/src/xgettext.c (default_syntax_check): Add initializer.
	(main): Recognize --no-check option.
	(usage): Document --no-check option.
	* gettext-tools/src/xg-message.c (decide_syntax_check): Assume that
	default_syntax_check[i] != undecided.
	* gettext-tools/src/xg-check.c (syntax_check_function): Remove the second
	argument.
	(string_has_ascii_ellipsis): New function, extracted from
	syntax_check_ellipsis_unicode.
	(message_has_ascii_ellipsis): New function.
	(syntax_check_ellipsis_unicode): Remove the second argument. Simplify. Emit only
	a single error for both msgid and msgid_plural.
	(string_has_space_ellipsis): New function, extracted from
	syntax_check_space_ellipsis.
	(message_has_space_ellipsis): New function.
	(syntax_check_space_ellipsis): Remove the second argument. Simplify. Emit only
	a single error for both msgid and msgid_plural.
	(syntax_check_quote_unicode): Remove the second argument.
	(syntax_check_bullet_unicode_string): New function, extracted from
	syntax_check_bullet_unicode.
	(syntax_check_bullet_unicode): Remove the second argument. Simplify.
	(string_has_url): Don't recognize 'mailto:' URLs.
	(syntax_check_url, syntax_check_email): New functions, extracted from
	url_check_message.
	(url_check_message): Remove function.
	(sc_funcs): Add syntax_check_url, syntax_check_email.
	(syntax_check_message): Simplify.
	(xgettext_check_message_list): Don't invoke url_check_message.
	* gettext-tools/tests/xgettext-14: Update after xg-check.c changesd.
	* gettext-tools/tests/xgettext-20: Add more testcases.
	* gettext-tools/doc/xgettext.texi: Document the --no-check option.
	* gettext-tools/doc/gettext.texi: Bump copyright year.
	* NEWS: Mention the change.

2026-01-10  Bruno Haible  <bruno@clisp.org>

	Document libjson-c version needed with MSVC.
	* DEPENDENCIES (libjson-c): Add note regarding MSVC.

2026-01-08  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix compilation error on platforms without working iconv.
	* libtextstyle/gnulib-local/lib/iconv-ostream.oo.c (iconv_ostream::flush): Add
	second parameter.

2026-01-07  Bruno Haible  <bruno@clisp.org>

	build: Fix build failure in VPATH builds outside of the source tree.
	* build-aux/jar-cf: Unset CDPATH. Run 'git log' from $top_srcdir, not from the
	current directory.

2026-01-02  Bruno Haible  <bruno@clisp.org>

	po-mode: Tweak.
	* gettext-tools/emacs/po-mode.el: Require Emacs >= 23, like before.
	(po-mode-version-string): Bump to 2.32.

2026-01-02  gemmaro  <gemmaro.dev@gmail.com>

	po-mode: Add po-subedit-mode-hook.
	Reported by <KAction@gnu.org> at
	<https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=890295>.

	* gettext-tools/emacs/po-mode.el (po-subedit-mode-hook): Add the
	customize variable.

2026-01-02  gemmaro  <gemmaro.dev@gmail.com>

	po-mode: Use define-derived-mode for po-subedit-mode.
	* gettext-tools/emacs/po-mode.el (po-subedit-mode): Define as derived
	mode from text mode using define-derived-mode.
	(po-subedit-mode-syntax-table, po-mode-abbrev-table): Remove these
	variables, as define-derived-mode creates them automatically.
	(po-edit-string): Use po-subedit-mode instead of text-mode.  Remove
	local abbrev table, keymap, syntax table, and hook invocation, since
	define-derived-mode handles these automatically.  Move easy-menu
	definition to the define-derived-mode body.
	(Package-Requires): Add minimum Emacs version requirement. The
	define-derived-mode was probably introduced in Emacs 19.23, and commit
	7797a29e9 dropped support for Emacs versions before 23.

2025-12-31  Collin Funk  <collin.funk1@gmail.com>

	msgfmt: Don't overflow the stack with large values for --alignment.
	Reported by <maxtodeath@gmail.com> at <https://savannah.gnu.org/bugs/?67743>.

	* gettext-tools/src/write-mo.c (write_table): Use xmalloca instead of
	alloca to allocate the buffer to fill with NUL bytes.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	doc: Mention the issue of LLM licenses.
	* gettext-tools/doc/gettext.texi (Installing an LLM): Discuss LLM license and
	size.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	po-fetch: Clarify the directory.
	Reported by Simon Josefsson in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-12/msg00030.html>.

	* gettext-tools/misc/po-fetch.in (func_usage): Mention the output files
	location.
	* gettext-tools/doc/po-fetch.texi: Likewise.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	Document the relation between fetch-po and version control.
	Reported by Simon Josefsson in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-12/msg00030.html>.

	* gettext-tools/doc/gettext.texi (po/fetch-po): Add a reference.
	(Translations under Version Control): Remove subsection.
	(PO Template File under Version Control?): New subsection.
	(Translations under Version Control?): New subsection.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	build: Avoid link error on native Windows with --enable-shared.
	Reported by Michele Locati <michele@locati.it> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-12/msg00038.html>.

	* gettext-tools/src/country-table.h (country_table, country_table_size): Remove
	LIBGETTEXTSRC_DLL_VARIABLE annotation.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	po-fetch: Add man page.
	Reported by Simon Josefsson in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-12/msg00030.html>.

	* gettext-tools/man/po-fetch.x: New file.
	* gettext-tools/man/po-fetch.1.diff: New file.
	* gettext-tools/man/Makefile.am (man_aux): Add po-fetch.x.
	(man_MAN1MISC): New variable.
	(man_MAN1): Include it.
	(man_HTML): Add po-fetch.1.html.
	($(man_MAN1MISC)): New rule.
	(po-fetch.1, po-fetch.1.html): State dependencies.
	* PACKAGING: Update.

2025-12-31  Bruno Haible  <bruno@clisp.org>

	build: Fix generation of man pages on native Windows.
	* gettext-tools/man/Makefile.am ($(man_MAN1WIZARD), $(man_MAN1AUTOTOOLS)): Write
	$${progname}, not $${progname}$(EXEEXT).

2025-12-30  Bruno Haible  <bruno@clisp.org>

	build: Reject libjson-c versions older than 0.13.
	Reported by Michele Locati <michele@locati.it> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-12/msg00036.html>.

	* DEPENDENCIES: Require libjson-c >= 0.13.
	* gettext-tools/configure.ac (LIBJSON_C): Reject libjson-c versions older than
	0.13.

2025-12-30  Bruno Haible  <bruno@clisp.org>

	Fix "make dist" error when BUILT_SPIT_IN_C is false.
	* gettext-tools/src/Makefile.am (noinst_SCRIPTS): Add 'spit'.
	(spit): New rule.
	(BUILT_SOURCES, MOSTLYCLEANFILES): Add it.

2025-12-29  Bruno Haible  <bruno@clisp.org>

	Start preparing for 1.0 release.
	* gettext-runtime/m4/gettext.m4: Bump version.

2025-12-29  Bruno Haible  <bruno@clisp.org>

	New program 'msgpre'.
	* gettext-tools/src/msgpre.c: New file, based on gettext-tools/src/msgfilter.c.
	* gettext-tools/src/FILES: Describe msgpre.c.
	* gettext-tools/src/Makefile.am (bin_PROGRAMS): Add msgpre.
	(msgpre_SOURCES, msgpre_LDADD, msgpre_DEPENDENCIES, msgpre_CPPFLAGS,
	msgpre_LDFLAGS): New variables.
	* gettext-tools/po/POTFILES.in: Add msgpre.c.
	* gettext-tools/man/msgpre.x: New file.
	* gettext-tools/man/Makefile.am (man_aux): Add msgpre.x.
	(man_MAN1SRC): Add msgpre.1.
	(man_HTML): Add msgpre.1.html.
	(msgpre.1, msgpre.1.html): Add dependencies.
	* gettext-tools/doc/gettext.texi (msgpre Invocation): New section.
	* gettext-tools/doc/msgpre.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/Makefile.am (programs-for-distdir): Create msgpre.
	(distdir1, gen-man1): Update for the msgpre.1 manual page.
	* NEWS: Mention the new program.

2025-12-28  Bruno Haible  <bruno@clisp.org>

	Whitespace tweaks.
	* gettext-tools/src/msgfilter.c: Fix indentation.
	* gettext-tools/src/*.c: GNU coding style.
	* gettext-tools/tests/*.c: Likewise.

2025-12-28  Bruno Haible  <bruno@clisp.org>

	New program 'spit'.
	* gettext-tools/machine-translation/README: New file.
	* gettext-tools/machine-translation/prototype/README: New file.
	* gettext-tools/machine-translation/prototype/OllamaSpit.java: New file.
	* gettext-tools/machine-translation/prototype/ollama-spit.c: New file.
	* gettext-tools/machine-translation/prototype/ollama-spit.go: New file.
	* gettext-tools/machine-translation/prototype/ollama-spit.py: New file.
	* gettext-tools/machine-translation/prototype/ollama-spit.sh: New file.
	* gettext-tools/configure.ac (INCJSON_C, LIBJSON_C, INCCURL, LIBCURL): New
	variables.
	(BUILD_SPIT_IN_C): New conditional.
	(AC_CONFIG_FILES): Add src/spit.py.
	* gettext-tools/src/country-table.h: New file.
	* gettext-tools/src/country-table.c: New file.
	* gettext-tools/src/spit.c: New file.
	* gettext-tools/src/spit.py.in: New file.
	* gettext-tools/src/FILES: Mention the new files.
	* gettext-tools/src/Makefile.am (bin_PROGRAMS): Conditionally add 'spit'.
	(noinst_SCRIPTS): New variable.
	(noinst_HEADERS): Add country-table.h.
	(spit_SOURCES, spit_CFLAGS, spit_LDADD, spit_DEPENDENCIES, spit_CPPFLAGS,
	spit_LDFLAGS): New variables.
	(install-exec-local): Conditionally install spit.py.
	(installdirs-local, uninstall-local): Update accordingly.
	(DISTCLEANFILES): Add spit.py.
	* gettext-tools/po/POTFILES.in: Add spit.c.
	* gettext-tools/man/spit.x: New file.
	* gettext-tools/man/Makefile.am (man_aux): Add spit.x.
	(man_MAN1SRC): Add spit.1.
	(man_HTML): Add spit.1.html.
	(spit.1, spit.1.html): Add dependencies.
	* gettext-tools/doc/gettext.texi (Pretranslating): New chapter.
	* gettext-tools/doc/spit.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* DEPENDENCIES: Update URLs for libxml2. Add libjson-c, libcurl, Python, the
	Python module 'requests'.
	* PACKAGING: Mention the 'spit' program and its manual page.
	* NEWS: Mention the change.

2025-12-26  Bruno Haible  <bruno@clisp.org>

	Update ISO 3166 country codes list.
	* gettext-tools/doc/ISO_3166: Update to match current Wikipedia.
	* gettext-tools/doc/iso-3166.texi: Likewise.
	* gettext-tools/src/msginit.c (catalogname_for_locale): Likewise.

2025-12-22  Bruno Haible  <bruno@clisp.org>

	Fix compilation error with MSVC 14 (regression 2025-12-19).
	* gettext-tools/src/msgl-merge.c (match_domain): Move variable declaration out
	of an OpenMP 'for' loop. Reduce scope of local variables.

2025-12-22  Bruno Haible  <bruno@clisp.org>

	Fix compilation errors with older C compilers (regression 2025-12-19).
	* gnulib-local/lib/xerror.c (multiline_internal): Add a semicolon between
	a label and a declaration.
	* gettext-tools/src/write-po.c (wrap): Likewise.
	* gettext-tools/src/format-go.c (format_parse): Likewise.

2025-12-19  Bruno Haible  <bruno@clisp.org>

	Simplify code.
	* gettext-tools/src/its.c (_its_encode_special_chars,
	_its_encode_special_chars_for_merge): Remove unnecessary memory store.

2025-12-19  Bruno Haible  <bruno@clisp.org>

	Update file list.
	* gettext-tools/src/FILES: Update.

2025-12-19  Bruno Haible  <bruno@clisp.org>

	Modernize coding style: Reduce scope of local variables.
	* HACKING (Coding Style): New section, copied from gnulib/HACKING.
	* gettext-runtime/src/envsubst.c: Reduce scope of local variables.
	* gettext-runtime/src/escapes.h: Likewise.
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-runtime/src/printf-command.c: Likewise.
	* gettext-runtime/src/printf_gettext.c: Likewise.
	* gettext-runtime/src/printf_ngettext.c: Likewise.
	* gnulib-local/lib/addext.c: Likewise.
	* gnulib-local/lib/backupfile.c: Likewise.
	* gnulib-local/lib/gettext.h: Likewise.
	* gnulib-local/lib/markup.c: Likewise.
	* gnulib-local/lib/xerror.c: Likewise.
	* libtextstyle/gnulib-local/lib/file-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/html-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/html-styled-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/iconv-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/memory-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/noop-styled-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c: Likewise.
	* libtextstyle/gnulib-local/lib/term-styled-ostream.oo.c: Likewise.
	* libtextstyle/lib/color.c: Likewise.
	* libtextstyle/lib/misc.c: Likewise.
	* gettext-tools/src/cldr-plural-exp.c: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/file-list.c: Likewise.
	* gettext-tools/src/filter-quote.c: Likewise.
	* gettext-tools/src/format-awk.c: Likewise.
	* gettext-tools/src/format-boost.c: Likewise.
	* gettext-tools/src/format-c++-brace.c: Likewise.
	* gettext-tools/src/format-c.c: Likewise.
	* gettext-tools/src/format-c-parse.h: Likewise.
	* gettext-tools/src/format-csharp.c: Likewise.
	* gettext-tools/src/format-d.c: Likewise.
	* gettext-tools/src/format-elisp.c: Likewise.
	* gettext-tools/src/format-gcc-internal.c: Likewise.
	* gettext-tools/src/format-gfc-internal.c: Likewise.
	* gettext-tools/src/format-go.c: Likewise.
	* gettext-tools/src/format-java-printf.c: Likewise.
	* gettext-tools/src/format-java.c: Likewise.
	* gettext-tools/src/format-javascript.c: Likewise.
	* gettext-tools/src/format-kde-kuit.c: Likewise.
	* gettext-tools/src/format-kde.c: Likewise.
	* gettext-tools/src/format-librep.c: Likewise.
	* gettext-tools/src/format-lisp.c: Likewise.
	* gettext-tools/src/format-lua.c: Likewise.
	* gettext-tools/src/format-modula2.c: Likewise.
	* gettext-tools/src/format-ocaml.c: Likewise.
	* gettext-tools/src/format-pascal.c: Likewise.
	* gettext-tools/src/format-perl-brace.c: Likewise.
	* gettext-tools/src/format-perl.c: Likewise.
	* gettext-tools/src/format-php.c: Likewise.
	* gettext-tools/src/format-python-brace.c: Likewise.
	* gettext-tools/src/format-python.c: Likewise.
	* gettext-tools/src/format-qt-plural.c: Likewise.
	* gettext-tools/src/format-qt.c: Likewise.
	* gettext-tools/src/format-ruby.c: Likewise.
	* gettext-tools/src/format-rust.c: Likewise.
	* gettext-tools/src/format-scheme.c: Likewise.
	* gettext-tools/src/format-sh-printf.c: Likewise.
	* gettext-tools/src/format-sh.c: Likewise.
	* gettext-tools/src/format-smalltalk.c: Likewise.
	* gettext-tools/src/format-tcl.c: Likewise.
	* gettext-tools/src/format.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/if-error.c: Likewise.
	* gettext-tools/src/its.c: Likewise.
	* gettext-tools/src/locating-rules.c: Likewise.
	* gettext-tools/src/message.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgl-ascii.c: Likewise.
	* gettext-tools/src/msgl-cat.c: Likewise.
	* gettext-tools/src/msgl-charset.c: Likewise.
	* gettext-tools/src/msgl-check.c: Likewise.
	* gettext-tools/src/msgl-english.c: Likewise.
	* gettext-tools/src/msgl-equal.c: Likewise.
	* gettext-tools/src/msgl-fsearch.c: Likewise.
	* gettext-tools/src/msgl-header.c: Likewise.
	* gettext-tools/src/msgl-iconv.c: Likewise.
	* gettext-tools/src/msgl-merge.c: Likewise.
	* gettext-tools/src/msgl-ofn.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/open-catalog.c: Likewise.
	* gettext-tools/src/plural-count.c: Likewise.
	* gettext-tools/src/po-charset.c: Likewise.
	* gettext-tools/src/po-time.c: Likewise.
	* gettext-tools/src/read-catalog.c: Likewise.
	* gettext-tools/src/read-catalog-abstract.c: Likewise.
	* gettext-tools/src/read-catalog-file.c: Likewise.
	* gettext-tools/src/read-catalog-special.c: Likewise.
	* gettext-tools/src/read-csharp.c: Likewise.
	* gettext-tools/src/read-desktop.c: Likewise.
	* gettext-tools/src/read-java.c: Likewise.
	* gettext-tools/src/read-mo.c: Likewise.
	* gettext-tools/src/read-po-lex.c: Likewise.
	* gettext-tools/src/read-properties.c: Likewise.
	* gettext-tools/src/read-resources.c: Likewise.
	* gettext-tools/src/read-stringtable.c: Likewise.
	* gettext-tools/src/read-tcl.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/search-path.c: Likewise.
	* gettext-tools/src/str-list.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/write-catalog.c: Likewise.
	* gettext-tools/src/write-csharp.c: Likewise.
	* gettext-tools/src/write-desktop.c: Likewise.
	* gettext-tools/src/write-java.c: Likewise.
	* gettext-tools/src/write-mo.c: Likewise.
	* gettext-tools/src/write-po.c: Likewise.
	* gettext-tools/src/write-properties.c: Likewise.
	* gettext-tools/src/write-qt.c: Likewise.
	* gettext-tools/src/write-resources.c: Likewise.
	* gettext-tools/src/write-stringtable.c: Likewise.
	* gettext-tools/src/write-tcl.c: Likewise.
	* gettext-tools/src/write-xml.c: Likewise.
	* gettext-tools/src/x-awk.c: Likewise.
	* gettext-tools/src/x-c.c: Likewise.
	* gettext-tools/src/x-csharp.c: Likewise.
	* gettext-tools/src/x-d.c: Likewise.
	* gettext-tools/src/x-desktop.c: Likewise.
	* gettext-tools/src/x-elisp.c: Likewise.
	* gettext-tools/src/x-go.c: Likewise.
	* gettext-tools/src/x-java.c: Likewise.
	* gettext-tools/src/x-javascript.c: Likewise.
	* gettext-tools/src/x-librep.c: Likewise.
	* gettext-tools/src/x-lisp.c: Likewise.
	* gettext-tools/src/x-lua.c: Likewise.
	* gettext-tools/src/x-modula2.c: Likewise.
	* gettext-tools/src/x-ocaml.c: Likewise.
	* gettext-tools/src/x-perl.c: Likewise.
	* gettext-tools/src/x-php.c: Likewise.
	* gettext-tools/src/x-po.c: Likewise.
	* gettext-tools/src/x-python.c: Likewise.
	* gettext-tools/src/x-rst.c: Likewise.
	* gettext-tools/src/x-ruby.c: Likewise.
	* gettext-tools/src/x-rust.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-sh.c: Likewise.
	* gettext-tools/src/x-smalltalk.c: Likewise.
	* gettext-tools/src/x-tcl.c: Likewise.
	* gettext-tools/src/x-typescript-impl.h: Likewise.
	* gettext-tools/src/x-vala.c: Likewise.
	* gettext-tools/src/x-ycp.c: Likewise.
	* gettext-tools/src/xerror-handler.c: Likewise.
	* gettext-tools/src/xg-arglist-callshape.c: Likewise.
	* gettext-tools/src/xg-arglist-context.c: Likewise.
	* gettext-tools/src/xg-arglist-parser.c: Likewise.
	* gettext-tools/src/xg-check.c: Likewise.
	* gettext-tools/src/xg-encoding.c: Likewise.
	* gettext-tools/src/xg-message.c: Likewise.
	* gettext-tools/src/xg-mixed-string.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.

2025-12-12  Bruno Haible  <bruno@clisp.org>

	xgettext: Optimize vc-mtime usage.
	* gettext-tools/src/xgettext.c (extract_from_xml_file): Don't augment
	files_for_vc_mtime twice.

2025-12-12  Bruno Haible  <bruno@clisp.org>

	Modernize coding style: Avoid 'goto' statements where possible.
	* gettext-tools/src/msgfmt.c (get_languages): Use if/else instead of 'goto'.

2025-12-12  Bruno Haible  <bruno@clisp.org>

	Modernize coding style: Avoid 'continue;' statements where possible.
	* gnulib-local/lib/backupfile.c (max_backup_version): Use if/else instead of
	'continue;'.
	* gnulib-local/lib/markup.c (emit_start_element): Likewise.

2025-12-11  Bruno Haible  <bruno@clisp.org>

	Modernize coding style: Avoid 'continue;' statements where possible.
	* gettext-tools/src/cldr-plurals.c (extract_rules): Use if/else instead of
	'continue;'.
	* gettext-tools/src/msgfmt.c (msgfmt_operand_list_add_from_directory): Likewise.
	* gettext-tools/src/read-po-lex.c (po_gram_lex): Likewise.
	* gettext-tools/src/sentence.c (sentence_end): Likewise.
	* gettext-tools/src/x-awk.c (extract_parenthesized): Use 'break;' instead of
	'continue;'.
	* gettext-tools/src/x-c.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-csharp.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-java.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-javascript.c (extract_balanced): Likewise.
	* gettext-tools/src/x-lua.c (extract_balanced): Likewise.
	* gettext-tools/src/x-modula2.c (extract_parenthesized): Likewise.
	* gettext-tools/src/x-php.c (extract_balanced): Likewise.
	* gettext-tools/src/x-python.c (extract_balanced): Likewise.
	* gettext-tools/src/x-vala.c (extract_balanced): Likewise.
	* gettext-tools/src/x-ycp.c (extract_parenthesized): Likewise.

2025-12-01  Bruno Haible  <bruno@clisp.org>

	tests: Remove a left-over debugging trace.
	* gettext-tools/tests/xgettext-20: Remove a 'set -x' statement.

2025-11-11  Bruno Haible  <bruno@clisp.org>

	libasprintf: Document need to use g++ option -Wall.
	* gettext-runtime/libasprintf/autosprintf.texi (Using autosprintf): Expand text.
	(Source code changes, Build system changes): New nodes.

2025-11-05  Bruno Haible  <bruno@clisp.org>

	autopoint: Diagnose multiple invocations of AM_GNU_GETTEXT_VERSION.
	Reported by Santiago Vila in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-11/msg00001.html>.

	* gettext-tools/autotools/autopoint.in: Report an error if "$xreq" or "$xver"
	consists of more than one line.

2025-10-24  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.
	* gettext-runtime/po/*.po: Update from TP.
	* gettext-tools/po/*.po: Update from TP.
	* gettext-tools/examples/po/*.po: Update from TP.

2025-10-24  Bruno Haible  <bruno@clisp.org>

	build: Add scripts for fetching the PO files.
	* gettext-runtime/po/fetch-po: New file.
	* gettext-tools/po/fetch-po: New file.
	* gettext-tools/examples/po/fetch-po: New file.
	* check-copyright-headers (func_check_file): Don't complain about the LINGUAS
	files, that will now have more than 10 lines.

2025-10-24  Bruno Haible  <bruno@clisp.org>

	po: Add customizable 'fetch-po' script.
	* gettext-tools/wizard/po-templates/traditional/fetch-po: New file.
	* gettext-tools/wizard/Makefile.am (po_SCRIPTS): New variable.
	(EXTRA_DIST): Add the po_SCRIPTS.
	* gettext-tools/wizard/gettextize.in: Copy but don't overwrite po/fetch-po.
	* gettext-tools/wizard/po-templates/traditional/Makefile.in.in (fetch-po): New
	target.
	* gettext-tools/examples/po/Makefile.am (fetch-po): New target.
	* gettext-tools/examples/hello-*/po/Makefile.am (fetch-po): New target.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile (fetch-po): New
	target.
	* gettext-tools/doc/gettext.texi (po/fetch-po): New subsection.
	(po/LINGUAS): Explain how it related to the 'fetch-po' script.
	(Release Management): Document how to fetch the PO files before a release.
	* NEWS: Mention the change.

2025-10-21  Bruno Haible  <bruno@clisp.org>

	New program 'po-fetch'.
	* gettext-tools/misc/po-fetch.in: New file.
	* gettext-tools/misc/Makefile.am: New file.
	* gettext-tools/configure.ac: Add AC_CONFIG_FILES invocations for the misc/
	directory.
	* gettext-tools/Makefile.am (SUBDIRS): Add misc.
	(EXTRA_DIST): Remove misc/disclaim-translations.txt.
	(pkgdata_DATA): Remove variable.
	* gettext-tools/doc/po-fetch.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (po-fetch): Add global menu entry.
	(po-fetch Invocation): New section.
	* PACKAGING: Mention the installed 'po-fetch' program.
	* NEWS: Mention 'po-fetch'.

2025-10-19  Bruno Haible  <bruno@clisp.org>

	build: Remove duplicate file from version control.
	* gettext-tools/examples/po/remove-potcdate.sed: Remove file.
	* autogen.sh: Copy remove-potcdate.sed to
	gettext-tools/examples/po/remove-potcdate.sed.

2025-10-19  Bruno Haible  <bruno@clisp.org>

	build: Distribute one more file.
	* gettext-runtime/install-tests/Makefile.am (EXTRA_DIST): Add itest.pot.

2025-10-19  Bruno Haible  <bruno@clisp.org>

	build: Distribute all tree-sitter patches.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add
	build-aux/tree-sitter-d-optimization-bug.diff, added on 2025-05-03.

2025-10-18  Bruno Haible  <bruno@clisp.org>

	New directory gettext-tools/wizard/po-templates/traditional/.
	* gettext-tools/wizard/po-templates/traditional/*: New files, moved here from
	gettext-runtime/po/.
	* gettext-tools/wizard/po-templates/traditional/Makefile.in.in (install-data,
	installdirs-data, uninstall-data, dist2): Remove special code for the
	'gettext-tools' package.
	* gettext-tools/wizard/po-templates/traditional/Makevars.template: Moved here
	from gettext-tools/po/.
	* autogen.sh: Copy the contents of the gettext-runtime/po/ and gettext-tools/po/
	directories from gettext-tools/wizard/po-templates/traditional/.
	* gettext-tools/wizard/Makefile.am (pkgdatadir, podir): New variables.
	(po_DATA): Add po-templates/traditional/*.
	(EXTRA_DIST): Likewise.
	(uninstall-sources): Also remove $(podir)/Makevars.
	* Makefile.am (distcheck-hook): Update.

2025-10-17  Bruno Haible  <bruno@clisp.org>

	doc: Mention how to localize other data formats.
	* gettext-tools/doc/gettext.texi (Data Formats): Mention po4a. Describe how to
	localize LibreOffice documents.

2025-10-14  Bruno Haible  <bruno@clisp.org>

	po: Don't msgmerge the PO files through Makefile.in.in.
	* gettext-runtime/po/Makefile.in.in (MSGMERGE_UPDATE): Remove variable.
	(UPDATEPOFILES): Remove variable.
	(POFILESDEPS*): Remove variables.
	(.SUFFIXES): Add '.gpo'. Remove '.po-update'.
	(.po.gpo): New rule.
	($(POFILES)): Remove dependencies. Don't invoke MSGMERGE_UPDATE.
	(mostlyclean): Add *.gpo.
	(update-po): Don't make $(UPDATEPOFILES).
	(.nop.po-update): Remove rule.
	* gettext-runtime/po/Makevars (PO_DEPENDS_ON_POT): Remove variable.
	* gettext-tools/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/po/Makevars.template (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-c/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-c-gnome2/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-c-gnome3/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-c-http/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-c++/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-c++20/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-c++-gnome2/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-c++-gnome3/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-c++-kde/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-objc/po/Makevars (PO_DEPENDS_ON_POT): Likewise.
	* gettext-tools/examples/hello-objc-gnome2/po/Makevars (PO_DEPENDS_ON_POT):
	Likewise.
	* gettext-tools/examples/hello-c++-wxwidgets/po/Makefile.am (MSGMERGE_UPDATE):
	Remove variable.
	(UPDATEPOFILES): Remove variable.
	(.SUFFIXES): Add '.gpo'. Remove '.po-update'.
	(.po.gpo): New rule.
	($(POFILES)): Remove dependencies. Don't invoke MSGMERGE_UPDATE.
	(MOSTLYCLEANFILES): Add *.gpo.
	(update-po): Don't make $(UPDATEPOFILES).
	(.nop.po-update): Remove rule.
	* gettext-tools/examples/hello-python/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-guile/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-clisp/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-librep/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-rust/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-go/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-go-http/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-ruby/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-sh/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-gawk/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-pascal/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-modula2/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-d/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-ocaml/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-smalltalk/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-perl/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-php/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-ycp/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-c++-qt/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-java/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-java-awt/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-java-swing/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-java-qtjambi/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-csharp/po/Makefile.am (MSGMERGE_UPDATE): Remove
	variable.
	(UPDATEPOFILES): Remove variable.
	(RESOURCESDLLFILES): Change emitted commands to use an intermediate .gpo file.
	(.SUFFIXES): Add '.gpo'. Remove '.po-update'.
	(.po.gpo): New rule.
	($(POFILES)): Remove dependencies. Don't invoke MSGMERGE_UPDATE.
	(MOSTLYCLEANFILES): Add *.gpo.
	(update-po): Don't make $(UPDATEPOFILES).
	(.nop.po-update): Remove rule.
	* gettext-tools/examples/hello-csharp-forms/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-tcl/po/Makefile.am (MSGMERGE_UPDATE): Remove
	variable.
	(UPDATEPOFILES): Remove variable.
	(MSGFILES): Change emitted commands to use an intermediate .gpo file.
	(.SUFFIXES): Add '.gpo'. Remove '.po-update'.
	(.po.gpo): New rule.
	($(POFILES)): Remove dependencies. Don't invoke MSGMERGE_UPDATE.
	(MOSTLYCLEANFILES): Add *.gpo.
	(update-po): Don't make $(UPDATEPOFILES).
	(.nop.po-update): Remove rule.
	* gettext-tools/examples/hello-tcl-tk/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile (MSGMERGE_UPDATE):
	Remove variable.
	(UPDATEPOFILES): Remove variable.
	(.SUFFIXES): Add '.gpo'. Remove '.po-update'.
	($(POFILES)): Remove dependencies. Don't invoke MSGMERGE_UPDATE.
	(update-po): Don't make $(UPDATEPOFILES).
	(.nop.po-update): Remove rule.
	* gettext-tools/examples/po/Makefile.am (MSGMERGE_OPTIONS): Add
	--no-fuzzy-matching --quiet.
	(MSGMERGE_UPDATE): Remove variable.
	(UPDATEPOFILES): Remove variable.
	(GPOFILES): New variable.
	(.SUFFIXES): Add '.gpo'. Remove '.nop', '.po-update'.
	(.po.gpo): New rule.
	($(POFILES)): Remove rule.
	(DISTCLEANFILES): New variable.
	(update-po): Don't make $(UPDATEPOFILES). Make the small PO files.
	(.nop.po-update): Remove rule.
	* gettext-tools/examples/po/mmsmallpo.sh: Use $language.gpo instead of
	$language.po.
	* gettext-tools/doc/gettext.texi (Translations under Version Control): Remove
	documentation of PO_DEPENDS_ON_POT.
	(Release Management): Update wording.
	* Admin/release-steps: Don't msgmerge the PO files from translationproject.org.
	* NEWS: Mention the change.

2025-10-13  Bruno Haible  <bruno@clisp.org>

	examples: Fix hello-tcl* examples (regression 2024-12-06).
	* gettext-tools/examples/hello-tcl*/po/Makefile.am (CATALOGS): Use suffix .msg,
	not .gmo.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	check-examples: Update comments.
	* gettext-tools/examples/check-examples: Update comments.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	examples: Improve error message when there is a mistake in a PO file.
	* gettext-tools/examples/hello-*/po/Makefile.am (.po.gmo): Use suffix .gpo
	instead of .1po.
	* gettext-tools/examples/hello-java*/po/Makefile.am (update-properties,
	update-classes): Likewise.
	* gettext-tools/examples/hello-c++-qt/po/Makefile.am (.po.qm): Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile ($(STRINGSFILES)):
	Likewise.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Recognize 'gettextrs::gettext' invocations like 'gettext' invocations.
	Reported by Schmiddiii <gnu-savannah@schmidhuberj.de>
	at <https://savannah.gnu.org/bugs/?67601>.

	* gettext-tools/src/x-rust.c (ts_symbol_scoped_identifier): New variable.
	(extract_from_function_call): Accept a scoped_identifier as first argument.
	(extract_from_node): Allow a scoped_identifier as callee.
	(extract_rust): Initialize ts_symbol_scoped_identifier.
	* gettext-tools/tests/xgettext-rust-1: Add another test case.
	* gettext-tools/tests/xgettext-rust-6: Likewise.
	* NEWS: Mention the fix.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	po: Improve error message when there is a mistake in a PO file.
	* gettext-runtime/po/Makefile.in.in (.po.gmo): Use suffix .gpo instead of .1po.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	po: Simplify.
	* gettext-runtime/po/Makefile.in.in (.NOEXPORT): Remove workaround for versions
	of GNU make from before 1993.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	build: Move more code into libgettextsrc.
	* gettext-tools/src/lang-table.h (language_table, language_table_size,
	language_variant_table, language_variant_table_size): Mark as
	LIBGETTEXTSRC_DLL_VARIABLE.
	* gettext-tools/src/Makefile.am (libgettextsrc_la_SOURCES): Add msgl-fsearch.c,
	lang-table.c, plural-count.c.
	(msgmerge_SOURCES): Remove msgl-fsearch.c, lang-table.c, plural-count.c.
	(msginit_SOURCES): Likewise.
	* gettext-tools/src/FILES: Update.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	msginit: Produce a merged PO file instead of failing.
	* gettext-tools/src/msginit.c: Include <omp.h>, msgl-merge.h, backupfile.h,
	copy-file.h.
	(catalogname): Remove variable.
	(main): When the PO file already exists, create a backup file, then merge the
	two files.
	(usage): Say what happens if the output file already exists.
	(struct header_entry_field): New type.
	(fresh_fields): Renamed from fields.
	(NFIELDS): Remove macro.
	(FRESH_FIELDS_LAST_TRANSLATOR): Renamed from FIELD_LAST_TRANSLATOR.
	(update_fields): New variable.
	(UPDATE_FIELDS_LAST_TRANSLATOR): New macro.
	(fill_header): Add 'fresh' parameter. Allocate field_value array on the heap.
	* gettext-tools/src/Makefile.am (msginit_SOURCES): Add msgl-fsearch.c,
	msgl-merge.c.
	(msginit_CFLAGS, msginit_CXXFLAGS): Link with the OpenMP flags.
	* gettext-tools/doc/msginit.texi: Say what happens if the output file already
	exists.
	* gettext-tools/doc/gettext.texi (Creating): Change title. Mention that msginit
	can also be used when continuing an existing translation.
	* NEWS: Mention the improvement.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	Refactor: Librarify the core of msgmerge.
	* gettext-tools/src/msgl-merge.h: New file, based on
	gettext-tools/src/msgmerge.c.
	* gettext-tools/src/msgl-merge.c: New file, based on
	gettext-tools/src/msgmerge.c.
	* gettext-tools/src/msgmerge.c: Include msgl-merge.h. Simplify includes.
	Remove definitions that are moved to msgl-merge.c.
	* gettext-tools/src/FILES: Update.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add msgl-merge.h.
	(msgmerge_SOURCES): Add msgl-merge.c.
	* gettext-tools/po/POTFILES.in: Add src/msgl-merge.c.

2025-10-12  Bruno Haible  <bruno@clisp.org>

	OCaml: Tweak documentation.
	* gettext-tools/doc/lang-ocaml.texi: Add note regarding format strings.

2025-10-07  Bruno Haible  <bruno@clisp.org>

	Fix failure of lang-javascript on macOS 15.

2025-10-05  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

2025-10-05  Bruno Haible  <bruno@clisp.org>

	Refactor: New subdirectory gettext-tools/wizard/, part 2.

2025-10-05  Bruno Haible  <bruno@clisp.org>

	Refactor: New subdirectory gettext-tools/autotools/.
	* gettext-tools/Makefile.am (SUBDIRS): Add autotools. Remove misc.
	(distdir2): Update.
	* gettext-tools/autotools/Makefile.am: Renamed from
	gettext-tools/misc/Makefile.am.
	* gettext-tools/autotools/archive.dir.tar: Renamed from
	gettext-tools/misc/archive.dir.tar.
	* gettext-tools/autotools/add-to-archive: Renamed from
	gettext-tools/misc/add-to-archive.
	* gettext-tools/autotools/cvsuser.c: Renamed from gettext-tools/misc/cvsuser.c.
	* gettext-tools/autotools/convert-archive.in: Renamed from
	gettext-tools/misc/convert-archive.in.
	* gettext-tools/autotools/autopoint.in: Renamed from
	gettext-tools/misc/autopoint.in.
	* gettext-tools/configure.ac: Update AC_CONFIG_FILES invocations.
	* gettext-tools/man/Makefile.am (man_MAN1AUTOTOOLS): Renamed from man_MAN1MISC.
	($(man_MAN1AUTOTOOLS)): Renamed from $(man_MAN1MISC).
	(autopoint.1): Update.
	* gettext-tools/examples/po/Makefile.am (USE_BUILT_PROGS): Update.
	* gettext-tools/tests/autopoint-1: Update.
	* gettext-tools/tests/autopoint-2: Likewise.
	* gettext-tools/tests/autopoint-3: Likewise.
	* check-copyright-headers (func_check_file): Update.

2025-10-05  Bruno Haible  <bruno@clisp.org>

	Put archive.dir.tar under version control, part 2.
	* gettext-tools/misc/Makefile.am ($(srcdir)/archive.dir.tar): Remove rule.

2025-10-05  Bruno Haible  <bruno@clisp.org>

	Refactor: New subdirectory gettext-tools/wizard/.
	* gettext-tools/configure.ac: Invoke AC_CONFIG_FILES for wizard/Makefile,
	wizard/gettextize, instead of for misc/gettextize.
	* gettext-tools/Makefile.am (SUBDIRS): Add wizard.
	(distdir2): Recurse into wizard/.
	* gettext-tools/wizard/Makefile.am: New file, based on
	gettext-tools/misc/Makefile.am.
	* gettext-tools/wizard/gettextize.in: Renamed from
	gettext-tools/misc/gettextize.in.
	* gettext-tools/misc/Makefile.am (bin_SCRIPTS, DISTCLEANFILES): Remove
	gettextize.
	(install-data-local, uninstall-local, uninstall-sources): Remove rules.
	* gettext-tools/man/Makefile.am (man_MAN1WIZARD): New variable.
	(man_MAN1MISC): Remove gettextize.1.
	($(man_MAN1WIZARD)): New rule.
	(gettextize.1): Update.
	($(man_MAN1MISC)): Simplify.

2025-10-02  Bruno Haible  <bruno@clisp.org>

	Restore syntax highlighting in Emacs 30 or newer.
	Reported by Sab Pyrope <sab.pyrope@gmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-03/msg00017.html>
	and by Julien Palard <julien@palard.fr> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-10/msg00000.html>.

	It's a regression in Emacs 30, in commit
	17e26cf57e18c5df2172a7049591d89fc53b3fb6 .

	* gettext-tools/emacs/HACKING: Document how to bisect Emacs regressions.
	* gettext-tools/emacs/po-mode.el (po-mode-version-string): Bump to 2.31.
	(po-mode): Invoke run-mode-hooks instead of run-hooks.
	* NEWS: Mention the fix.

2025-10-01  Bruno Haible  <bruno@clisp.org>

	xgettext: Java: Remove unjustified warning "'}' found where ')' was expected".
	Reported by Alexander Hubmann-Haidvogel <ahubmann@gmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-09/msg00000.html>
	and by Bjoern Voigt <bjoernv@arcor.de> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-09/msg00023.html>.

	* gettext-tools/src/x-java.c (extract_parenthesized): When a semicolon is seen
	inside braces, start a new argparser instead of returning.
	* gettext-tools/tests/xgettext-java-1: Add test cases with inner classes.

2025-09-30  Bruno Haible  <bruno@clisp.org>

	tests: Increase debuggability.
	* gettext-tools/tests/xgettext-python-9: Show the warnings in the log when
	failing.

2025-09-30  Bruno Haible  <bruno@clisp.org>

	libgettextpo: Add API for the workflow flags and the sticky flags.
	Reported by Alexander Potashev <aspotashev@gmail.com>
	at <https://savannah.gnu.org/bugs/?67470>.

	* gettext-tools/src/message.h (format_flag, not_format_p): New declarations.
	* gettext-tools/src/message.c (format_flag): New variable.
	(not_format_p): New function.
	* gettext-tools/src/write-po.c (make_format_description_string): Add comments.
	(significant_format_p): Likewise.
	* gettext-tools/libgettextpo/gettext-po.in.h (po_flag_iterator_t): New type.
	(po_message_has_workflow_flag, po_message_set_workflow_flag,
	po_message_workflow_flags_iterator): New declarations.
	(po_message_has_sticky_flag, po_message_set_sticky_flag,
	po_message_sticky_flags_iterator): New declarations.
	(po_flag_iterator_free, po_flag_next): New declarations.
	* gettext-tools/libgettextpo/gettext-po.c (struct po_flag_iterator): New type.
	(po_message_has_workflow_flag, po_message_set_workflow_flag,
	po_message_workflow_flags_iterator): New functions.
	(po_message_get_format): Simplify by using not_format_p.
	(po_message_has_sticky_flag, po_message_set_sticky_flag,
	po_message_sticky_flags_iterator): New functions.
	(po_flag_iterator_free, po_flag_next): New functions.
	* gettext-tools/tests/gettextpo-1-prg.c (main): Add more test cases.
	* gettext-tools/doc/gettext.texi (po_message_t API): Document the new functions.
	(po_flag_iterator_t API): New subsection.
	* NEWS: Mention the new functions.

2025-09-27  Bruno Haible  <bruno@clisp.org>

	libgettextpo: New function po_message_get_format.
	Reported by Alexander Potashev <aspotashev@gmail.com> in
	<https://savannah.gnu.org/bugs/?67485>.

	* gettext-tools/libgettextpo/gettext-po.in.h (po_message_get_format): New
	declaration.
	* gettext-tools/libgettextpo/gettext-po.c (po_message_get_format): New function.
	* gettext-tools/tests/gettextpo-1-prg.c (main): Test the return value of
	po_message_get_format. Add a test case of po_message_set_format with value -1.
	* gettext-tools/doc/gettext.texi (po_message_t API): Document
	po_message_get_format.
	* NEWS: Mention the change.

2025-09-22  Bruno Haible  <bruno@clisp.org>

	Upgrade to libtool 2.6.0.
	* m4/libtool.m4: Update from libtool-2.6.0.
	* m4/ltoptions.m4: Likewise.
	* m4/ltsugar.m4: Likewise.
	* m4/ltversion.m4: Likewise.
	* m4/lt~obsolete.m4: Likewise.
	* build-aux/ltmain.sh: Likewise.

2025-09-14  Bruno Haible  <bruno@clisp.org>

	gettext.h: Avoid warning with gcc < 4.2.
	Reported by Orgad Shaneh <orgads@gmail.com> in
	<https://lists.gnu.org/archive/html/bug-gnulib/2025-09/msg00183.html>.

	* gnulib-local/lib/gettext.h (gettext, dgettext, dcgettext): Don't use attribute
	__gnu_inline__ with gcc < 4.2.

2025-09-14  Bruno Haible  <bruno@clisp.org>

	lang-javascript: Avoid failure on macOS 13..15.
	* gettext-tools/tests/lang-javascript: On macOS, test only in the UTF-8 locale.

2025-09-14  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/libgrep/gnulib-lib/Makefile.am (AM_CPPFLAGS): Add -I option,
	so that libintl.h gets found during the compilation of regex.c.

2025-09-08  Bruno Haible  <bruno@clisp.org>

	Put archive.dir.tar under version control.
	This helps reducing CI failures when alpha.gnu.org is not responding.
	It also simplifies the branch handling when a bug-fix release is made
	on the maintenance branch of an older release.

	* gettext-tools/misc/archive.dir.tar: New file.
	* autopull.sh: Don't fetch it from alpha.gnu.org any more.

2025-09-08  Bruno Haible  <bruno@clisp.org>

	build: Make CI's git hostname rewriting rules apply.
	* .gitmodules: Canonicalize savannah host name.

2025-09-04  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* libtextstyle/tests/Makefile.am (AM_CFLAGS): Initialize.
	* gettext-tools/gnulib-tests/Makefile.am (AM_CFLAGS): Initialize.

2025-09-04  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-08-24  Bruno Haible  <bruno@clisp.org>

	doc: Update table of programming languages.
	* gettext-tools/doc/gettext.texi (List of Programming Languages): Update table
	in comments.

2025-08-13  Bruno Haible  <bruno@clisp.org>

	its: Improve libxml error handling.
	When there is a non-fatal error, the previous code would just print a message
	to stderr and continue the operation, without affecting the exit code.

	* gettext-tools/src/its.c: Include <setjmp.h>, <stdarg.h>.
	(xml_error_exit): New variable.
	(structured_error): Longjmp to xml_error_exit.
	(generic_error): New function.
	(its_rule_list_add_from_file, its_rule_list_add_from_string,
	its_rule_list_extract, its_merge_context_merge, its_merge_context_alloc,
	its_merge_context_write): Invoke also xmlSetGenericErrorFunc. Use setjmp to
	abort the operation when a non-fatal error occurs.

2025-08-11  Bruno Haible  <bruno@clisp.org>

	its: Fix error handling.
	* gettext-tools/src/its.c (structured_error, its_rule_list_add_from_file,
	its_rule_list_add_from_string, its_rule_list_extract, its_merge_context_alloc):
	Swap error() arguments.

2025-08-10  Bruno Haible  <bruno@clisp.org>

	Rely more on Gnulib.
	* gettext-tools/src/write-java.c (S_*): Remove macros, relying on gnulib module
	sys_stat-h.
	* gettext-tools/src/write-csharp.c (S_*): Likewise.

2025-08-10  Bruno Haible  <bruno@clisp.org>

	Use standard way of including <config.h>.
	* gettext-runtime/src/*.c: Include <config.h> unconditionally.
	* gettext-runtime/libasprintf/lib-asprintf.h: Likewise.
	* libtextstyle/lib/color.c: Likewise.
	* gnulib-local/lib/markup.c: Likewise.
	* gettext-tools/src/*.y: Likewise.
	* gettext-tools/src/*.c: Likewise.
	* gettext-tools/libgrep/*.c: Likewise.
	* gettext-tools/libgettextpo/*.c: Likewise.
	* gettext-tools/tests/*.c: Likewise.

2025-08-05  Bruno Haible  <bruno@clisp.org>

	INSTALL: Tweak wording.
	* INSTALL: Fix a copy-and-paste mistake.

2025-08-05  Bruno Haible  <bruno@clisp.org>

	build: Make autogen.sh more reliable.
	* autogen.sh: Fail if gnulib-tool fails.

2025-08-05  Bruno Haible  <bruno@clisp.org>

	tests: Fix a lang-go failure.
	* gettext-tools/tests/lang-go: Add workaround against
	"go: GOPROXY list is not the empty string, but contains no entries" error.

2025-08-05  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/tests/Makefile.am (TESTS_ENVIRONMENT): Define top_builddir,
	consistently with Gnulib.
	* gettext-tools/tests/init-env.in (top_builddir): Remove definition here.

2025-08-05  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-08-03  Bruno Haible  <bruno@clisp.org>

	intl-java: Remove an unused variable.
	Reported by Coverity.

	* gettext-runtime/intl-java/gnu/gettext/GettextResource.java (ngettextnull):
	Remove an unused variable.

2025-08-03  Bruno Haible  <bruno@clisp.org>

	libcroco: Fix double-free and free-after-use bug.
	Reported by Coverity.

	* libtextstyle/gnulib-local/lib/libcroco/cr-sel-eng.c
	(cr_sel_eng_unregister_pseudo_class_sel_handler): Don't access or free 'elem'
	after it has been freed. Remove always-NULL variable.

2025-08-03  Bruno Haible  <bruno@clisp.org>

	intl: Fix a small memory leak.
	Reported by Coverity.

	* gettext-runtime/intl/loadmsgcat.c (_nl_load_domain): Free
	sysdep_segment_values before 'goto invalid'.

2025-08-03  Bruno Haible  <bruno@clisp.org>

	examples: Fix a compiler warning.
	* gettext-tools/examples/hello-objc-gnustep/Hello.m (Hello): Remove an unused
	variable.

2025-08-01  Bruno Haible  <bruno@clisp.org>

	gettext.m4: Fix build on Cygwin with gcc 13 or newer.
	This gcc version links with -lintl -liconv by default, making it appear as if
	gettext() et al. were defined in libc. But GNU gettext still needs to build a
	new libintl.

	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): On Cygwin, set
	USE_INCLUDED_LIBINTL=yes regardless of the gcc version.

2025-08-01  Bruno Haible  <bruno@clisp.org>

	gettext.m4: Modernize.
	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): Rename configure option
	--with-included-gettext to --with-included-libintl. Rename cache
	variable nls_cv_force_use_gnu_gettext to gt_cv_force_use_gnu_libintl.
	Rename cache variable nls_cv_use_gnu_gettext to gt_cv_use_gnu_libintl.

2025-07-30  Bruno Haible  <bruno@clisp.org>

	tests: Fix a lang-java failure on native Windows with MSVC.
	* gettext-tools/tests/lang-java: On native Windows, don't test the UTF-8 locale.

2025-07-28  Bruno Haible  <bruno@clisp.org>

	hostname: Fix a small memory leak.
	Reported by Coverity.

	* gettext-tools/src/hostname.c (print_hostname): Free hostname before returning.

2025-07-28  Bruno Haible  <bruno@clisp.org>

	Fix a small memory leak.
	Reported by Coverity.

	* gettext-tools/src/format-python.c (format_parse): Free name before returning.

2025-07-28  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-ocaml example.
	* gettext-tools/examples/hello-ocaml/INSTALL: New file.
	* gettext-tools/examples/hello-ocaml/autogen.sh: New file.
	* gettext-tools/examples/hello-ocaml/autoclean.sh: New file.
	* gettext-tools/examples/hello-ocaml/dune.in: New file.
	* gettext-tools/examples/hello-ocaml/dune-project.in: New file.
	* gettext-tools/examples/hello-ocaml/hello.ml.in: New file.
	* gettext-tools/examples/hello-ocaml/Makefile.am: New file.
	* gettext-tools/examples/hello-ocaml/configure.ac: New file.
	* gettext-tools/examples/hello-ocaml/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-ocaml/po/LINGUAS: New file.
	* gettext-tools/examples/hello-ocaml/po/Makefile.am: New file.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-ocaml.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-ocaml.
	(hello-ocaml.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-ocaml.
	($(srcdir)/../hello-ocaml/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check__hello_ocaml): New function.
	* gettext-tools/examples/README: Mention hello-ocaml.
	* gettext-tools/doc/lang-ocaml.texi: Likewise.
	* NEWS: Likewise.

2025-07-28  Bruno Haible  <bruno@clisp.org>

	OCaml support: Add a unit test.
	* gettext-tools/tests/lang-ocaml: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* HACKING: Document dependencies for lang-ocaml.

2025-07-28  Bruno Haible  <bruno@clisp.org>

	OCaml support: Add OCaml support in the tools.
	This implements several improvements, compared to
	"ocaml-gettext --action extract ...":
	  - Comments are extracted.
	  - '#, ocaml-format' annotation on f_ arguments.
	  - Recognizes concatenated strings, such as ("abc" ^ "def").
	  - Supports (s_ "").

	* autopull.sh: Check out tree-sitter-ocaml. Set TREE_SITTER_OCAML_VERSION.
	* gettext-tools/build-aux/tree-sitter-ocaml-portability.diff: New file.
	* gettext-tools/configure.ac: Set TREE_SITTER_OCAML_VERSION.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add the tree-sitter-ocaml source code
	and patch.
	* gettext-tools/doc/gettext.texi (PO Files): Mention ocaml-format.
	(Translators for other Languages): New subsection "OCaml Format Strings".
	* gettext-tools/doc/lang-ocaml.texi: Mention all the supported *gettext
	functions. Mention format strings with positions.
	* gettext-tools/doc/xgettext.texi: Document the OCaml support in more places.
	* gettext-tools/src/message.h (format_ocaml): New enum value.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_ocaml.
	* gettext-tools/src/format-ocaml.c: New file, based on
	gettext-tools/src/format-awk.c.
	* gettext-tools/src/format.h (formatstring_ocaml): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add formatstring_ocaml.
	* gettext-tools/src/x-ocaml.h (SCANNERS_OCAML): Reference flag_table_ocaml and
	formatstring_ocaml.
	(extract_ocaml): Declare with first argument of type 'FILE *'.
	* gettext-tools/src/x-ocaml.c: Completely rewritten.
	* gettext-tools/src/xgettext.c (flag_table_ocaml): New variable.
	(usage): Document the OCaml support in more places.
	(xgettext_record_flag): Support format_ocaml.
	* gettext-tools/src/FILES: Mention format-ocaml.c.
	* gettext-tools/src/Makefile.am (FORMAT_SOURCE): Add format-ocaml.c.
	(LIBXGETTEXTTS): Add libxgettextts5.a.
	(libxgettextts5_a_*): New variables.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-ocaml.c.
	* gettext-tools/po/POTFILES.in: Add src/format-ocaml.c.
	* gettext-tools/tests/format-ocaml-1: New file.
	* gettext-tools/tests/format-ocaml-2: New file.
	* gettext-tools/tests/xgettext-ocaml-1: New file.
	* gettext-tools/tests/xgettext-ocaml-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	* NEWS: Mention the OCaml support.

2025-07-27  Bruno Haible  <bruno@clisp.org>

	Refactor: Simplify.
	* gettext-tools/src/format-python-brace.c (parse_named_field,
	parse_numeric_field, parse_directive, parse_upto): Remove 'translated'
	parameter.
	(format_parse): Update.

2025-07-27  Bruno Haible  <bruno@clisp.org>

	Fix typos in comments.
	* gettext-tools/src/format-lua.c: Fix typos in comments.
	* gettext-tools/src/format-d.c: Likewise.

2025-07-23  Bruno Haible  <bruno@clisp.org>

	OCaml support: Add OCaml support in xgettext.
	* gettext-tools/doc/lang-ocaml.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (No string concatenation): Mention string
	concatenation in OCaml.
	(List of Programming Languages): Include lang-ocaml.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L OCaml option.
	* gettext-tools/src/x-ocaml.h: New file.
	* gettext-tools/src/x-ocaml.c: New file.
	* gettext-tools/src/xgettext.c: Include x-ocaml.h.
	(flag_table_ocaml): New variable.
	(main): Invoke init_flag_table_ocaml, x_ocaml_extract_all, x_ocaml_keyword.
	(usage): Document the -L OCaml option.
	(language_to_extractor, extension_to_language): Support OCaml.
	* gettext-tools/src/FILES: Mention x-ocaml.h, x-ocaml.c.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add x-ocaml.h.
	(xgettext_SOURCES): Add x-ocaml.c.
	* gettext-tools/po/POTFILES.in: Add src/x-ocaml.c.

2025-07-22  Bruno Haible  <bruno@clisp.org>

	tests: Fix a lang-java failure on native Windows.
	* gettext-tools/tests/lang-java: On native Windows, convert newlines in the
	output before comparing.

2025-07-22  Bruno Haible  <bruno@clisp.org>

	tests: Recognize the *-*-windows* config triplets introduced on 2023-06-26.
	* gettext-tools/tests/init-env.in: Treat windows* as equivalent to mingw*.
	* gettext-tools/tests/intl-7: Likewise.
	* gettext-tools/tests/lang-c: Likewise.
	* gettext-tools/tests/lang-c++: Likewise.
	* gettext-tools/tests/lang-c++-boost: Likewise.
	* gettext-tools/tests/lang-c++20: Likewise.
	* gettext-tools/tests/lang-c++26: Likewise.
	* gettext-tools/tests/lang-d: Likewise.
	* gettext-tools/tests/lang-modula2: Likewise.
	* gettext-tools/tests/lang-objc: Likewise.
	* gettext-tools/tests/msgfilter-8: Likewise.

2025-07-21  Bruno Haible  <bruno@clisp.org>

	tests: Fix a lang-java failure on native Windows.
	* gettext-tools/tests/init-env.in (CLASSPATH_SEPARATOR): New variable.
	* gettext-tools/tests/lang-java: Use it instead of hardcoding ':'.

2025-07-21  Bruno Haible  <bruno@clisp.org>

	Fix typos.
	Reported by <Jens.Schleusener@fossies.org>.

	* gettext-tools/libgrep/m-regex.c: Fix typo in comments.
	* gettext-tools/misc/autopoint.in: Likewise.
	* gettext-tools/misc/gettextize.in: Likewise.
	* gettext-tools/src/format-python-brace.c: Likewise.
	* gettext-tools/src/gnu/gettext/DumpResource.java: Likewise.
	* gettext-tools/src/its.h: Likewise.
	* gettext-tools/src/locating-rules.h: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/read-catalog-abstract.h: Likewise.
	* gettext-tools/src/read-catalog-abstract.c: Likewise.
	* gettext-tools/src/read-catalog.h: Likewise.
	* gettext-tools/src/read-properties.c: Likewise.
	* gettext-tools/src/write-java.c: Likewise.
	* gettext-tools/src/write-mo.c: Likewise.
	* gettext-tools/src/x-d.c: Likewise.
	* gettext-tools/src/x-scheme.c: Likewise.
	* gettext-tools/src/x-sh.c: Likewise.
	* gettext-tools/emacs/po-mode.el: Fix typos in help and comments.
	* gettext-tools/doc/gettext.texi: Fix typos.
	* NEWS: Fix typos.

2025-07-21  Bruno Haible  <bruno@clisp.org>

	examples: Reenable checking of hello-c-gnome3 and hello-c++-gnome3.
	* gettext-tools/examples/check-examples (func_check__hello_c_gnome3,
	func_check__hello_cxx_gnome3): Reenable most checks.

2025-07-20  Bruno Haible  <bruno@clisp.org>

	examples: Make 'check-example' more maintainable.
	Some examples require specific sets of environment variables.
	E.g. hello-go requires a PATH which uses GCC 13 or 14, not GCC 15,
	due to <https://gcc.gnu.org/bugzilla/show_bug.cgi?id=119098>.

	* gettext-tools/examples/check-examples: Rewrite to use one top-level function
	per sample, instead of one top-level function for each check.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	Update release steps.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 0.26.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.26.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.
	* gettext-runtime/po/*.po: Update from TP.
	* gettext-tools/po/*.po: Update from TP.
	* gettext-tools/examples/po/*.po: Update from TP.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	Prepare for 0.26 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/po/Makefile.in.in: Update Origin.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:5:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:6:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:15:5.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.26.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.26.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-07-19  Bruno Haible  <bruno@clisp.org>

	xgettext: JavaScript: Add one more test.
	Reported by <fiurgeist@gmail.com>
	at <https://savannah.gnu.org/bugs/index.php?67337>.

	* gettext-tools/tests/xgettext-javascript-14: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-07-18  Bruno Haible  <bruno@clisp.org>

	msginit: Fix encoding of second title line, part 2.
	Reported by Matilin Torre <watilin@protonmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-07/msg00024.html>.

	To reproduce the problem:
	$ LC_ALL=de_DE.ISO-8859-1 msginit -l fr_FR.ISO-8859-1 -i some_utf-8.pot -o fr.po

	* gettext-tools/src/msginit.c (output_charset): New variable.
	(content_type): Use output_charset.
	(get_title): Use output_charset instead of ignoring was_utf8.
	(fill_header): Initialize output_charset. Moved logic from content_type()
	to here.

2025-07-18  Bruno Haible  <bruno@clisp.org>

	msginit: Fix encoding of second title line, part 1.
	Reported by Matilin Torre <watilin@protonmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-07/msg00024.html>.

	* gettext-tools/src/msginit.c: Include xstriconv.h.
	(get_title): Don't set OUTPUT_CHARSET; this does not work any more since 2005,
	when an optimization was made in dcigettext.c. Instead, use xstr_iconv().

2025-07-12  Bruno Haible  <bruno@clisp.org>

	msgfmt: Verify that .mo files are reproducible across GNU gettext versions.
	* gettext-tools/tests/msgfmt-21: New file.
	* gettext-tools/tests/testdata/mf-21.mo: New generated file.
	* gettext-tools/tests/Makefile.am (TESTS): Add msgfmt-21.
	(EXTRA_DIST): Add testdata/mf-21.mo.

2025-07-12  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-07-09  Bruno Haible  <bruno@clisp.org>

	build: On mingw, avoid link dependency from xgettext.exe to libstdc++.
	Reported by Michele Locati <michele@locati.it> in
	<https://lists.gnu.org/archive/html/bug-gettext/2024-10/msg00007.html>.

	* gettext-tools/src/Makefile.am (xgettext_CXXFLAGS): New variable.

2025-07-09  Bruno Haible  <bruno@clisp.org>

	build: Use a more understandable directory name for ITS data files.
	Reported by Santiago Vila <sanvila@debian.org>.

	* gettext-tools/configure.ac (PACKAGE_SUFFIX): Use PACKAGE_VERSION, not
	ARCHIVE_VERSION.

2025-07-08  Bruno Haible  <bruno@clisp.org>

	build: Update .gitignore files.

2025-07-08  Bruno Haible  <bruno@clisp.org>

	build: Remove autosprintf_all.html upon "make maintainer-clean".
	* gettext-runtime/libasprintf/Makefile.am (MAINTAINERCLEANFILES): New variable.

2025-07-07  Bruno Haible  <bruno@clisp.org>

	tests: Fix suggested valgrind invocation.
	A while ago, valgrind exited with exit code != 0 when it encountered an error.
	This is apparently not the case any more.

	* gettext-tools/tests/Makefile.am (CHECKER): Add --error-exitcode option.

2025-07-07  Bruno Haible  <bruno@clisp.org>

	xgettext: Perl: Add unit test for bug.
	* gettext-tools/tests/xgettext-perl-11: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-07-07  Bruno Haible  <bruno@clisp.org>

	xgettext: Perl: Fix a memory leak (regression 2003-06-27).
	* gettext-tools/src/x-perl.c (phase2_getc): Free the result of
	from_current_source_encoding.

2025-07-07  Bruno Haible  <bruno@clisp.org>

	xgettext: Perl: Fix bug with comment lines longer than 1024 (regr. 2024-09-26).
	Reported by Alyssa Ross <hi@alyssa.is> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-07/msg00009.html>.

	* gettext-tools/src/x-perl.c (phase2_getc): Move the sb_free call until after
	the savable_comment_add call.

2025-07-04  Bruno Haible  <bruno@clisp.org>

	doc: More precisions about POSIX printf portability.
	* gettext-tools/doc/lang-sh.texi (The printf approach): Add more details.
	Based on info given by Jörg Schilling in 2020.

2025-07-04  Bruno Haible  <bruno@clisp.org>

	Prepare for prerelease.
	* gettext-tools/po/POTFILES.in: Update file list.

2025-07-04  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-07-04  Bruno Haible  <bruno@clisp.org>

	xgettext: Warn when a message contains an URL or email address.
	Reported by Arsen Arsenović <arsen@aarsen.me>
	at <https://savannah.gnu.org/bugs/?67000>.

	* gettext-tools/src/xg-check.c: Include c-strstr.h.
	(SIZEOF): New macro.
	(string_has_url, message_has_url, string_has_email, message_has_email,
	url_check_message): New functions.
	(xgettext_check_message_list): Invoke url_check_message.
	* gettext-tools/tests/xgettext-20: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention the change.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	msgcat, msgen, xgettext: Tweak processing order.
	* gettext-tools/src/msgcat.c (main): Sort the list of messages as the last
	processing step before writing the PO file.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	xgettext: Check msgid and msgid_plural for compatibility as format strings.
	* gettext-tools/src/if-error.h: Include <stdarg.h>.
	(if_verror): New declaration.
	* gettext-tools/src/if-error.c (if_verror): New function, extracted from
	if_error.
	(if_error): Invoke it.
	* gettext-tools/src/xg-check.h (xgettext_check_message_list): Renamed from
	syntax_check_message_list.
	* gettext-tools/src/xg-check.c: Include format.h, if-error.h.
	(struct formatstring_error_logger_locals): New type.
	(formatstring_error_logger, format_check_message): New functions.
	(xgettext_check_message_list): Renamed from syntax_check_message_list. Invoke
	also format_check_message.
	* gettext-tools/src/xgettext.c (main): Invoke xgettext_check_message_list
	instead of syntax_check_message_list.
	* gettext-tools/tests/xgettext-19: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention the change.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	Lisp, Scheme support: Fix format string checking.
	* gettext-tools/src/format-lisp.c (format_check): Allow missing arguments if
	!equality.
	* gettext-tools/src/format-scheme.c (format_check): Likewise.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	Lua support: Fix format string checking.
	* gettext-tools/src/format-lua.c (format_check): Allow missing arguments if
	!equality. Report all argument type mismatches at once.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	tests: Strengthen tests.
	* gettext-tools/tests/lang-bash: Invoke msgfmt with option '-c'.
	* gettext-tools/tests/lang-c: Likewise.
	* gettext-tools/tests/lang-c++: Likewise.
	* gettext-tools/tests/lang-c++20: Likewise.
	* gettext-tools/tests/lang-c++26: Likewise.
	* gettext-tools/tests/lang-c++-boost: Likewise.
	* gettext-tools/tests/lang-clisp: Likewise.
	* gettext-tools/tests/lang-csharp: Likewise.
	* gettext-tools/tests/lang-d: Likewise.
	* gettext-tools/tests/lang-elisp: Likewise.
	* gettext-tools/tests/lang-gawk: Likewise.
	* gettext-tools/tests/lang-go: Likewise.
	* gettext-tools/tests/lang-guile: Likewise.
	* gettext-tools/tests/lang-java: Likewise.
	* gettext-tools/tests/lang-javascript: Likewise.
	* gettext-tools/tests/lang-librep: Likewise.
	* gettext-tools/tests/lang-lua: Likewise.
	* gettext-tools/tests/lang-modula2: Likewise.
	* gettext-tools/tests/lang-objc: Likewise.
	* gettext-tools/tests/lang-pascal: Likewise.
	* gettext-tools/tests/lang-perl-1: Likewise.
	* gettext-tools/tests/lang-perl-2: Likewise.
	* gettext-tools/tests/lang-php: Likewise.
	* gettext-tools/tests/lang-python-1: Likewise.
	* gettext-tools/tests/lang-python-2: Likewise.
	* gettext-tools/tests/lang-ruby: Likewise.
	* gettext-tools/tests/lang-rust: Likewise.
	* gettext-tools/tests/lang-sh-1: Likewise.
	* gettext-tools/tests/lang-sh-2: Likewise.
	* gettext-tools/tests/lang-sh-3: Likewise.
	* gettext-tools/tests/lang-smalltalk: Likewise.
	* gettext-tools/tests/lang-tcl: Likewise.
	* gettext-tools/tests/lang-vala: Likewise.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	Python: Fix compilation error (regression 2025-06-24).
	* gettext-tools/src/format-python-brace.c (parse_directive): Pass NULL, not
	false.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Fix possible crash during format string checking.
	* gettext-tools/src/format-modula2.c (format_check): Fix error message. Fix loop
	bound.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix bug with syntax-checks on messages from Perl source code.
	* gettext-tools/src/x-perl.c (extract_perl): Don't free logical_file_name,
	because it is referenced by the 'pos' field of the returned messages, and
	xg-check.c accesses and prints it.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	xgettext: Fix handling of syntax-checks with multi-domain POT files.
	* gettext-tools/src/xgettext.c (main): Consider the total number of errors.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	msggrep: Add new options -W and -S.
	Reported at <https://savannah.gnu.org/bugs/?40489>.

	* gettext-tools/src/msggrep.c (workflow_flags, sticky_flags): New variables.
	(main): Initialize them. Handle the options -W and -S.
	(usage): Document the -W and -S options.
	(is_message_selected_no_invert): Return true if one of the specified workflow
	flags or one of the specified sticky flags is set.
	* gettext-tools/tests/msggrep-12: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* gettext-tools/doc/msggrep.texi: Document the -W and -S options.
	* NEWS: Mention the change.

2025-07-03  Bruno Haible  <bruno@clisp.org>

	msggrep: Finish documenting the -X option (left-over from 2006-03-17).
	* gettext-tools/doc/msggrep.texi: Mention the -X option in the summary.

2025-07-02  Bruno Haible  <bruno@clisp.org>

	Update NEWS after 0.25.1 release.
	* NEWS: Mention 0.25.1 release.

2025-07-02  Bruno Haible  <bruno@clisp.org>

	Merge from 0.25.x branch: Prepare for 0.25.1 release.
	* gettext-tools/misc/autopoint.in: Accept versions 0.23.2, 0.24.2, 0.25.1.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.25.1.
	* NEWS: Update.

2025-07-01  Bruno Haible  <bruno@clisp.org>

	autopoint: Don't fail if no gettext version is specified, part 2.
	* gettext-tools/misc/autopoint.in (func_trace_sed): Recognize also macro calls
	without arguments.
	* gettext-tools/tests/autopoint-1: Remove unneeded parentheses in macro call.

2025-07-01  Bruno Haible  <bruno@clisp.org>

	autopoint: Update unit test, part 2.
	* gettext-tools/tests/autopoint-1: Remove debugging trace.

2025-07-01  Bruno Haible  <bruno@clisp.org>

	autopoint: Update unit test.
	* gettext-tools/tests/autopoint-1: Update for new autopoint behaviour.

2025-07-01  Bruno Haible  <bruno@clisp.org>

	Fix an autoreconf failure in packages that only need AM_NLS.
	Rationale: https://lists.gnu.org/archive/html/bug-gettext/2025-06/msg00009.html

	* gettext-tools/m4/Makefile.am (aclocaldir, aclocal_DATA): New variables.
	* PACKAGING: Update.

2025-07-01  Bruno Haible  <bruno@clisp.org>

	autopoint: Don't fail if no gettext version is specified.
	Rationale: https://lists.gnu.org/archive/html/bug-gettext/2025-06/msg00009.html

	* gettext-tools/misc/autopoint.in: Instead of failing with "Missing version",
	use version 0.23.1. Set omitintl=yes if there is no AM_GNU_GETTEXT invocation.

2025-06-30  Bruno Haible  <bruno@clisp.org>

	Support reading PO files with '#=' lines.
	* gettext-tools/src/read-catalog-abstract.c
	(catalog_reader_seen_generic_comment): Treat '=' like ','.
	* gettext-tools/src/read-catalog.c (default_comment_special): Allow several
	calls to this method to make side effects on dcatr.
	* gettext-tools/src/read-catalog-special.h: Update comment.
	* gettext-tools/src/read-catalog-special.c: Likewise.
	* gettext-tools/tests/msgcat-24: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-30  Bruno Haible  <bruno@clisp.org>

	doc: Document the short-term PO file format evolution.
	* gettext-tools/doc/gettext.texi (PO File Format Evolution): New section.

2025-06-30  Bruno Haible  <bruno@clisp.org>

	doc: Structure the "PO Files" chapter.
	* gettext-tools/doc (PO Files): Split into sections. Introduce workflow flags
	and sticky flags. Mention the 'no-wrap' flag.

2025-06-30  Bruno Haible  <bruno@clisp.org>

	Simplify code: The syntax-check flags are only used inside xgettext.
	* gettext-tools/src/message.h: Improve comments regarding do_syntax_check.
	* gettext-tools/src/msgl-cat.c (catenate_msgdomain_list): Don't manipulate
	do_syntax_check field.
	* gettext-tools/src/msgmerge.c (message_merge): Likewise.
	* gettext-tools/src/read-catalog-special.h (parse_comment_special): Change 'scp'
	parameter to a pointer.
	* gettext-tools/src/read-catalog-special.c (parse_comment_special): Support a
	null 'scp' argument.
	* gettext-tools/src/read-catalog.h (DEFAULT_CATALOG_READER_TY): Remove
	do_syntax_check field.
	* gettext-tools/src/read-catalog.c (default_constructor,
	default_copy_comment_state, default_reset_comment_state,
	default_comment_special): Don't reference do_syntax_check field.

2025-06-29  Bruno Haible  <bruno@clisp.org>

	examples: Extend the hello-sh example, part 2.
	* gettext-tools/examples/hello-sh/hello-2.sh: New file, based on
	gettext-tools/examples/hello-sh/hello-1.sh.
	* gettext-tools/examples/hello-sh/hello-3.sh: New file, based on
	gettext-tools/examples/hello-sh/hello-2.sh.

2025-06-29  Bruno Haible  <bruno@clisp.org>

	Tweak last commit.
	* gettext-tools/src/msgcmp.c (main): Tweak whitespace.

2025-06-28  Bruno Haible  <bruno@clisp.org>

	Refactor: Use gnulib's 'options' module.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC, GNULIB_MODULES_TOOLS_FOR_SRC): Add
	'options'. Remove 'getopt-gnu'.
	* gettext-runtime/src/envsubst.c: Include options.h instead of <getopt.h>.
	(long_options): Remove variable.
	(main): Define options array here. Call start_options, get_next_option instead
	of getopt_long().
	* gettext-runtime/src/gettext.c: Likewise.
	* gettext-runtime/src/ngettext.c: Likewise.
	* gettext-runtime/src/printf_gettext.c: Likewise.
	* gettext-runtime/src/printf_ngettext.c: Likewise.
	* gettext-tools/src/cldr-plurals.c: Likewise.
	* gettext-tools/src/hostname.c: Likewise.
	* gettext-tools/src/msgattrib.c: Likewise.
	* gettext-tools/src/msgcat.c: Likewise.
	* gettext-tools/src/msgcmp.c: Likewise.
	* gettext-tools/src/msgcomm.c: Likewise.
	* gettext-tools/src/msgconv.c: Likewise.
	* gettext-tools/src/msgen.c: Likewise.
	* gettext-tools/src/msgexec.c: Likewise.
	* gettext-tools/src/msgfilter.c: Likewise.
	* gettext-tools/src/msgfmt.c: Likewise.
	* gettext-tools/src/msggrep.c: Likewise.
	* gettext-tools/src/msginit.c: Likewise.
	* gettext-tools/src/msgmerge.c: Likewise.
	* gettext-tools/src/msgunfmt.c: Likewise.
	* gettext-tools/src/msguniq.c: Likewise.
	* gettext-tools/src/recode-sr-latin.c: Likewise.
	* gettext-tools/src/urlget.c: Likewise.
	* gettext-tools/src/xgettext.c: Likewise.
	* gettext-tools/tests/tstgettext.c: Likewise.
	* gettext-tools/tests/tstngettext.c: Likewise.

2025-06-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-06-28  Bruno Haible  <bruno@clisp.org>

	Adhere to GNU Coding Style.
	* gettext-runtime/src/envsubst.c (main): Use common 'switch' indentation.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/tests/tstgettext.c (main): Likewise.
	* gettext-tools/tests/tstngettext.c (main): Likewise.

2025-06-28  Bruno Haible  <bruno@clisp.org>

	xgettext: Remove undocumented no-op option '-W'.
	This was a regression from 2015-01-29.

	* gettext-tools/src/xgettext.c (main): Remove short option '-W'.

2025-06-28  Bruno Haible  <bruno@clisp.org>

	msgconv, msgen, msgfilter, msggrep, msgmerge: The option '-n' takes no argument.
	This was a regression from 2014-03-24.

	* gettext-tools/src/msgconv.c (main): Change "n:" to "n" in getopt_long
	argument.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.

2025-06-27  Bruno Haible  <bruno@clisp.org>

	Shell: Document two more approaches.
	* gettext-tools/doc/lang-sh.texi (sh): Tweaks.
	(sh - Three approaches): New subsubsection.
	(The gettext.sh approach): New subsubsection, incorporating the "gettext.sh"
	subsubsection.
	(The printf approach, The printf_gettext approach): New subsubsections.
	(Preparing for gettext.sh): Renamed from "Preparing Shell Scripts".
	(Preparing for printf, Preparing for printf_gettext): New subsubsections.
	* gettext-tools/doc/gettext.texi: Update detailed node list.
	* NEWS: Mention the change.

2025-06-27  Bruno Haible  <bruno@clisp.org>

	examples: Extend the hello-sh example.
	* gettext-tools/examples/hello-sh/hello-1.sh: Renamed from
	gettext-tools/examples/hello-sh/hello.sh.
	* gettext-tools/examples/hello-sh/hello-2.sh: New file, based on
	gettext-tools/examples/hello-sh/hello-1.sh.
	* gettext-tools/examples/hello-sh/hello-3.sh: New file, based on
	gettext-tools/examples/hello-sh/hello-2.sh.
	* gettext-tools/examples/hello-sh/configure.ac: Update AC_CONFIG_SRCDIR
	invocation and AC_CONFIG_FILES invocations.
	* gettext-tools/examples/hello-sh/Makefile.am (bin_SCRIPTS): Remove hello.
	Add hello-1, hello-2, hello-3.
	* gettext-tools/examples/hello-sh/po/Makefile.am (POTFILES): Remove hello.sh.
	Add hello-1.sh, hello-2.sh, hello-3.sh.
	* gettext-tools/examples/po/Makefile.am (POTFILES): Update accordingly.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES): Update file list.

2025-06-27  Bruno Haible  <bruno@clisp.org>

	Shell: Add another unit test.
	* gettext-tools/tests/lang-sh-3: New file, based on
	gettext-tools/tests/lang-sh-2.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-27  Bruno Haible  <bruno@clisp.org>

	build: Use module 'kwset' from gnulib.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_LIBGREP): Add kwset.
	(GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES): Update.
	* gettext-tools/libgrep/m-fgrep.c (Fcompile, Fexecute): Update for changed kwset
	API.
	* gettext-tools/libgrep/kwset.h: Remove file.
	* gettext-tools/libgrep/kwset.c: Remove file.
	* gettext-tools/libgrep/Makefile.am (libgrep_a_SOURCES): Remove kwset.h,
	kwset.c.

2025-06-26  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-06-26  Bruno Haible  <bruno@clisp.org>

	build: Update regarding current gnulib.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES): Update.

2025-06-25  Bruno Haible  <bruno@clisp.org>

	build: Fix "make distcheck" failure.
	* gettext-runtime/man/*.x: Add copyright and license header.

2025-06-25  Bruno Haible  <bruno@clisp.org>

	xgettext: Shell: Recognize printf_gettext, printf_ngettext invocations.
	* gettext-tools/src/x-sh.c (init_keywords, init_flag_table_sh): Add knowledge
	about printf_gettext and printf_ngettext.
	(read_command): Recognize '-c' option of printf_gettext and printf_ngettext.
	* gettext-tools/tests/xgettext-sh-1: Add test cases with printf_gettext and
	printf_ngettext.
	* gettext-tools/doc/xgettext.texi: Document it.

2025-06-25  Bruno Haible  <bruno@clisp.org>

	gettext-runtime: New programs 'printf_gettext', 'printf_ngettext'.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC): Add c-ctype, c-strtold,
	fzprintf-posix, mbrtoc32, mbszero, quote, stdint-h, strtoimax, strtold,
	strtoumax, xstrtold.
	* gettext-runtime/src/printf-command.h: New file.
	* gettext-runtime/src/printf-command.c: New file.
	* gettext-runtime/src/printf_gettext.c: New file.
	* gettext-runtime/src/Makefile.am (bin_PROGRAMS): Add printf_gettext,
	printf_ngettext.
	(noinst_LIBRARIES, libgrtsrc_a_SOURCES): New variables.
	(printf_gettext_SOURCES, printf_gettext_CFLAGS, printf_gettext_LDFLAGS): New
	variables.
	(printf_ngettext_SOURCES, printf_ngettext_CFLAGS, printf_ngettext_LDFLAGS): New
	variables.
	(LDADD): Add libgrtsrc.a.
	* gettext-runtime/po/POTFILES.in: Add src/printf-command.c,
	src/printf_gettext.c, src/printf_ngettext.c.
	* gettext-runtime/man/printf_gettext.x: New file.
	* gettext-runtime/man/printf_ngettext.x: New file.
	* gettext-runtime/man/Makefile.am (man_aux): Add printf_gettext.x,
	printf_ngettext.x.
	(man_MAN1GEN): Add printf_gettext.1, printf_ngettext.1.
	(man_MAN1IN): Add printf_gettext.1.in, printf_ngettext.1.in.
	(man_HTML1GEN): Add printf_gettext.1.html, printf_ngettext.1.html.
	(man_HTML1IN): Add printf_gettext.1.html.in, printf_ngettext.1.html.in.
	(printf_gettext.1, rintf_ngettext.1, printf_gettext.1.in, printf_ngettext.1.in):
	Add dependencies.
	(printf_gettext.1.html, printf_ngettext.1.html, printf_gettext.1.html.in,
	printf_ngettext.1.html.in): Likewise.
	* gettext-runtime/Makefile.am (distdir1): Depend on man/printf_gettext.1 and
	man/printf_ngettext.1.
	(man/printf_gettext.1, man/printf_ngettext.1): Depend on gen-man1.
	(gen-man1): Make src/printf_gettext, src/printf_ngettext and printf_gettext.1,
	printf_ngettext.1.
	* gettext-runtime/doc/rt-printf_gettext.texi: New file.
	* gettext-runtime/doc/rt-printf_ngettext.texi: New file.
	* gettext-runtime/doc/Makefile.am (EXTRA_DIST): Add them.
	* gettext-tools/doc/lang-sh.texi (printf_gettext Invocation,
	printf_ngettext Invocation): New subsubsections.
	* gettext-tools/doc/gettext.texi (@direntry): Add printf_gettext, .
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add rt-printf_gettext.texi,
	rt-printf_ngettext.texi.
	* gettext-runtime/NEWS: Mention the new programs.
	* NEWS: Likewise.
	* PACKAGING: Add the printf_gettext and printf_ngettext programs and their
	documentation.

2025-06-25  Bruno Haible  <bruno@clisp.org>

	gettext-runtime: Improve --help output.
	* gettext-runtime/src/gettext.c (usage): Add section title
	"Options and arguments".
	* gettext-runtime/src/ngettext.c (usage): Likewise.
	* gettext-runtime/doc/rt-gettext.texi: Add section titles
	"Options and arguments" and "Informative output".
	* gettext-runtime/doc/rt-ngettext.texi: Likewise.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	C++: Add another unit test.
	* gettext-tools/tests/lang-c++-boost: New file, based on
	gettext-tools/tests/lang-c++26.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* gettext-tools/doc/lang-c.texi: Mention how to use C++ with the Boost library.
	* HACKING: Mention the Boost library.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	Shell: Add another unit test.
	* gettext-tools/tests/lang-sh-1: Renamed from gettext-tools/tests/lang-sh.
	* gettext-tools/tests/lang-sh-2: New file, based on
	gettext-tools/tests/lang-sh-1.
	* gettext-tools/tests/Makefile.am (TESTS): Remove lang-sh. Add lang-sh-1,
	lang-sh-2.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	Python: Add another unit test.
	* gettext-tools/tests/lang-python-2: New file, based on
	gettext-tools/tests/lang-python-1.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	Python: Update python-brace-format, assuming Python >= 3.1.
	* gettext-tools/src/format-python-brace.c (struct toplevel_counters): New type.
	(parse_directive): Take a 'struct toplevel_counters *' parameter. Allow empty
	argument names at the top-level. But reject format strings with both absolute
	argument numbers and unnamed arguments at the top-level.
	(parse_upto): Take a 'struct toplevel_counters *' parameter.
	(format_parse): Pass a 'struct toplevel_counters *' to parse_upto.
	* gettext-tools/tests/format-python-brace-1: Update.
	* gettext-tools/tests/format-python-brace-2: Add another test case.
	* gettext-tools/doc/lang-python.texi: Add more examples of formatting with
	positions.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	Python: Fix bug in python-brace-format.
	* gettext-tools/src/format-python-brace.c (parse_directive): The name ends
	before ':', not before '}'.

2025-06-24  Bruno Haible  <bruno@clisp.org>

	Python: Remove an obsolete unit test.
	Python versions < 2.3 are irrelevant nowadays.

	* gettext-tools/tests/lang-python-1: Renamed from
	gettext-tools/tests/lang-python-2.
	* gettext-tools/tests/Makefile.am (TESTS): Remove lang-python-2.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	Support format strings longer than 2 GiB on 64-bit platforms.
	* gettext-tools/configure.ac: In config.h, define GCD_WORD_T.
	* gettext-tools/src/format-invalid.h: In format strings, use %zu instead of %u.
	* gettext-tools/src/format-awk.c: Use size_t instead of 'unsigned int'. In
	format strings, use %zu instead of %u.
	* gettext-tools/src/format-boost.c: Likewise.
	* gettext-tools/src/format-c.c: Likewise.
	* gettext-tools/src/format-c-parse.h: Likewise.
	* gettext-tools/src/format-c++-brace.c: Likewise.
	* gettext-tools/src/format-csharp.c: Likewise.
	* gettext-tools/src/format-d.c: Likewise.
	* gettext-tools/src/format-elisp.c: Likewise.
	* gettext-tools/src/format-gcc-internal.c: Likewise.
	* gettext-tools/src/format-gfc-internal.c: Likewise.
	* gettext-tools/src/format-go.c: Likewise.
	* gettext-tools/src/format-java.c: Likewise.
	* gettext-tools/src/format-java-printf.c: Likewise.
	* gettext-tools/src/format-javascript.c: Likewise.
	* gettext-tools/src/format-kde.c: Likewise.
	* gettext-tools/src/format-kde-kuit.c: Likewise.
	* gettext-tools/src/format-librep.c: Likewise.
	* gettext-tools/src/format-lisp.c: Likewise.
	* gettext-tools/src/format-lua.c: Likewise.
	* gettext-tools/src/format-modula2.c: Likewise.
	* gettext-tools/src/format-pascal.c: Likewise.
	* gettext-tools/src/format-perl.c: Likewise.
	* gettext-tools/src/format-perl-brace.c: Likewise.
	* gettext-tools/src/format-php.c: Likewise.
	* gettext-tools/src/format-python.c: Likewise.
	* gettext-tools/src/format-python-brace.c: Likewise.
	* gettext-tools/src/format-qt.c: Likewise.
	* gettext-tools/src/format-qt-plural.c: Likewise.
	* gettext-tools/src/format-ruby.c: Likewise.
	* gettext-tools/src/format-rust.c: Likewise.
	* gettext-tools/src/format-scheme.c: Likewise.
	* gettext-tools/src/format-sh.c: Likewise.
	* gettext-tools/src/format-sh-printf.c: Likewise.
	* gettext-tools/src/format-smalltalk.c: Likewise.
	* gettext-tools/src/format-tcl.c: Likewise.
	* gettext-tools/src/format.h (get_python_format_unnamed_arg_count): Return
	size_t instead of 'unsigned int'.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	gettext-runtime: Fix --help output in relocatable installations.
	* gettext-runtime/src/gettext.c (usage): Show the relocated LOCALEDIR.
	* gettext-runtime/src/ngettext.c (usage): Likewise.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	Adhere to GNU Coding Style.
	* gettext-runtime/src/gettext.c (usage): Add space after 'printf'.
	* gettext-runtime/src/ngettext.c (usage): Likewise.
	* gettext-runtime/src/envsubst.c (usage): Likewise.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	Add support for Shell printf format strings, part 3.
	* gettext-tools/src/format-invalid.h (INVALID_FLAG_FOR): New macro.
	* gettext-tools/src/format-java-printf.c (INVALID_FLAG_FOR): Remove macro.
	* gettext-tools/src/format-sh-printf.c (format_parse): Reject format strings
	with invalid flag+specifier combinations.
	* gettext-tools/tests/format-sh-printf-1: Add more test cases.
	* gettext-tools/doc/gettext.texi (sh-format): Mention the ' flag.

2025-06-23  Bruno Haible  <bruno@clisp.org>

	Add support for Shell printf format strings, part 2.
	* gettext-tools/po/POTFILES.in: Add src/format-sh-printf.c.
	* gettext-tools/tests/format-sh-printf-1: Use 'printf' instead of 'echo',
	because 'echo' processes escape sequences on macOS, OpenBSD, Solaris.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	Add support for Shell printf format strings.
	* gettext-tools/src/message.h (enum format_type): Add format_sh_printf.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_sh_printf.
	* gettext-tools/src/format.h (formatstring_sh_printf): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add an entry for
	format_sh_printf.
	* gettext-tools/src/format-sh-printf.c: New file, based on
	gettext-tools/src/format-awk.c.
	* gettext-tools/src/FILES: Mention it.
	* gettext-tools/src/x-sh.h (SCANNERS_SH): Use formatstring_sh_printf as
	secondary format string type.
	* gettext-tools/src/xgettext.c (xgettext_record_flag): Update accordingly.
	* gettext-tools/src/x-sh.c (init_flag_table_sh): Register gettext, ngettext with
	flag 'pass-sh-printf-format'. Register 'printf' with flag 'sh-printf-format'.
	* gettext-tools/src/Makefile.am (FORMAT_SOURCE): Add format-sh-printf.c.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Likewise.
	* gettext-tools/doc/gettext.texi (PO Files): Mention sh-printf-format.
	(sh-format): Document also the sh-printf-format strings.
	* gettext-tools/doc/lang-sh.texi (sh): Mention the coreutils 'printf' command.
	* gettext-tools/tests/xgettext-sh-1: Add a test case with a printf invocation.
	* gettext-tools/tests/format-sh-printf-1: New file, based on
	gettext-tools/tests/format-awk-1.
	* gettext-tools/tests/format-sh-printf-2: New file, based on
	gettext-tools/tests/format-awk-2.
	* gettext-tools/tests/Makefile.am (TESTS): Add them.
	* NEWS: Mention the change.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	tcl-format: Accept null precision.
	Proof that it's valid:
	$ tclsh
	puts [format "%.f" 3.1415926535]

	* gettext-tools/src/format-tcl.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-tcl-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	rust-format: Reject null precision.
	* gettext-tools/tests/format-rust-1: Add more test cases with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	ruby-format: Accept null precision.
	Proof that it's valid:
	$ ruby
	puts "%.f" % 3.1415926535

	* gettext-tools/src/format-ruby.c: Clarify comment regarding the precision.
	* gettext-tools/tests/format-ruby-1: Add test cases with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	python-brace-format: Reject null precision.
	Proof that it's invalid:
	$ python
	print("{value:.}".format(value = 3.141592535))

	* gettext-tools/tests/format-python-brace-1: Add another test case with null
	precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	python-format: Accept null precision.
	Proof that it's valid:
	$ python
	print("%(value).f" % { 'value': 3.1415926535 })

	* gettext-tools/src/format-python.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-python-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	php-format: Reject null precision.
	Rationale: The handling of null precision in php is buggy,
	cf. <https://github.com/php/php-src/issues/18897>.

	* gettext-tools/src/format-php.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-php-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	perl-format: Accept null precision.
	Proof that it's valid:
	$ perl
	printf "%.f", 3.1415926535

	* gettext-tools/src/format-perl.c: Clarify comment regarding the precision.
	* gettext-tools/tests/format-perl-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	pascal-format: Accept null precision.
	Proof that it's valid:
	------------------------- foo.pp -------------------------
	program foo;
	uses sysutils;
	begin
	  writeln(format('%.f', [3.1415926535]));
	end.
	----------------------------------------------------------

	* gettext-tools/src/format-pascal.c: Fix comment regarding the precision.
	(format_parse): Accept a null precision after '.'.
	* gettext-tools/tests/format-pascal-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	lua-format: Accept null precision. Limit width and precision to two digits.
	Proof that it's valid:
	$ lua
	print(string.format("%.f", 3.1415926535))

	* gettext-tools/src/format-lua.c: Fix comment regarding the width and the
	precision.
	(format_parse): Recognize at most two digits for the width. Recognize at most
	two digits for the precision.
	* gettext-tools/tests/format-lua-1: Add test cases with large width, null
	precision, and large precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	librep-format: Accept null precision.
	Proof that it's valid:
	$ rep
	(format t "%.d" 3.1415926535)

	* gettext-tools/src/format-librep.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-librep-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	javascript-format: Reject null precision.
	Proof that it's invalid:
	------------------------------- foo.js -------------------------------
	const Format = imports.format;
	String.prototype.format = Format.format;
	print("%.f".format(3.1415916535));
	----------------------------------------------------------------------
	$ gjs foo.js

	* gettext-tools/src/format-invalid.h (INVALID_PRECISION_MISSING): New macro.
	* gettext-tools/src/format-java-printf.c (INVALID_PRECISION_MISSING): Remove
	macro.
	* gettext-tools/src/format-javascript.c: Fix comment regarding the precision.
	(format_parse): Report an error if the precision is null (empty).
	* gettext-tools/tests/format-javascript-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	java-printf-format: Reject null precision.
	Proof that it's invalid:
	--------------------------- foo.java ---------------------------
	public class foo {
	  public static void main(String[] args) {
	    System.out.println(String.format("%.f\n", 3.1415926535));
	  }
	}
	----------------------------------------------------------------

	* gettext-tools/tests/format-java-printf-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	go-format: Accept null precision.
	* gettext-tools/src/format-go.c: Clarify comment regarding the precision.
	(format_parse): Accept a null precision after '.'.
	* gettext-tools/tests/format-go-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	elisp-format: Accept null precision.
	Proof that is is valid:
	(format "%.f" 3.1415926)

	* gettext-tools/src/format-elisp.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-elisp-1: Add a test case with null precision.

2025-06-22  Bruno Haible  <bruno@clisp.org>

	d-format: Accept null precision.
	Proof that a null precision is valid:
	------------------------------- foo.d -------------------------------
	import std.stdio;
	import std.format;
	void main () { writeln (format ("%.f", 3.1415926)); }
	---------------------------------------------------------------------

	* gettext-tools/tests/format-d-1: Add a test case with null precision.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	c-format: Accept null precision.
	* gettext-tools/src/format-c-parse.h: Fix comment regarding the precision and
	the ISO C23 size specifiers.
	* gettext-tools/tests/format-c-1: Add a test case with null precision.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	boost-format: Accept null precision.
	* gettext-tools/src/format-boost.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-boost-1: Add a test case with null precision.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	awk-format: Accept null precision.
	Proof that it's valid:
	$ echo 3.1415926 | gawk '{ printf "%.f", $1 }'

	* gettext-tools/src/format-awk.c: Fix comment regarding the precision.
	* gettext-tools/tests/format-awk-1: Add a test case with null precision.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	xgettext: Shell: Reject \u and \U escape sequences that produce surrogates.
	* gettext-tools/src/x-sh.c (read_word): Reject \u and \U values in the range
	0xD800..0xDFFF.
	* gettext-tools/tests/xgettext-sh-9: Add more test cases.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	xgettext: Shell: Bump phase1_pushback buffer size.
	* gettext-tools/src/x-sh.c (phase1_pushback): Bump size to 9.
	* gettext-tools/tests/xgettext-sh-8: Add more test cases.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	xgettext: Shell: Recognize \u and \U escape sequences in $'...' strings.
	* gettext-tools/src/xg-mixed-string.h (mixed_string_remove_prefix,
	mixed_string_buffer_equals, mixed_string_buffer_startswith,
	mixed_string_buffer_cloned_result): New declarations.
	* gettext-tools/src/xg-mixed-string.c (mixed_string_remove_prefix): New
	function.
	(mixed_string_buffer_is_empty): Also test the absence of utf16_surr.
	(mixed_string_buffer_equals, mixed_string_buffer_startswith,
	mixed_string_buffer_cloned_result): New functions.
	* gettext-tools/src/x-sh.c (struct token): Remove type.
	(init_token, free_token, grow_token, string_of_token): Remove functions.
	(struct word): Change type of 'token' field.
	(free_word): Update.
	(string_of_word, substring_of_word): Remove functions.
	(read_word): Call mixed_string_buffer_init instead of init_token,
	mixed_string_buffer_destroy instead of free_token,
	mixed_string_buffer_append_char instead of grow_token. Update accesses to
	wp->token. Recognize \u and \U escape sequences in $'...' strings.
	(read_command): Call mixed_string_buffer_cloned_result instead of
	string_of_word. Update accesses to inner.token.
	* gettext-tools/tests/xgettext-sh-7: Use --from-code option.
	* gettext-tools/tests/xgettext-sh-9: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* NEWS: Mention this and the previous change.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	xgettext: Shell: Recognize \c escape sequences in $'...' strings.
	* gettext-tools/src/x-sh.c (read_word): Recognize \c escape sequences.
	* gettext-tools/tests/xgettext-sh-1: Add test cases with ASCII $'...' strings.

2025-06-21  Bruno Haible  <bruno@clisp.org>

	tests: Avoid a test failure with valgrind.
	* gettext-tools/tests/xgettext-python-9: Filter out the valgrind traces.

2025-06-20  Bruno Haible  <bruno@clisp.org>

	Fix 'make installcheck' failure on Cygwin.
	* gettext-tools/configure.ac (INSTALLED_LIBINTL, INSTALLED_LIBGETTEXTPO_DEPS):
	New variables.
	* gettext-tools/install-tests/Makefile.am (installcheck): Use
	INSTALLED_LIBGETTEXTPO_DEPS.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	Reject the dysfunctional gettext in Solaris libc, other than Solaris 11.4.
	This fixes a 'make installcheck' failure.

	<https://www.illumos.org/issues/13423> has been reported more than 4 years ago.
	I don't have hope that they will fix it, ever.

	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): On Solaris other than
	Solaris 11.4, don't use the gettext() function in libc.
	* gettext-tools/tests/init.cfg (prepare_locale_): Remove function.
	* gettext-tools/tests/format-c-3: Remove prepare_locale_ invocations.
	* gettext-tools/tests/format-c-4: Likewise.
	* gettext-tools/tests/format-c-5: Likewise.
	* gettext-tools/tests/intl-0: Likewise.
	* gettext-tools/tests/intl-1: Likewise.
	* gettext-tools/tests/intl-2: Likewise.
	* gettext-tools/tests/intl-3: Likewise.
	* gettext-tools/tests/intl-4: Likewise.
	* gettext-tools/tests/intl-6: Likewise.
	* gettext-tools/tests/intl-7: Likewise.
	* gettext-tools/tests/intl-thread-1: Likewise.
	* gettext-tools/tests/intl-thread-2: Likewise.
	* gettext-tools/tests/intl-thread-3: Likewise.
	* gettext-tools/tests/lang-bash: Likewise.
	* gettext-tools/tests/lang-c: Likewise.
	* gettext-tools/tests/lang-c++: Likewise.
	* gettext-tools/tests/lang-c++20: Likewise.
	* gettext-tools/tests/lang-c++26: Likewise.
	* gettext-tools/tests/lang-clisp: Likewise.
	* gettext-tools/tests/lang-csharp: Likewise.
	* gettext-tools/tests/lang-d: Likewise.
	* gettext-tools/tests/lang-gawk: Likewise.
	* gettext-tools/tests/lang-go: Likewise.
	* gettext-tools/tests/lang-guile: Likewise.
	* gettext-tools/tests/lang-java: Likewise.
	* gettext-tools/tests/lang-javascript: Likewise.
	* gettext-tools/tests/lang-librep: Likewise.
	* gettext-tools/tests/lang-lua: Likewise.
	* gettext-tools/tests/lang-modula2: Likewise.
	* gettext-tools/tests/lang-objc: Likewise.
	* gettext-tools/tests/lang-pascal: Likewise.
	* gettext-tools/tests/lang-perl-1: Likewise.
	* gettext-tools/tests/lang-perl-2: Likewise.
	* gettext-tools/tests/lang-php: Likewise.
	* gettext-tools/tests/lang-python-1: Likewise.
	* gettext-tools/tests/lang-python-2: Likewise.
	* gettext-tools/tests/lang-ruby: Likewise.
	* gettext-tools/tests/lang-rust: Likewise.
	* gettext-tools/tests/lang-sh: Likewise.
	* gettext-tools/tests/lang-smalltalk: Likewise.
	* gettext-tools/tests/lang-tcl: Likewise.
	* gettext-tools/tests/lang-vala: Likewise.
	* gettext-tools/tests/msgfmt-20: Likewise.
	* gettext-tools/tests/plural-1: Likewise.
	* NEWS: Mention the change.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	Fix 'make installcheck' failure on Cygwin.
	* gettext-runtime/configure.ac (INSTALLED_LIBINTL): Add $LIBICONV.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	Deprecate the gfc-internal-format flag.
	* gettext-tools/src/format-gfc-internal.c: Update comment.
	* gettext-tools/doc/gettext.texi (PO Files): Mark gfc-internal-format as
	deprecated.
	(gfc-internal-format): Mention "up to GCC 14".

2025-06-19  Bruno Haible  <bruno@clisp.org>

	xgettext: GCC-source: Disable gfc-format-internal recognition.
	* gettext-tools/src/x-c.h (SCANNERS_C): Replace formatstring_gfc_internal with
	NULL.
	* gettext-tools/tests/format-gfc-internal-1: Remove file.
	* gettext-tools/tests/Makefile.am (TESTS): Remove it.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	Strengthen gcc-internal-format: Check that %< %>, %r %R, %{ %} come in pairs.
	* gettext-tools/src/format-gcc-internal.c (format_parse): New local variables
	in_quote_group, in_color_group, in_url_group. Add pairing checks for %< %>,
	%r %R, %{ %}.
	* gettext-tools/tests/format-gcc-internal-1: Update.
	* gettext-tools/tests/format-gcc-internal-2: Update.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	Update gcc-internal-format for GCC 15.
	Reported by Roland Illig, Andrew Pinski, Jakub Jelinek in
	<https://gcc.gnu.org/bugzilla/show_bug.cgi?id=119684>.
	Also reported by Roland Illig in
	<https://savannah.gnu.org/bugs/?50450>, <https://savannah.gnu.org/bugs/?50461>.

	* gettext-tools/src/format-gcc-internal.c: Update for GCC 15.
	* gettext-tools/tests/format-gcc-internal-1: Likewise.
	* gettext-tools/tests/format-gcc-internal-2: Likewise.
	* gettext-tools/doc/gettext.texi (gcc-internal-format): Likewise.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	gettext-runtime: Fix "make installcheck" failure on MSVC with --enable-shared.
	* gettext-runtime/intl/Makefile.am (libintl.h): Insert '__declspec (dllimport)'
	in the variable declarations, like in libgnuintl.h.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	gettext-tools: Implement 'installcheck' target.
	* gettext-tools/install-tests/test-version.c: New file.
	* gettext-tools/install-tests/test-api.c: New file.
	* gettext-tools/install-tests/de.po: New file.
	* gettext-tools/install-tests/Makefile.am: New file.
	* gettext-tools/configure.ac (PATH_SEPARATOR, AUGMENT_SHLIBPATH): New variables.
	(AC_CONFIG_FILES): Add install-tests/Makefile.
	* gettext-tools/Makefile.am (SUBDIRS): Add install-tests.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	gettext-runtime: Implement 'installcheck' target.
	* gettext-runtime/install-tests/test-version.c: New file.
	* gettext-runtime/install-tests/test-api.c: New file.
	* gettext-runtime/install-tests/itest.pot: New file.
	* gettext-runtime/install-tests/locale/en_US/LC_MESSAGES/itest.mo: New file.
	* gettext-runtime/install-tests/Makefile.am: New file.
	* gettext-runtime/configure.ac (INSTALLED_LIBINTL, PATH_SEPARATOR,
	AUGMENT_SHLIBPATH): New variables.
	(AC_CONFIG_FILES): Add install-tests/Makefile.
	* gettext-runtime/Makefile.am (SUBDIRS): Add install-tests.

2025-06-19  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Implement 'installcheck' target.
	* libtextstyle/install-tests/test-version.c: New file.
	* libtextstyle/install-tests/test-api.c: New file.
	* libtextstyle/install-tests/Makefile.am: New file.
	* libtextstyle/configure.ac (AUGMENT_SHLIBPATH): New variable.
	(AC_CONFIG_FILES): Add install-tests/Makefile.
	* libtextstyle/Makefile.am (SUBDIRS): Add install-tests.

2025-06-14  Bruno Haible  <bruno@clisp.org>

	build: Simplify.
	* gettext-runtime/configure.ac (LIBSCHED): Remove variable.

2025-06-12  Bruno Haible  <bruno@clisp.org>

	Improve config.log traces.
	* gettext-runtime/m4/progtest.m4 (AM_PATH_PROG_WITH_TEST): Emit the configure
	line number into config.log.

2025-06-08  Bruno Haible  <bruno@clisp.org>

	build: Simplify handling of exported symbols on Windows, part 2.
	* gettext-tools/configure.ac (WINDOWS_MSVC): New conditional.
	* gnulib-local/modules/gettext-tools-misc (Makefile.am): Re-add the
	--export-all-symbols linker option.
	* gettext-tools/src/Makefile.am (libgettextsrc_la_LDFLAGS): Re-add the
	--export-all-symbols linker option.

2025-06-07  Bruno Haible  <bruno@clisp.org>

	gettext.m4: Recognize the shared GNU libintl on MSVC.
	Reported by Kirill Makurin <maiddaisuki@outlook.com>
	in <https://lists.gnu.org/archive/html/bug-m4/2025-06/msg00000.html>.

	* gettext-runtime/m4/gettext.m4 (AM_GNU_GETTEXT): On MSVC, don't try to use
	_nl_msg_cat_cntr.
	* NEWS: Mention it.

2025-06-07  Bruno Haible  <bruno@clisp.org>

	build: Simplify handling of exported symbols on Windows.
	* gnulib-local/modules/gettext-tools-misc (Makefile.am): Don't compile
	gettextlib-exports.c. Don't add now-redundant --export-all-symbols linker
	option. Don't use GETTEXTLIB_EXPORTS_FLAGS.
	* gettext-tools/src/Makefile.am (libgettextsrc_la_SOURCES): Don't add
	gettextsrc-exports.c.
	(libgettextsrc_la_LDFLAGS): Don't add now-redundant --export-all-symbols linker
	option.
	(libgettextsrc_la_CPPFLAGS): Don't add $(GETTEXTLIB_EXPORTS_FLAGS).
	* gettext-tools/configure.ac (GETTEXTLIB_EXPORTS_FLAGS): Remove variable.
	* gettext-tools/woe32dll/gettextlib-exports.c: Remove file.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Remove file.
	* gettext-tools/woe32dll/export.h: Update comments.

2025-06-06  Bruno Haible  <bruno@clisp.org>

	build: Fix build error on MSVC with --enable-shared.
	* autogen.sh: Avoid the float-h-tests, since they reference the variables
	gl_FLT_SNAN, gl_DBL_SNAN, gl_LDBL_SNAN.

2025-06-06  Bruno Haible  <bruno@clisp.org>

	build: Fix build failure on Cygwin and mingw without preinstalled libunistring.
	* gettext-tools/configure.ac: Define DLL_VARIABLE and LIBGETTEXTSRC_DLL_VARIABLE
	on Cygwin and mingw like on MSVC.

2025-06-06  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix build failure on Cygwin < 3.4.6.
	* libtextstyle/lib/Makefile.am (config.h): Don't rename the _imp_ variable
	associated with the gl_get_setlocale_null_lock function.

2025-06-05  Bruno Haible  <bruno@clisp.org>

	tests: xgettext-scheme-6: Fix potential conflict with xgettext-scheme-7.
	* gettext-tools/tests/xgettext-scheme-6: Use common file name idiom.

2025-06-05  Bruno Haible  <bruno@clisp.org>

	build: Fix "make install" in MSVC builds with --enable-shared.
	The problem was that intl-8.dll was not installed with execute permissions.

	* gettext-runtime/intl/Makefile.am (install-exec-libintl): Use $(INSTALL),
	not $(INSTALL_DATA), with libtool --mode=install.
	* INSTALL.windows: Remove constraint to use --disable-shared on MSVC.

2025-06-05  Bruno Haible  <bruno@clisp.org>

	build: Fix MSVC builds with --enable-shared.
	This was a regression in commit 8e914861708ed459a2ae8157eb60d89375ab46cd
	from 2023-09-06.

	Thanks to Kirill Makurin <maiddaisuki@outlook.com> for fruitful discussions.

	* autogen.sh: Among the gnulib-tests, avoid the modules array-map-tests,
	array-oset-tests, carray-list-tests, and uninorm/decomposing-form-tests, since
	they use variables from libgettextlib.
	* gettext-tools/configure.ac (GL_GNULIB_LIBUNISTRING_DLL_VARIABLE_NAME): New
	variable.
	(WOE32DLL): New C macro.
	(DLL_VARIABLE): On MSVC with --enable-shared, define to '__declspec(dllexport)'
	when compiling libgettextlib, and define to '__declspec(dllimport)' when
	compiling the programs in src/.
	(LIBGETTEXTSRC_DLL_VARIABLE): New C macro.
	* gettext-tools/gnulib-lib/Makefile.am (AM_CPPFLAGS): Define the C macro
	IN_LIBGETTEXTLIB.
	* gettext-tools/src/Makefile.am (libgettextsrc_la_CPPFLAGS): Define the C macro
	IN_LIBGETTEXTSRC.
	* gettext-tools/src/format.h: Use LIBGETTEXTSRC_DLL_VARIABLE instead of
	DLL_VARIABLE.
	* gettext-tools/src/message.h: Likewise.
	* gettext-tools/src/msgl-cat.h: Likewise.
	* gettext-tools/src/plural-table.h: Likewise.
	* gettext-tools/src/po-charset.h: Likewise.
	* gettext-tools/src/po-error.h: Likewise.
	* gettext-tools/src/read-catalog.h: Likewise.
	* gettext-tools/src/read-po.h: Likewise.
	* gettext-tools/src/read-properties.h: Likewise.
	* gettext-tools/src/read-stringtable.h: Likewise.
	* gettext-tools/src/sentence.h: Likewise.
	* gettext-tools/src/write-po.h: Likewise.
	* gettext-tools/src/write-properties.h: Likewise.
	* gettext-tools/src/write-stringtable.h: Likewise.
	* gettext-tools/src/xerror-handler.h: Likewise.
	* gettext-tools/libgettextpo/Makefile.am (config.h): Override the value of
	LIBGETTEXTSRC_DLL_VARIABLE.
	* gettext-runtime/configure.ac (WOE32DLL): New C macro.
	(DLL_VARIABLE): Define to empty always.

2025-06-05  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-06-05  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on MSVC due to conflict of different stdlib.h files.
	Reported by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-05/msg00071.html>.

	* autogen.sh: Change gnulib-tool invocation for libgrep.
	* gettext-tools/configure.ac (AC_CONFIG_FILES): Add libgrep/gnulib-lib/Makefile.
	* gettext-tools/libgrep/Makefile.am: Don't include Makefile.gnulib.
	(SUBDIRS): New variable.
	(noinst_LIBRARIES): Add libgrep.a.
	(AM_CPPFLAGS): Add -I options for gnulib-lib subdirectory.
	(libgrep_a_DEPENDENCIES): New variable.
	* gettext-tools/libgrep/gnulib-lib/Makefile.am: New file.
	* gettext-tools/src/Makefile.am (LIBGREP): Add ../libgrep/gnulib-lib/libgnu.a.

2025-06-03  Bruno Haible  <bruno@clisp.org>

	build: Fix some crashes when building with --enable-shared on MSVC, part 2.
	* gettext-tools/woe32dll/gettextlib-exports.c: Export also
	gl_carray_list_implementation, gl_hash_map_implementation,
	gl_hash_set_implementation, gl_linked_list_implementation.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	tests: Fix test failure when rxgettext is not installed.
	* gettext-tools/tests/format-ruby-3: Skip test if rxgettext is not installed.

2025-06-02  Collin Funk  <collin.funk1@gmail.com>

	Update a country name.
	* gettext-tools/doc/ISO_3166: Use "Eswatini" instead of "Swaziland".
	* gettext-tools/doc/iso-3166.texi: Likewise.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	Add a NEWS entry.
	* NEWS: Mention the format string heuristic improvements.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Tcl: Improve heuristic for format strings.
	* gettext-tools/src/format-tcl.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_tcl): Use it.
	* gettext-tools/tests/format-tcl-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Ruby: Improve heuristic for format strings.
	* gettext-tools/src/format-ruby.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_ruby): Use it.
	* gettext-tools/tests/format-ruby-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Python: Improve heuristic for format strings.
	* gettext-tools/src/format-python.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_python): Use it.
	* gettext-tools/tests/format-python-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: PHP: Improve heuristic for format strings.
	* gettext-tools/src/format-php.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_php): Use it.
	* gettext-tools/tests/format-php-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Perl: Improve heuristic for format strings.
	* gettext-tools/src/format-perl.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_perl): Use it.
	* gettext-tools/tests/format-perl-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: librep: Improve heuristic for format strings.
	* gettext-tools/src/format-librep.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_librep): Use it.
	* gettext-tools/tests/format-librep-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: JavaScript: Improve heuristic for format strings.
	* gettext-tools/src/format-javascript.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_javascript): Use it.
	* gettext-tools/tests/format-javascript-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Go: Improve heuristic for format strings.
	* gettext-tools/src/format-go.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_go): Use it.
	* gettext-tools/tests/format-go-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Emacs Lisp: Improve heuristic for format strings.
	* gettext-tools/src/format-elisp.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_elisp): Use it.
	* gettext-tools/tests/format-elisp-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: D: Improve heuristic for format strings.
	* gettext-tools/src/format-d.c (struct spec): Add field
	'likely_intentional_directives'.
	(parse_upto): Increment it for each directive that don't contain a space.
	(format_parse): Initialize it.
	(format_is_unlikely_intentional): New function.
	(formatstring_d): Use it.
	* gettext-tools/tests/format-d-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: C++: Improve heuristic for Boost format strings.
	* gettext-tools/src/format-boost.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_boost): Use it.
	* gettext-tools/tests/format-boost-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: C: Improve heuristic for format strings.
	* gettext-tools/src/format-c-parse.h (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse_entrails): Set it to the number of directives that don't contain
	a space.
	* gettext-tools/src/format-c.c (format_is_unlikely_intentional): Also test the
	'likely_intentional_directives' field.
	* gettext-tools/tests/format-c-6: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	xgettext: awk: Improve heuristic for format strings.
	* gettext-tools/src/format-awk.c (struct spec): Add field
	'likely_intentional_directives'.
	(format_parse): Set it to the number of directives that don't contain a space.
	(format_is_unlikely_intentional): New function.
	(formatstring_awk): Use it.
	* gettext-tools/tests/format-awk-3: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-06-02  Bruno Haible  <bruno@clisp.org>

	D: Fix handling of %% directive in format string parser.
	* gettext-tools/src/format-d.c (parse_upto): Add matching FMTDIR_END also for
	the %% directive.

2025-06-01  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from "gcc -Wextra".
	Reported by Collin Funk in
	<https://lists.gnu.org/archive/html/bug-gnulib/2025-05/msg00280.html>.

	* gnulib-local/lib/gettext.h (gettext, dgettext, dcgettext): Silence
	-Wbuiltin-declaration-mismatch warning.

2025-06-01  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on Solaris 11 (regr. 2025-05-28).
	* gnulib-local/lib/gettext.h (gettext, dgettext, dcgettext): On Solaris, use
	'char *' as return type.

2025-05-31  Bruno Haible  <bruno@clisp.org>

	build: Fix some crashes when building with --enable-shared on MSVC.
	Reported by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-05/msg00087.html>.

	* gnulib-local/lib/gl_carray_list.h.diff: New file.
	* gnulib-local/lib/gl_hash_map.h.diff: New file.
	* gnulib-local/lib/gl_hash_set.h.diff: New file.
	* gnulib-local/lib/gl_linked_list.h.diff: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add them.

2025-05-31  Bruno Haible  <bruno@clisp.org>

	build: Mark automake 1.18 as supported.
	* autogen.sh: Update comment.
	* m4/fixautomake.m4 (FIX_MAKEFILE_DISTRIB): Likewise.

2025-05-31  Bruno Haible  <bruno@clisp.org>

	doc: For MSVC, recommend to avoid the preinstalled libunistring.
	This fixes an "initializer is not a constant" error upon use of uninorm_nfc.
	Reported by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-05/msg00076.html>.

	* INSTALL.windows: For MSVC, recommend --with-included-libunistring.

2025-05-31  Bruno Haible  <bruno@clisp.org>

	build: Tweak option for MSVC.
	Suggested by Kirill Makurin <maiddaisuki@outlook.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-05/msg00071.html>.

	* gettext-tools/src/Makefile.am (xgettext_LDFLAGS): Use an MSVC option with '-'
	instead of '/', for resilience against the (unsupported) MSYS2.

2025-05-28  Bruno Haible  <bruno@clisp.org>

	Avoid gcc -Wformat-security warnings with --disable-nls.
	Reported by Holger Hoffstätte <holger@applied-asynchrony.com> in
	<https://lists.gnu.org/archive/html/bug-gnulib/2025-05/msg00225.html>.

	* gnulib-local/lib/gettext.h (gettext, dgettext, dcgettext): With gcc in C mode,
	define these as inline functions.

2025-05-20  Bruno Haible  <bruno@clisp.org>

	xgettext: JavaScript: Parse RegExp literals according to ECMA-262 15th edition.
	Reported by Christian Wasserthal <aperion@fsfe.org> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-05/msg00038.html>.

	* gettext-tools/src/x-javascript.c (phase5_scan_regexp): Report an error when
	end-of-line is reached. Parse character classes. Recognize more modifier flags.
	* gettext-tools/tests/xgettext-javascript-2: Add two more test cases.
	* NEWS: Mention the change.

2025-05-16  Bruno Haible  <bruno@clisp.org>

	doc: Update, now that autopull.sh does more than a gnulib checkout.
	* autogen.sh: Update comments.
	* HACKING: Improve formatting.

2025-05-11  Bruno Haible  <bruno@clisp.org>

	Refactor: Fix a compiler warning.
	* gettext-tools/src/x-perl.c: Remove a stray ';'.

2025-05-11  Bruno Haible  <bruno@clisp.org>

	Refactor: Fix typo in function name.
	* gettext-tools/src/x-d.c (extract_from_template_instantiation): Renamed from
	extract_from_template_instantation.

2025-05-11  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/src/msgl-iconv.h (convert_string_desc_directly): Change result
	type to rw_string_desc_t.
	* gettext-tools/src/msgl-iconv.c (convert_string_desc_directly): Likewise.
	* gettext-tools/src/its.c (_its_is_valid_simple_gen_xml): Omit casts to
	'char *'. Don't use sd_c_casecmp, sd_cmp as function pointers.
	* gettext-tools/src/xg-encoding.h (string_desc_from_current_source_encoding):
	Change result type to rw_string_desc_t.
	* gettext-tools/src/xg-encoding.c (from_current_source_encoding): Return
	converted result directly, without a cast.
	(string_desc_from_current_source_encoding): Change result type to
	rw_string_desc_t. Return converted result directly, without a cast. Invoke
	sd_readwrite.
	* gettext-tools/src/x-perl.c (get_here_document): Add benign cast.
	(extract_quotelike_pass1, extract_quotelike_pass1_utf8): Change result type to
	rw_string_desc_t.
	(extract_quotelike, extract_triple_quotelike): Update.
	(extract_quotelike_pass3): Add benign casts.
	(interpolate_keywords): Don't call sd_set_char_at on a string_desc_t.
	* gettext-tools/src/x-d.c (handle_comments, is_string_literal,
	string_literal_accumulate_pieces, extract_from_function_call,
	extract_from_function_call_without_args, extract_from_template_instantation,
	extract_from_node): Omit casts to 'char *'.
	* gettext-tools/src/x-go.c (string_literal_accumulate_pieces,
	string_literal_value, scan_import_spec, get_type_from_type_identifier_node,
	get_type_from_type_node, store_type_declaration, get_mvtypes_of_expression,
	store_var_spec, store_const_spec, store_function_declaration,
	augment_for_type_declaration, augment_for_parameter_list, augment_for_var_spec,
	augment_for_const_spec, augment_for_short_variable_declaration, handle_comments,
	extract_from_function_call, extract_from_node): Omit casts to 'char *'.
	* gettext-tools/src/x-rust.c (handle_comments, string_literal_value): Omit casts
	to 'char *'. Add benign casts.
	(extract_from_function_call, extract_from_function_call_like,
	extract_from_node): Omit casts to 'char *'.
	* gettext-tools/src/x-typescript-impl.h (handle_comments,
	sbru_prepend_lone_surrogate): Omit casts to 'char *'.
	(sbru_xprepend_unicode): Add benign casts.
	(string_literal_accumulate_pieces, string_literal_value,
	extract_from_function_call, extract_from_node): Omit casts to 'char *'.

2025-05-11  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 0.25.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.25.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.
	* gettext-runtime/po/*.po: Update from TP.
	* gettext-tools/po/*.po: Update from TP.
	* gettext-tools/examples/po/*.po: Update from TP.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	Prepare for 0.25 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/po/Makefile.in.in: Update Origin.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:4:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:5:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:14:5.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.25.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.25.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	doc: Clarify how to obtain the various autoconf macros.
	* gettext-tools/doc/gettext.texi (autoconf macros): Suggest to use gettextize or
	autopoint. Discourage autoreconf.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	Update .gitignore.

2025-05-07  Bruno Haible  <bruno@clisp.org>

	Update to a newer gnulib.

2025-05-06  Bruno Haible  <bruno@clisp.org>

	intl-modula2: Try to fix a build failure on macOS.
	* gettext-runtime/intl-modula2/Makefile.am (libintl_m2_la_LDFLAGS): Revert last
	two commits. Instead, use -L and -l options.

2025-05-06  Bruno Haible  <bruno@clisp.org>

	tests: Avoid xgettext-git-1 failure on AIX.
	* gettext-tools/tests/xgettext-git-1: Don't use shell pattern matching with
	braces.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	intl-modula2: Try to fix a build failure on macOS.
	* gettext-runtime/intl-modula2/Makefile.am (libintl_m2_la_LIBADD): Avoid
	automake error.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	intl-modula2: Try to fix a build failure on macOS.
	* gettext-runtime/intl-modula2/Makefile.am (libintl_m2_la_LIBADD): New variable.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	PACKAGING: Revisit intl-d and intl-modula2 packaging.
	* PACKAGING: Suggest packaging libintl_d and libintl_m2 each in a separate
	package.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	tests: Avoid xgettext-git-1 failure on native Windows.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	doc: xgettext: More doc regarding --generated.
	Suggested by Vaclav Slavik <vaclav@slavik.io>
	at <https://savannah.gnu.org/bugs/?66916>.

	* gettext-tools/doc/xgettext.texi: Mention the --generated option in the
	--files-from description.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	doc: Update list of examples.
	* gettext-tools/doc/lang-c.texi: Update the list of examples.
	* gettext-tools/doc/lang-ruby.texi: Mention the hello-ruby example.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	tests: Avoid a lang-modula2 failure.
	* gettext-tools/tests/lang-modula2: Skip the test if gm2 is not working.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	tests: Add a comment regarding a lang-modula2 failure.
	* gettext-tools/tests/lang-modula2: Add comment.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	intl-modula2: Fix a build failure on Ubuntu 22.04.
	* gettext-runtime/configure.ac: Substitute M2SHLIBEXT.
	* gettext-runtime/intl-modula2/Makefile.am (libintl_m2_la_LDFLAGS): Attempt
	harder to find the libm2pim library.

2025-05-05  Bruno Haible  <bruno@clisp.org>

	build: Avoid possible problems due to AC_REQUIRE in if/else branches.
	* gettext-runtime/configure.ac: Use AS_IF when at least one of the if/else
	branches invokes a complicated Autoconf macro.
	* gettext-tools/configure.ac: Likewise.

2025-05-04  Bruno Haible  <bruno@clisp.org>

	Avoid some clang -Wthread-safety-analysis warnings.
	* gettext-tools/src/x-typescript-impl.h (sbru_init): Declare with
	_GL_ATTRIBUTE_ACQUIRE_CAPABILITY.
	(sbru_xdupfree_c): Declare with _GL_ATTRIBUTE_RELEASE_CAPABILITY.

2025-05-04  Bruno Haible  <bruno@clisp.org>

	xgettext: Allow ignoring specific files in the POT-Creation-Date computation.
	Reported by Vaclav Slavik <vaclav@slavik.io>
	at <https://savannah.gnu.org/users/vslavik>.

	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add hashkey-string, set.
	* gettext-tools/src/xgettext.c: Include gl_set.h, gl_xset.h, gl_hash_set.h,
	hashkey-string.h.
	(generated_files): New variables.
	(long_options): New option '--generated'.
	(main): Initialize generated_files. Handle the option '--generated'.
	(usage): Document the option '--generated'.
	(finalize_header): Filter out the generated_files from the file list.
	* gettext-tools/doc/xgettext.texi: Document the option '--generated'.
	* gettext-tools/tests/xgettext-git-1: Test the --generated option.
	* NEWS: Mention the new option.

2025-05-04  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-05-04  Bruno Haible  <bruno@clisp.org>

	Update release steps.

2025-05-03  Bruno Haible  <bruno@clisp.org>

	doc: Clarify that the minimum needed GCC version is 4.4.
	Rationale: With GCC version 4.1.2 or 4.2.1, all tree-sitter based extractors
	in xgettext crash at runtime when compiled with optimization. Whereas
	GCC 4.4.7 works fine.

	* DEPENDENCIES: State "GCC 4.4 or newer".

2025-05-03  Bruno Haible  <bruno@clisp.org>

	xgettext: D: Work around a gcc miscompilation bug.
	* gettext-tools/build-aux/tree-sitter-d-optimization-bug.diff: New file.
	* autopull.sh: Apply it.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	Merge from 0.24.x branch: Prepare for 0.24.1 release.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.24.1.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.24.1.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	build: Update after recent gettextize fix.
	* gettext-tools/misc/add-to-archive: Look up the *.m4 files in
	$datadir/gettext/m4, not $datadir/aclocal.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Give a hint about --no-git when max_vc_mtime() took more than 10 sec.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add getrusage.
	* gettext-tools/src/xgettext.c: Include <sys/resource.h>.
	(max_mtime): New function.
	(finalize_header): Invoke it.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Add an option to opt-out of the use of git for the POT-Creation-Date.
	Reported by Serhii Tereshchenko at <https://savannah.gnu.org/bugs/?66865>.

	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add stat-time.
	* gettext-tools/src/xgettext.c: Include stat-time.h.
	(xgettext_no_git): New variable.
	(long_options): Add option '--no-git'.
	(main): Handle the option --no-git.
	(usage): Document the option --no-git.
	(struct accumulator): New type, copied from gnulib/lib/vc-mtime.c.
	(accumulate): New function, copied from gnulib/lib/vc-mtime.c.
	(max_mtime_without_git): New function, based on gnulib/lib/vc-mtime.c.
	(finalize_header): Conditionally invoke max_mtime_without_git instead of
	max_vc_mtime.
	* gettext-tools/doc/xgettext.texi: Document the option --no-git.
	* NEWS: Mention the change.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	tests: Fix test failure with git versions < 2.23.
	* gettext-tools/tests/xgettext-git-1: Use 'git checkout' instead of
	'git restore'.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	xgettext: Speed up the computation of the POT-Creation-Date.
	Reported by Serhii Tereshchenko, Arthur, Adam YS, Foucauld Degeorges
	at <https://savannah.gnu.org/bugs/?66865>.

	* gettext-tools/src/xgettext.c (has_some_mtimes, max_of_mtimes, some_mtimes_failed): Remove variables.
	(files_for_vc_mtime): New variable.
	(main): Initialize files_for_vc_mtime. Update files_for_vc_mtime instead of calling consider_vc_mtime.
	(consider_vc_mtime): Remove function.
	(read_exclusion_file, extract_from_file, extract_from_xml_file): Update files_for_vc_mtime instead of calling consider_vc_mtime.
	(finalize_header): Call max_vc_mtime.
	* NEWS: Mention the speedup.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-05-02  Bruno Haible  <bruno@clisp.org>

	tests: Add a test for xgettext's computation of the POT-Creation-Date.
	* gettext-tools/tests/testdata/repo.tar.gz: New file.
	* gettext-tools/tests/xgettext-git-1: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	(EXTRA_DIST): Add testdata/repo.tar.gz.

2025-04-30  Bruno Haible  <bruno@clisp.org>

	build: Take the mem-hash-map module from Gnulib now, part 2.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add next-prime.
	* gettext-tools/src/write-mo.c: Include next-prime.h.
	* gettext-tools/src/write-qt.c: Likewise.

2025-04-30  Bruno Haible  <bruno@clisp.org>

	build: Take the mem-hash-map module from Gnulib now.
	* gnulib-local/lib/mem-hash-map.h: Remove file.
	* gnulib-local/lib/mem-hash-map.c: Remove file.
	* gnulib-local/modules/mem-hash-map: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.

2025-04-30  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	* gnulib-local/lib/hash.h.diff: Remove file.
	* gnulib-local/lib/hash.c.diff: Remove file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Remove them.
	* autogen.sh: Avoid module hashcode-string1.

2025-04-29  Bruno Haible  <bruno@clisp.org>

	build: Ignore -Wduplicated-branches warnings.
	* m4/more-warnings.m4 (gt_MORE_WARNINGS): Don't add the -Wduplicated-branches
	option.

2025-04-28  Bruno Haible  <bruno@clisp.org>

	Modula-2: Fix linking of libintl_m2 on non-ELF platforms.
	* gettext-runtime/intl-modula2/Makefile.am (libintl_m2_la_LDFLAGS): Link with
	libm2pim.la.

2025-04-28  Bruno Haible  <bruno@clisp.org>

	tests: Support older GNU Modula-2 compilers.
	* gettext-tools/tests/lang-modula2: Don't use the option -fscaffold-main.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Simplify build system.
	* gettext-runtime/intl-modula2/Makefile.am (nodist_m2include_HEADERS): New
	variable.
	(installdirs-modula2-sources, uninstall-modula2-sources): Remove rules.
	(install-data-local, installdirs-local, uninstall-local): Remove dependencies.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Fix VPATH builds.
	* gettext-runtime/intl-modula2/Makefile.am (install-modula2-sources): Take
	Libintl.def from the build dir, not from the source dir.
	* gettext-tools/tests/lang-modula2: Search for Libintl.def in the build dir,
	not in the source dir.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-modula2 example.
	* gettext-tools/examples/hello-modula2/INSTALL: New file.
	* gettext-tools/examples/hello-modula2/autogen.sh: New file.
	* gettext-tools/examples/hello-modula2/autoclean.sh: New file.
	* gettext-tools/examples/hello-modula2/hello.mod.in: New file.
	* gettext-tools/examples/hello-modula2/Makefile.am: New file.
	* gettext-tools/examples/hello-modula2/configure.ac: New file.
	* gettext-tools/examples/hello-modula2/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-modula2/po/LINGUAS: New file.
	* gettext-tools/examples/hello-modula2/po/Makefile.am: New file.
	* gettext-tools/examples/installpaths.in: Define also libdir.
	* gettext-tools/m4/Makefile.am (examplesbuildaux_DATA): Add modula2comp.m4.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-modula2.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-modula2.
	(hello-modula2.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-modula2.
	($(srcdir)/../hello-modula2/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-modula2 as well.
	* gettext-tools/examples/README: Mention hello-modula2.
	* gettext-tools/doc/lang-modula2.texi: Likewise.
	* NEWS: Likewise.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Add a unit test.
	* autogen.sh (GNULIB_MODULES_TOOLS_OTHER): Add modula2, modula2comp-script.
	* gettext-tools/configure.ac: Set and substitute BUILDMODULA2.
	* gettext-tools/tests/init-env.in: Propagate MODULA2_CHOICE, BUILDMODULA2, M2C,
	M2FLAGS.
	* gettext-tools/tests/lang-modula2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Add Modula-2 support in the tools.
	* gettext-tools/doc/lang-modula2.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (PO Files): Mention modula2-format.
	(No string concatenation): Mention string concatenation in Modula-2.
	(Translators for other Languages): New subsection "Modula-2 Format Strings".
	(List of Programming Languages): Include lang-modula2.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L Modula-2 option.
	* gettext-tools/src/message.h (format_modula2): New enum value.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_modula2.
	* gettext-tools/src/format-modula2.c: New file.
	* gettext-tools/src/format.h (formatstring_modula2): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add formatstring_modula2.
	* gettext-tools/src/x-modula2.h: New file.
	* gettext-tools/src/x-modula2.c: New file.
	* gettext-tools/src/xgettext.c: Include x-modula2.h.
	(flag_table_modula2): New variable.
	(main): Invoke init_flag_table_modula2, x_modula2_extract_all,
	x_modula2_keyword.
	(usage): Document the -L Modula-2 option.
	(xgettext_record_flag): Support format_modula2.
	(language_to_extractor, extension_to_language): Support Modula-2.
	* gettext-tools/src/FILES: Mention format-modula2.c, x-modula2.h, x-modula2.c.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add x-modula2.h.
	(FORMAT_SOURCE): Add format-modula2.c.
	(xgettext_SOURCES): Add x-modula2.c.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-modula2.c.
	* gettext-tools/po/POTFILES.in: Add src/format-modula2.c, src/x-modula2.c.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Export formatstring_modula2.
	* gettext-tools/tests/format-modula2-1: New file.
	* gettext-tools/tests/format-modula2-2: New file.
	* gettext-tools/tests/xgettext-modula2-1: New file.
	* gettext-tools/tests/xgettext-modula2-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	* NEWS: Mention the Modula-2 support.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Modula-2 support: Add the runtime library.
	* gnulib-local/m4/modula2.m4: New file.
	* gnulib-local/modules/modula2: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add modula2.m4 and the 'modula2'
	module.
	* autogen.sh (GNULIB_MODULES_RUNTIME_OTHER): Add modula2, modula2comp-script.
	* gettext-runtime/intl-modula2/Libintl.def.in: New file.
	* gettext-runtime/intl-modula2/Libintl.mod: New file.
	* gettext-runtime/intl-modula2/LibintlFromC.def: New file.
	* gettext-runtime/intl-modula2/Makefile.am: New file.
	* gettext-runtime/intl-modula2/HACKING: New file.
	* gettext-runtime/configure.ac: Invoke gt_MODULA2_CHOICE, gt_MODULA2COMP.
	Determine VALUE_OF_LC_* for each LC_* constant. Set the variable BUILDMODULA2
	and the Automake conditional BUILD_MODULA2.
	* gettext-runtime/Makefile.am (SUBDIRS): Add intl-modula2.
	* NEWS: Mention libintl_m2.so.
	* gettext-runtime/NEWS: Likewise.
	* PACKAGING: Add the interface and binary for the libintl_m2 library.
	* DEPENDENCIES: Mention the Modula-2 compiler and runtime.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	examples: Fix the D example.
	* gettext-tools/Makefile.am (examplesbuildaux_DATA): Add dcomp.sh.in.
	* gettext-tools/m4/Makefile.am (examplesbuildaux_DATA): Add dcomp.m4.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	examples: Fix the Go examples.
	* gettext-tools/Makefile.am (examplesbuildaux_DATA): Add gocomp.sh.in.
	* gettext-tools/m4/Makefile.am (examplesbuildaux_DATA): Add gocomp.m4.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	examples: Fix the C# examples.
	* gettext-tools/m4/Makefile.am (examplesbuildaux_DATA): Add csharp.m4.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	examples: Fix reference to examples/build-aux/ directory (regr. 2005-03-22).
	* gettext-tools/examples/installpaths.in (EXAMPLESCONFIGDIR): Correct value.

2025-04-25  Bruno Haible  <bruno@clisp.org>

	tests: Fix the lang-d test.
	* gettext-tools/tests/lang-d: Reencode in ISO-8859-1 encoding.

2025-04-24  Bruno Haible  <bruno@clisp.org>

	intl: Export libintl_{new,dup,free}locale from libintl.so on OpenBSD.
	Reported by Christian Weisgerber <naddy@mips.inka.de>.

	* gnulib-local/lib/getlocalename_l-unsafe.c.diff: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add it.
	* gettext-runtime/intl/configure.ac (rpl_newlocale, rpl_duplocale,
	rpl_freelocale): Redirect to symbols prefixed with 'libintl_', not '_libintl_'.
	* gettext-runtime/intl/Makefile.am (BUILT_SOURCES): Add libgnuintl.h.

2025-04-24  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-04-23  Bruno Haible  <bruno@clisp.org>

	xgettext: D: Allow comments between the parts of concatenated string literals.
	* gettext-tools/src/x-d.c (is_add_expression_with_tilde): New function.
	(is_string_literal, string_literal_accumulate_pieces): Use it.
	* gettext-tools/tests/xgettext-d-2: Add another test case regarding string
	concatenation.

2025-04-23  Bruno Haible  <bruno@clisp.org>

	xgettext: Go: More unit tests.
	* gettext-tools/tests/xgettext-go-6: Add more test cases regarding string
	concatenation.

2025-04-23  Bruno Haible  <bruno@clisp.org>

	Refactor: Make format-lua.c more similar to format-elisp.c.
	* gettext-tools/src/format-lua.c (format_parse): Allocate the final spec on the
	heap only once parsing was successful.

2025-04-22  Bruno Haible  <bruno@clisp.org>

	build: Simplify.
	* gettext-runtime/configure.ac: Don't test whether setlocale exists.

2025-04-16  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gitsub.sh: Update from gnulib.

2025-04-15  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* libtextstyle/autogen.sh: Don't avoid module 'locale-h'. vasnprintf now needs
	localeconv, and localeconv depends on locale-h.

2025-04-15  Bruno Haible  <bruno@clisp.org>

	build: Simplify D configuration-time support.
	* gettext-runtime/configure.ac: Don't search for the D compiler a second time
	(already done by gt_DCOMP).
	* gettext-tools/configure.ac: Likewise.

2025-04-02  Bruno Haible  <bruno@clisp.org>

	build: Simplify last commit.
	* gettext-tools/src/Makefile.am (LIBXGETTEXTX): Remove variable.

2025-04-02  Bruno Haible  <bruno@clisp.org>

	build: Make it possible to compile x-go.c with GCC 11 in 1 GB of RAM.
	* gettext-tools/src/Makefile.am (LIBXGETTEXTX, libxgettextx_a_SOURCES,
	libxgettextx_a_CPPFLAGS, libxgettextx_a_CFLAGS): New variables.
	(xgettext_SOURCES): Remove x-go.c.
	(noinst_LIBRARIES, xgettext_LDADD, xgettext_DEPENDENCIES): Add $(LIBXGETTEXTX).

2025-04-02  Bruno Haible  <bruno@clisp.org>

	build: Make it possible to compile tree-sitter with GCC 11 in 1 GB of RAM.
	* gettext-tools/src/Makefile.am (libxgettextts1_a_CFLAGS,
	libxgettextts2_a_CFLAGS, libxgettextts3_a_CFLAGS, libxgettextts4_a_CFLAGS): New
	variables.

2025-04-02  Bruno Haible  <bruno@clisp.org>

	gettextize: Fix last commit.
	* gettext-tools/m4/Makefile.am (OLD_M4_FILES): New variable.
	(uninstall-macros): Delete only these files from @aclocaldir@.

2025-04-02  Bruno Haible  <bruno@clisp.org>

	gettextize: Fix bad interactions between autoreconf and autopoint.
	Reported by Sebastian Pipping <sebastian@pipping.org>
	in <https://savannah.gnu.org/bugs/index.php?66968>.

	* gettext-tools/m4/Makefile.am (aclocaldir): Remove variable.
	(pkgdatadir, macrosdir): Add variables.
	(macros_DATA): Renamed from aclocal_DATA.
	(install-data-local, uninstall-local, uninstall-macros): New targets.
	* gettext-tools/misc/gettextize.in: Copy the *.m4 files from
	$datadir/gettext/m4, not from $datadir/aclocal.
	* gettext-tools/doc/gettext.texi (aclocal): Don't recommend to add option
	--install to ACLOCAL_MFLAGS. Instead, recommend one-time use of --system-acdir.
	* PACKAGING: Expect *.m4 files in $prefix/share/gettext/m4, not in
	$prefix/share/aclocal.
	* NEWS: Mention the fix.

2025-04-02  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-d example.
	* gettext-tools/examples/hello-d/INSTALL: New file.
	* gettext-tools/examples/hello-d/autogen.sh: New file.
	* gettext-tools/examples/hello-d/autoclean.sh: New file.
	* gettext-tools/examples/hello-d/hello.d.in: New file.
	* gettext-tools/examples/hello-d/Makefile.am: New file.
	* gettext-tools/examples/hello-d/configure.ac: New file.
	* gettext-tools/examples/hello-d/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-d/po/LINGUAS: New file.
	* gettext-tools/examples/hello-d/po/Makefile.am: New file.
	* gettext-tools/examples/installpaths.in: Define also includedir.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add hello-d.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for hello-d.
	(hello-d.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-d.
	($(srcdir)/../hello-d/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-d as well.
	* gettext-tools/examples/README: Mention hello-d.
	* gettext-tools/doc/lang-d.texi: Likewise.
	* NEWS: Likewise.

2025-04-01  Bruno Haible  <bruno@clisp.org>

	D support: Add a unit test.
	* autogen.sh (GNULIB_MODULES_TOOLS_OTHER): Add d, dcomp-script.
	* gettext-tools/configure.ac: Set and substitute BUILDD.
	* gettext-tools/tests/init-env.in: Propagate D_CHOICE, BUILDD.
	* gettext-tools/tests/lang-d: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2025-04-01  Bruno Haible  <bruno@clisp.org>

	D support: Add D support in the tools.
	* autopull.sh: Check out tree-sitter-d. Set TREE_SITTER_D_VERSION.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add unistr/u16-check,
	unistr/u16-to-u8, unistr/u32-check, unistr/u32-to-u8.
	* gettext-tools/build-aux/tree-sitter-d-portability.diff: New file.
	* gettext-tools/configure.ac: Set TREE_SITTER_D_VERSION.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add the tree-sitter-d source code and
	patch.
	* gettext-tools/doc/lang-d.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (PO Files): Mention d-format.
	(No string concatenation): Mention string concatenation and string interpolation
	in D.
	(Translators for other Languages): New subsection "D Format Strings".
	(List of Programming Languages): Include lang-d.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L D option.
	* gettext-tools/src/message.h (format_d): New enum value.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_d.
	* gettext-tools/src/format-d.c: New file, based on
	gettext-tools/src/format-lisp.c.
	* gettext-tools/src/format.h (formatstring_d): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add formatstring_d.
	* gettext-tools/src/x-d.h: New file.
	* gettext-tools/src/x-d.c: New file, based on gettext-tools/src/x-rust.c and
	gettext-tools/src/x-go.c.
	* gettext-tools/src/html5-entities.h: New file.
	* gettext-tools/src/xgettext.c: Include x-d.h.
	(flag_table_d): New variable.
	(main): Invoke init_flag_table_d, x_d_extract_all, x_d_keyword.
	(usage): Document the -L D option.
	(xgettext_record_flag): Support format_d.
	(language_to_extractor, extension_to_language): Support D.
	* gettext-tools/src/xg-message.c (decide_is_format, remember_a_message_plural):
	Add better heuristic for c-format and d-format.
	* gettext-tools/src/FILES: Mention format-d.c, x-d.h, x-d.c, html5-entities.h.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add x-d.h, html5-entities.h.
	(FORMAT_SOURCE): Add format-d.c.
	(libxgettextts2_a_SOURCES): Add d-parser.c, d-scanner.c.
	(xgettext_SOURCES): Add x-d.c.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-d.c.
	* gettext-tools/po/POTFILES.in: Add src/format-d.c, src/x-d.c.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Export formatstring_d.
	* gettext-tools/tests/format-d-1: New file.
	* gettext-tools/tests/format-d-2: New file.
	* gettext-tools/tests/xgettext-d-1: New file.
	* gettext-tools/tests/xgettext-d-2: New file.
	* gettext-tools/tests/xgettext-d-3: New file.
	* gettext-tools/tests/xgettext-d-4: New file.
	* gettext-tools/tests/xgettext-d-5: New file, based on
	gettext-tools/tests/xgettext-rust-5.
	* gettext-tools/tests/xgettext-d-6: New file, based on
	gettext-tools/tests/xgettext-rust-7.
	* gettext-tools/tests/testdata/dprog.utf-8.d: New file.
	* gettext-tools/tests/testdata/dprog.utf-8+bom.d: New file, based on
	gettext-tools/tests/testdata/dprog.utf-8.d.
	* gettext-tools/tests/testdata/dprog.utf-16be.d: New file, based on
	gettext-tools/tests/testdata/dprog.utf-8.d.
	* gettext-tools/tests/testdata/dprog.utf-16le.d: New file, based on
	gettext-tools/tests/testdata/dprog.utf-8.d.
	* gettext-tools/tests/testdata/dprog.utf-32be.d: New file, based on
	gettext-tools/tests/testdata/dprog.utf-8.d.
	* gettext-tools/tests/testdata/dprog.utf-32le.d: New file, based on
	gettext-tools/tests/testdata/dprog.utf-8.d.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	(EXTRA_DIST): Add the new testdata files.
	* NEWS: Mention the D support.

2025-04-01  Bruno Haible  <bruno@clisp.org>

	D support: Add the runtime library.
	* gnulib-local/m4/d.m4: New file.
	* gnulib-local/modules/d: New file.
	* gnulib-local/Makefile.am (EXTRA_DIST): Add d.m4 and the 'd' module.
	* autogen.sh (GNULIB_MODULES_RUNTIME_OTHER): Add d, dcomp-script.
	* gettext-runtime/intl-d/Makefile.am: New file.
	* gettext-runtime/intl-d/gnu/libintl/package.d: New file.
	* gettext-runtime/intl-d/gnu/libintl/libintl.d: New file.
	* gettext-runtime/intl-d/gnu/libintl/internal/low.d: New file.
	* gettext-runtime/configure.ac: Invoke gt_D_CHOICE, gt_DCOMP. Set the variable
	BUILDD and the Automake conditional BUILD_D.
	* gettext-runtime/Makefile.am (SUBDIRS): Add intl-d.
	* NEWS: Mention libintl_d.a.
	* gettext-runtime/NEWS: Likewise.
	* PACKAGING: Add the sources and binary for the libintl_d library.
	* DEPENDENCIES: Mention the D compiler and runtime.

2025-04-01  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-03-27  Bruno Haible  <bruno@clisp.org>

	Objective-C: xgettext: Strengthen tests.
	* gettext-tools/tests/xgettext-objc-1: Add test cases with format strings.

2025-03-25  Bruno Haible  <bruno@clisp.org>

	doc: Small updates.
	Reported by Michael Chirico <michaelchirico4@gmail.com>.

	* gettext-tools/doc/gettext.texi (The LANGUAGE variable): Rephrase
	recommendation for Norwegian users.
	(Header Entry): Remove statement about old versions of Emacs.

2025-03-23  Bruno Haible  <bruno@clisp.org>

	Refactor: Use more of c-ctype.h.
	* gettext-tools/src/format-awk.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-boost.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-c-parse.h (isdigit): Remove macro.
	(format_parse_entrails): Use c_isdigit instead.
	* gettext-tools/src/format-c++-brace.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-elisp.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-gcc-internal.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-gfc-internal.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-go.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-java-printf.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-javascript.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-librep.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-lua.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-pascal.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-perl.c (isdigit): Remove macro.
	(c_isnonzerodigit): Renamed from isnonzerodigit.
	(format_parse): Use c_isdigit instead of isdigit.
	* gettext-tools/src/format-php.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-python.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-ruby.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.
	* gettext-tools/src/format-tcl.c (isdigit): Remove macro.
	(format_parse): Use c_isdigit instead.

2025-03-23  Bruno Haible  <bruno@clisp.org>

	Comment cleanup.
	* gettext-tools/src/format-rust.c: Remove obsolete comment.

2025-03-22  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/setlocale.c: Include setlocale-fixes.h instead of
	setlocale-messages.h.
	(setlocale_unixlike) [__ANDROID__]: Use setlocale_fixed instead of setlocale.
	(setlocale_improved): On Android, use setlocale_fixed_null instead of setlocale.

2025-03-22  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-03-21  Bruno Haible  <bruno@clisp.org>

	Avoid bit rot of unused code.
	* gettext-tools/src/format-lisp.c: Include attribute.h.
	(intersection): Mark with MAYBE_UNUSED instead of '#ifdef unused'.
	* gettext-tools/src/format-scheme.c (intersection): Likewise.
	* gettext-tools/src/x-csharp.c (phase5_ungetc): Likewise.
	* gettext-tools/src/x-php.c (phase3_ungetc): Likewise.

2025-03-21  Bruno Haible  <bruno@clisp.org>

	Simplify strtoul() invocation.
	* gnulib-local/lib/markup.c: Don't include <errno.h>.
	(unescape_string_inplace): Don't reset or test errno.

2025-03-21  Bruno Haible  <bruno@clisp.org>

	Work around an strtoul() misfeature.
	* gettext-runtime/src/ngettext.c: Include <ctype.h>.
	(main): When parsing a nonnegative number, disallow leading whitespace and sign.
	* gettext-tools/tests/tstngettext.c: Include <ctype.h>.
	(worker_thread): When parsing a nonnegative number, disallow leading whitespace
	and sign.
	* gnulib-local/lib/markup.c (unescape_string_inplace): When parsing a numeric
	character entity, disallow leading whitespace and sign, and report a too large
	number as "non-permitted character" rather than "Numerical result out of range".
	* gettext-tools/src/msgfmt.c (main): When parsing the '-a' argument, disallow
	leading whitespace and sign and check whether the value is a power of 2.
	* gettext-tools/src/read-stringtable.c: Include c-ctype.h.
	(comment_line_end): When parsing a line number, disallow leading whitespace and
	sign.

2025-03-20  Bruno Haible  <bruno@clisp.org>

	Refactor.
	* gettext-tools/src/x-rust.c (ts_language_symbol, ts_language_field): Follow GNU
	coding style.
	* gettext-tools/src/x-go.c (ts_language_symbol, ts_language_field): Likewise.
	* gettext-tools/src/x-typescript-impl.h (ts_language_symbol, ts_language_field):
	Likewise.

2025-03-20  Bruno Haible  <bruno@clisp.org>

	Makevars template: Fix small mistake.
	* gettext-tools/po/Makevars.template: Correct statement about copyright.
	* gettext-runtime/po/Makevars: Likewise.
	* gettext-tools/po/Makevars: Likewise.
	* gettext-tools/examples/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-*/po/Makevars: Likewise.
	* gettext-tools/examples/hello-*/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2025-03-20  Bruno Haible  <bruno@clisp.org>

	doc: Fix small mistake.
	* gettext-tools/doc/xgettext.texi: Correct statement about copyright.

2025-03-11  Bruno Haible  <bruno@clisp.org>

	doc: Mention strings with embedded expressions in TypeScript.
	* gettext-tools/doc/gettext.texi (No string concatenation): Mention
	"template literals" in TypeScript.

2025-03-11  Bruno Haible  <bruno@clisp.org>

	Add TypeScript support.
	* autopull.sh: Check out tree-sitter-typescript. Set
	TREE_SITTER_TYPESCRIPT_VERSION.
	* gettext-tools/build-aux/tree-sitter-typescript-portability.diff: New file.
	* gettext-tools/configure.ac: Set TREE_SITTER_TYPESCRIPT_VERSION.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add the tree-sitter-typescript source
	code and patch.
	* gettext-tools/doc/lang-typescript.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (No string concatenation): Mention string
	concatenation in TypeScript.
	(List of Programming Languages): Include lang-typescript.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L TypeScript and -L TSX
	options.
	* gettext-tools/src/x-typescript-impl.h: New file.
	* gettext-tools/src/x-typescript.h: New file.
	* gettext-tools/src/x-typescript.c: New file.
	* gettext-tools/src/x-typescriptx.h: New file.
	* gettext-tools/src/x-typescriptx.c: New file.
	* gettext-tools/src/xgettext.c: Include x-typescript.h, x-typescriptx.h.
	(flag_table_typescript, flag_table_typescriptx): New variables.
	(main): Invoke init_flag_table_typescript, init_flag_table_typescriptx,
	x_typescript_extract_all, x_typescriptx_extract_all, x_typescript_keyword,
	x_typescriptx_keyword.
	(usage): Document the -L TypeScript and -L TSX options.
	(xgettext_record_flag): Support format_javascript with TypeScript and TSX.
	(language_to_extractor, extension_to_language): Support TypeScript and TSX.
	* gettext-tools/src/FILES: Mention x-typescript.h, x-typescript.c,
	x-typescriptx.h, x-typescriptx.c, x-typescript-impl.h.
	* gettext-tools/src/Makefile.am (noinst_LIBRARIES): Reference LIBXGETTEXTTS.
	(noinst_HEADERS): Add x-typescript.h, x-typescriptx.h, x-typescript-impl.h.
	(LIBXGETTEXTTS): Add libxgettextts3.a, libxgettextts4.a.
	(libxgettextts3_a_SOURCES, libxgettextts3_a_CPPFLAGS): New variables.
	(libxgettextts4_a_SOURCES, libxgettextts4_a_CPPFLAGS): New variables.
	(xgettext_SOURCES): Add x-typescript.c, x-typescriptx.c.
	* gettext-tools/tests/xgettext-javascript-6: Improve comments.
	* gettext-tools/tests/xgettext-typescript-1: New file, based on
	gettext-tools/tests/xgettext-javascript-1.
	* gettext-tools/tests/xgettext-typescript-2: New file, based on
	gettext-tools/tests/xgettext-javascript-2.
	* gettext-tools/tests/xgettext-typescript-3: New file, based on
	gettext-tools/tests/xgettext-javascript-3.
	* gettext-tools/tests/xgettext-typescript-4: New file, based on
	gettext-tools/tests/xgettext-javascript-4.
	* gettext-tools/tests/xgettext-typescript-5: New file, based on
	gettext-tools/tests/xgettext-javascript-5.
	* gettext-tools/tests/xgettext-typescript-6: New file, based on
	gettext-tools/tests/xgettext-javascript-6.
	* gettext-tools/tests/xgettext-typescript-7: New file, based on
	gettext-tools/tests/xgettext-javascript-7.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	* NEWS: Mention the TypeScript support.

2025-03-11  Bruno Haible  <bruno@clisp.org>

	xgettext: Go: Refactor.
	* gettext-tools/src/x-go.c (handle_comments): Remove 'contents' parameter.
	(extract_from_function_call, extract_from_node): Update.

2025-03-10  Bruno Haible  <bruno@clisp.org>

	examples: Fix "make install".
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES): Match actual file list.

2025-03-09  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Refactor, part 2.
	* gettext-tools/src/x-rust.c (handle_comments, string_literal_value): Remove
	'contents' parameter.
	(extract_from_function_call, extract_from_function_call_like,
	extract_from_node): Update.

2025-03-09  Bruno Haible  <bruno@clisp.org>

	Fix a comment.
	* gettext-tools/src/x-javascript.h: Fix typo in comment.

2025-03-08  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-go-http example.
	* gettext-tools/examples/hello-go-http/INSTALL: New file.
	* gettext-tools/examples/hello-go-http/autogen.sh: New file.
	* gettext-tools/examples/hello-go-http/autoclean.sh: New file.
	* gettext-tools/examples/hello-go-http/example1/hello1ml.go.in: New file.
	* gettext-tools/examples/hello-go-http/example1/go.mod.in: New file.
	* gettext-tools/examples/hello-go-http/example1/Makefile.am: New file.
	* gettext-tools/examples/hello-go-http/Makefile.am: New file.
	* gettext-tools/examples/hello-go-http/configure.ac: New file.
	* gettext-tools/examples/hello-go-http/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-go-http/po/LINGUAS: New file.
	* gettext-tools/examples/hello-go-http/po/Makefile.am: New file.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-go-http.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-go-http.
	(hello-go-http.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-go-http.
	($(srcdir)/../hello-go-http/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-go-http as well.
	* gettext-tools/examples/README: Mention hello-go-http.
	* gettext-tools/doc/lang-go.texi: Likewise.
	* NEWS: Likewise.

2025-03-08  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-go example.
	* gettext-tools/examples/hello-go/INSTALL: New file.
	* gettext-tools/examples/hello-go/autogen.sh: New file.
	* gettext-tools/examples/hello-go/autoclean.sh: New file.
	* gettext-tools/examples/hello-go/example1/hello1sl.go.in: New file.
	* gettext-tools/examples/hello-go/example1/hello1ml.go.in: New file.
	* gettext-tools/examples/hello-go/example1/go.mod.in: New file.
	* gettext-tools/examples/hello-go/example1/Makefile.am: New file.
	* gettext-tools/examples/hello-go/example2/hello2sl.go.in: New file.
	* gettext-tools/examples/hello-go/example2/go.mod.in: New file.
	* gettext-tools/examples/hello-go/example2/Makefile.am: New file.
	* gettext-tools/examples/hello-go/example3/hello3ml.go.in: New file.
	* gettext-tools/examples/hello-go/example3/go.mod.in: New file.
	* gettext-tools/examples/hello-go/example3/Makefile.am: New file.
	* gettext-tools/examples/hello-go/Makefile.am: New file.
	* gettext-tools/examples/hello-go/configure.ac: New file.
	* gettext-tools/examples/hello-go/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-go/po/LINGUAS: New file.
	* gettext-tools/examples/hello-go/po/Makefile.am: New file.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-go.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-go.
	(hello-go.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-go.
	($(srcdir)/../hello-go/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-go as well.
	* gettext-tools/examples/README: Mention hello-go.
	* gettext-tools/doc/lang-go.texi: Likewise.
	* NEWS: Likewise.

2025-03-07  Bruno Haible  <bruno@clisp.org>

	tests: Fix autopoint-3 test failure on macOS.
	* gettext-tools/tests/autopoint-3 (MAKE): Set to 'gmake' only if gmake exists.

2025-03-07  Bruno Haible  <bruno@clisp.org>

	Go: Add integration test.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC): Add gocomp-script.
	* gettext-tools/tests/init-env.in (GO_CHOICE, GO): New variables.
	* gettext-tools/tests/lang-go: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* HACKING: Document dependencies for lang-go.

2025-03-07  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-03-07  Bruno Haible  <bruno@clisp.org>

	tests: Fix autopoint-3 test failure on Solaris 11.
	* gettext-tools/tests/autopoint-3 (MAKE): Set to 'gmake' on macOS, Solaris, AIX.

2025-03-07  Bruno Haible  <bruno@clisp.org>

	Add Go support.
	* autopull.sh: Check out tree-sitter-go. Set TREE_SITTER_GO_VERSION.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add carray-list, hash-map,
	hash-set, xlist, xmap, xset, xstring-buffer-reversed.
	* gettext-tools/build-aux/tree-sitter-go-portability.diff: New file.
	* gettext-tools/configure.ac: Set TREE_SITTER_GO_VERSION.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add the tree-sitter-go source code and
	patch.
	* gettext-tools/doc/lang-go.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (PO Files): Mention go-format.
	(No string concatenation): Mention string concatenation in Go.
	(Translators for other Languages): New subsection "Go Format Strings".
	(List of Programming Languages): Include lang-go.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L Go option.
	* gettext-tools/src/message.h (format_go): New enum value.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_go.
	* gettext-tools/src/format-go.c: New file.
	* gettext-tools/src/format.h (formatstring_go): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add formatstring_go.
	* gettext-tools/src/x-go.h: New file.
	* gettext-tools/src/x-go.c: New file.
	* gettext-tools/src/xgettext.c: Include x-go.h.
	(flag_table_go): New variable.
	(main): Invoke init_flag_table_go, x_go_extract_all, x_go_keyword.
	(usage): Document the -L Go option.
	(xgettext_record_flag): Support format_go.
	(language_to_extractor, extension_to_language): Support Go.
	* gettext-tools/src/FILES: Mention format-go.c, x-go.h, x-go.c.
	* gettext-tools/src/Makefile.am (noinst_HEADERS): Add x-go.h.
	(FORMAT_SOURCE): Add format-go.c.
	(libxgettextts2_a_SOURCES): Add go-parser.c.
	(xgettext_SOURCES): Add x-go.c.
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-go.c.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Export formatstring_go.
	* gettext-tools/tests/format-go-1: New file.
	* gettext-tools/tests/format-go-2: New file.
	* gettext-tools/tests/xgettext-go-1: New file.
	* gettext-tools/tests/xgettext-go-2: New file.
	* gettext-tools/tests/xgettext-go-3: New file.
	* gettext-tools/tests/xgettext-go-4: New file.
	* gettext-tools/tests/xgettext-go-5: New file.
	* gettext-tools/tests/xgettext-go-6: New file.
	* gettext-tools/tests/xgettext-go-7: New file.
	* gettext-tools/tests/xgettext-go-8: New file.
	* gettext-tools/tests/xgettext-go-9: New file.
	* gettext-tools/tests/xgettext-go-10: New file.
	* gettext-tools/tests/xgettext-go-11: New file.
	* gettext-tools/tests/xgettext-go-12: New file.
	* gettext-tools/tests/xgettext-go-13: New file.
	* gettext-tools/tests/xgettext-go-14: New file.
	* gettext-tools/tests/xgettext-go-15: New file.
	* gettext-tools/tests/xgettext-go-16: New file.
	* gettext-tools/tests/xgettext-go-17: New file.
	* gettext-tools/tests/xgettext-go-18: New file.
	* gettext-tools/tests/xgettext-go-stackovfl-1: New file.
	* gettext-tools/tests/xgettext-go-stackovfl-2: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	* NEWS: Mention the Go support.

2025-03-04  Bruno Haible  <bruno@clisp.org>

	tests: Rust: Small fix.
	* gettext-tools/tests/xgettext-rust-7: Fix a typo.

2025-03-04  Bruno Haible  <bruno@clisp.org>

	tests: Prefer 'cat <<\EOF' to 'cat <<EOF' whenever possible.
	Rationale: Not interpreting $ and \ in the here documents is a better default
	than interpreting them.

	* gettext-tools/tests/xgettext-*: Write 'cat <<\EOF' instead of 'cat <<EOF',
	when no shell dollar-substitution and backslash-interpretation is needed.

2025-03-01  Bruno Haible  <bruno@clisp.org>

	build: Improve wording in './configure --help'.
	Reported by Benno Schulenberg <bensberg@telfort.nl> in
	<https://lists.gnu.org/archive/html/bug-gettext/2025-03/msg00000.html>.

	* configure.ac: Use a dummy version number named 'package', not 'dummy'.
	* gettext-runtime/configure.ac: Likewise.
	* gettext-runtime/intl/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.
	* gettext-tools/examples/configure.ac: Likewise.
	* libtextstyle/configure.ac: Likewise.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	examples: Use #| (previous) lines in the PO files.
	* gettext-tools/examples/po/Makefile.am ($(POFILES), update-po): Pass --lang and
	--previous options to msgmerge.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 0.24.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.24.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	examples: Make hello-rust pass the check.
	* gettext-tools/examples/check-examples (func_check_dist): Ignore the
	till-present 'target' directory in hello-rust.
	(func_check_dist_vpath): Likewise.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	examples: Fix hello-c++-gnome3.
	* gettext-tools/examples/hello-c++-gnome3/autoclean.sh: Remove po/Makefile.in.in.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.
	* gettext-runtime/po/*.po: Update from TP.
	* gettext-tools/po/*.po: Update from TP.
	* gettext-tools/examples/po/*.po: Update from TP.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	Prepare for 0.24 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/m4/gettext.m4: Update comments.
	* gettext-runtime/m4/nls.m4: Likewise.
	* gettext-runtime/m4/progtest.m4: Likewise.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:3:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:4:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:13:5.
	* gettext-runtime/src/envsubst.c (main): Update copyright year in --version
	output.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/gettext.sh.in (func_version): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-tools/misc/convert-archive.in (func_version): Likewise.
	* gettext-tools/misc/gettextize.in (func_version): Likewise.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.24.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.24.
	* NEWS: Update.

2025-02-25  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-02-24  Bruno Haible  <bruno@clisp.org>

	xgettext: Implement a "reproducible" POT-Creation-Date value.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add vc-mtime.
	* gettext-tools/src/xgettext.c: Include vc-mtime.h, msgl-header.h.
	(has_some_mtimes, max_of_mtimes, some_mtimes_failed): New variables.
	(long_options): Add --reference option.
	(main): Implement --reference option. Invoke consider_vc_mtime for the
	--files-from option.
	(usage): Document the --reference option.
	(consider_vc_mtime): New function.
	(read_exclusion_file, extract_from_file, extract_from_xml_file: Invoke
	consider_vc_mtime.
	(construct_header): Don't compute the value of POT-Creation-Date here.
	(finalize_header): Compute it here.
	* gettext-tools/doc/xgettext.texi: Document the --reference option.
	* NEWS: Mention the change.

2025-02-24  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/intl/setlocale.c: Include setlocale-messages.h.
	(lc_messages_name): Remove variable.

2025-02-24  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-02-19  Bruno Haible  <bruno@clisp.org>

	Prepare for prerelease.
	* gettext-tools/po/POTFILES.in: Update file list.

2025-02-19  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-02-18  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

2025-02-18  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Avoid an error localeconv_used_without_requesting_gnulib_module_localeconv on mingw.
	* libtextstyle/autogen.sh: Avoid module 'locale-h'.

2025-02-13  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-c-http example.
	* gettext-tools/examples/hello-c-http/INSTALL: New file.
	* gettext-tools/examples/hello-c-http/autogen.sh: New file, based on
	gettext-tools/examples/hello-c/autogen.sh.
	* gettext-tools/examples/hello-c-http/autoclean.sh: New file, based on
	gettext-tools/examples/hello-c/autoclean.sh.
	* gettext-tools/examples/hello-c-http/hello-server.c: New file.
	* gettext-tools/examples/hello-c-http/Makefile.am: New file, based on
	gettext-tools/examples/hello-c/Makefile.am.
	* gettext-tools/examples/hello-c-http/configure.ac: New file, based on
	gettext-tools/examples/hello-c/configure.ac.
	* gettext-tools/examples/hello-c-http/m4/Makefile.am: New file, copied from
	gettext-tools/examples/hello-c/m4/Makefile.am.
	* gettext-tools/examples/hello-c-http/po/POTFILES.in: New file.
	* gettext-tools/examples/hello-c-http/po/Makevars: New file, copied from
	gettext-tools/examples/hello-c/po/Makevars.
	* gettext-tools/examples/hello-c-http/po/LINGUAS: New file, copied from
	gettext-tools/examples/hello-c/po/LINGUAS.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-c-http.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-c-http.
	(hello-c-http.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-c-http.
	($(srcdir)/../hello-c-http/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-c-http as well.
	* gettext-tools/examples/README: Mention hello-c-http.
	* NEWS: Likewise.

2025-02-13  Bruno Haible  <bruno@clisp.org>

	intl: Update info about Galician and Tamil.
	* gettext-runtime/intl/setlocale.c (locales_with_principal_territory): Galician
	is mostly spoken in Spain, not Portugal. Tamil is mostly spoken in India, not
	Sri Lanka.

2025-02-12  Bruno Haible  <bruno@clisp.org>

	msginit: Update info about Galician and Tamil.
	* gettext-tools/src/msginit.c (catalogname_for_locale): Galician is mostly
	spoken in Spain, not Portugal. Tamil is mostly spoken in India, not Sri Lanka.

2025-02-11  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Support named format string arguments.
	Reported by Kévin Commaille <zecakeh@tedomum.fr>
	in <https://savannah.gnu.org/bugs/?56774>.

	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add unictype/property-xid-start,
	unictype/property-xid-continue.
	(GNULIB_MODULES_LIBGETTEXTPO): Likewise.
	* gettext-tools/src/format-rust.c (struct named_arg): New type.
	(struct spec): Add fields named_arg_count, named.
	(named_arg_compare): New function.
	(format_parse): Recognize named arguments.
	(format_check): Search for differences also between the named arguments.
	(format_print): Print also the named arguments.
	* gettext-tools/tests/format-rust-1: Add test cases for named arguments.
	* gettext-tools/tests/format-rust-2: Likewise.
	* gettext-tools/doc/gettext.texi (rust-format): Describe rust-format in detail.

2025-02-11  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Fix comments.
	* gettext-tools/src/x-rust.c: Fix reference to the Rust specification.

2025-02-11  Bruno Haible  <bruno@clisp.org>

	Refactor.
	* gettext-tools/src/format-ruby.c (format_parse): Use two different variables
	named_allocated, numbered_allocated, instead of a single variable (assuming that
	INVALID_MIXES_NAMED_UNNAMED is called when it should).

2025-02-10  Ivan Krylov  <ikrylov@disroot.org>  (tiny change)

	doc: Suggest to not use ngettext() in a specific case.
	Edits from Ivan Krylov <ikrylov@disroot.org> at
	<https://lists.gnu.org/archive/html/bug-gettext/2025-02/msg00000.html>
	and Bruno Haible.

	* gettext-tools/doc/gettext.texi (Plural forms): Suggest to not use ngettext()
	in singular/plural cases without a number in the strings.

2025-02-09  Bruno Haible  <bruno@clisp.org>

	Refactor: Allow for better static analysis, fixing some GCC analyzer warnings.
	* gettext-tools/src/cldr-plural.y: Define SB_NO_APPENDF.
	* gettext-tools/src/its.c: Likewise.
	* gettext-tools/src/read-desktop.c: Likewise.
	* gettext-tools/src/read-properties.c: Likewise.
	* gettext-tools/src/x-awk.c: Likewise.
	* gettext-tools/src/x-c.c: Likewise.
	* gettext-tools/src/x-java.c: Likewise.
	* gettext-tools/src/x-javascript.c: Likewise.
	* gettext-tools/src/x-lua.c: Likewise.
	* gettext-tools/src/x-perl.c: Likewise.
	* gettext-tools/src/x-php.c: Likewise.
	* gettext-tools/src/x-python.c: Likewise.
	* gettext-tools/src/x-rst.c: Likewise.
	* gettext-tools/src/x-smalltalk.c: Likewise.
	* gettext-tools/src/x-vala.c: Likewise.
	* gettext-tools/src/x-ycp.c: Likewise.

2025-02-09  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Refactor.
	* gettext-tools/src/x-rust.c (contents): New variable.
	(extract_from_function_call, extract_from_function_call_like,
	extract_from_node): Remove the 'contents' parameter.
	(extract_rust): Update.

2025-02-09  Bruno Haible  <bruno@clisp.org>

	xgettext: Handle out-of-memory situation.
	* gettext-tools/src/x-perl.c: Include xstring-desc.h.
	(extract_quotelike): Call xsd_c instead of sd_c.
	* gettext-tools/src/x-rust.c: Include xstring-desc.h.
	(string_literal_value): Call xsd_c instead of sd_c. Call sb_xappend_desc
	instead of sb_append_desc.

2025-02-05  Bruno Haible  <bruno@clisp.org>

	doc: Sort programming languages consistently.
	* gettext-tools/doc/gettext.texi (No string concatenation): Sort the programming
	languages like elsewhere in the doc.

2025-02-04  Bruno Haible  <bruno@clisp.org>

	build: Remove undesired output from autopull.sh.
	* autopull.sh (func_git_clone_shallow): Silence the initial branch hint.

2025-02-04  Bruno Haible  <bruno@clisp.org>

	Fix last two commits.

2025-02-04  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Improve namespacing.
	* gettext-tools/libgettextpo/Makefile.am (COMPILATION_UNITS): Fix reference to
	LIBOBJS variable.
	(config.h): Remove leading part of the elements of
	$(lts_libtextstyle_LTLIBOBJS).

2025-02-04  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/libgettextpo/Makefile.am (config.h): Remove leading part of the
	elements of $(libgnu_la_LIBADD).

2025-02-04  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-02-03  Bruno Haible  <bruno@clisp.org>

	Rust: Update .gitignore.

2025-02-03  Bruno Haible  <bruno@clisp.org>

	Rust: Reference the example in the documentation.
	* gettext-tools/doc/lang-rust.texi: Reference the example.

2025-02-03  Bruno Haible  <bruno@clisp.org>

	Java: Doc comments.
	* gettext-tools/doc/lang-java.texi: Add comments.

2025-02-02  Bruno Haible  <bruno@clisp.org>

	Sort programming languages like in the documentation.
	* gettext-tools/src/xgettext.c (usage): For the -L, -a, -k, --flag options, sort
	the list of programming languages like in the documentation. Add Guile, Rust,
	GSettings, that were forgotten earlier.
	* gettext-tools/doc/xgettext.texi: Likewise.
	* gettext-tools/examples/README: Sort the examples like the programming
	languages in the documentation.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Likewise.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Likewise.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS, hello-*.pot,
	SMALLPOFILES_FOR_lang, $(srcdir)/../hello-*/po/$(LL).po): Likewise.

2025-02-02  Bruno Haible  <bruno@clisp.org>

	tests: Fix a comment.
	* gettext-tools/tests/format-lua-2: Fix comment.

2025-02-01  Bruno Haible  <bruno@clisp.org>

	doc: Explain why localizations are in separate files.
	* gettext-tools/doc/gettext.texi (Overview): Explain why the MO files should
	not be embedded in the executable.

2025-01-29  Bruno Haible  <bruno@clisp.org>

	tests: Fix a comment.
	* gettext-tools/tests/lang-rust: Fix comment.

2025-01-29  Bruno Haible  <bruno@clisp.org>

	intl: Fix undefined behaviour.
	Found using clang's undefined-behaviour sanitizer:
	CC="clang -fsanitize=undefined -fno-sanitize-recover=undefined".
	It reported errors
	dcigettext.c:1219:25: runtime error: applying non-zero offset 8 to null pointer
	because the code was computing
	    outbuf = freemem + sizeof (size_t);
	where freemem == NULL.

	* gettext-runtime/intl/dcigettext.c (_nl_find_msg): Initialize outbuf only after
	having verified that freemem_size >= sizeof (size_t).

2025-01-29  Bruno Haible  <bruno@clisp.org>

	xgettext: Rust: Fix xgettext-rust-stackovfl-* failures on MSVC 14/x86_64.
	* autogen.sh (GNULIB_MODULES_TOOLS_OTHER): Add test-xfail.
	* gettext-tools/src/Makefile.am (xgettext_LDFLAGS): On MSVC, use a larger
	stack size.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	examples: Add hello-rust example.
	* gettext-tools/examples/hello-rust/INSTALL: New file.
	* gettext-tools/examples/hello-rust/autogen.sh: New file.
	* gettext-tools/examples/hello-rust/autoclean.sh: New file.
	* gettext-tools/examples/hello-rust/Cargo.toml.in: New file.
	* gettext-tools/examples/hello-rust/src/main.rs.in: New file.
	* gettext-tools/examples/hello-rust/Makefile.am: New file.
	* gettext-tools/examples/hello-rust/configure.ac: New file.
	* gettext-tools/examples/hello-rust/m4/Makefile.am: New file.
	* gettext-tools/examples/hello-rust/po/Makefile.am: New file.
	* gettext-tools/examples/hello-rust/po/LINGUAS: New file.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Add
	hello-rust.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS): Update for
	hello-rust.
	(hello-rust.pot): New target.
	(SMALLPOFILES_FOR_lang): Update for hello-rust.
	($(srcdir)/../hello-rust/po/$(LL).po): New rule.
	* gettext-tools/examples/check-examples (func_check_autoclean_all,
	func_check_distclean_all, func_check_maintainerclean_all,
	func_check_maintainerclean_vpath_all, func_check_dist_all,
	func_check_dist_vpath_all, func_check_install_all, func_check_uninstall_all,
	func_check_distcheck_all, func_check_all): Handle hello-rust as well.
	(func_check): Add a more useful body.
	* gettext-tools/examples/README: Mention hello-rust.
	* NEWS: Likewise.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	Rust: Add lang-rust unit test.
	* gettext-tools/tests/init.cfg (this_test_is_longrunning_): New function.
	* gettext-tools/tests/lang-rust: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.
	* HACKING: Reorder. Document prerequisites for Rust unit test.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	Add Rust support.
	* autopull.sh (func_git_clone_shallow): New function, based on
	gnulib/top/bootstrap-funclib.sh.
	Check out tree-sitter and tree-sitter-rust.
	Create gettext-tools/tree-sitter.cfg.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Add strnlen,
	unictype/property-white-space.
	(GNULIB_MODULES_LIBGETTEXTPO): Likewise.
	* gettext-tools/build-aux/tree-sitter-portability.diff: New file.
	* gettext-tools/build-aux/tree-sitter-rust-portability.diff: New file.
	* gettext-tools/configure.ac: Set TREE_SITTER_VERSION, TREE_SITTER_RUST_VERSION.
	* gettext-tools/Makefile.am (EXTRA_DIST): Add the tree-sitter configuration,
	source code, and patches.
	* gettext-tools/doc/lang-rust.texi: New file.
	* gettext-tools/doc/Makefile.am (gettext_TEXINFOS): Add it.
	* gettext-tools/doc/gettext.texi (PO Files): Mention rust-format.
	(Translators for other Languages): New subsection "Rust Format Strings".
	(List of Programming Languages): Include lang-rust.texi.
	* gettext-tools/doc/xgettext.texi: Document the -L Rust option.
	* gettext-tools/src/message.h (format_rust): New enum value.
	(NFORMATS): Increment.
	* gettext-tools/src/message.c (format_language, format_language_pretty): Add an
	entry for format_rust.
	* gettext-tools/src/format-rust.c: New file.
	* gettext-tools/src/format.h (formatstring_rust): New declaration.
	* gettext-tools/src/format.c (formatstring_parsers): Add formatstring_rust.
	* gettext-tools/src/x-rust.h: New file.
	* gettext-tools/src/x-rust.c: New file.
	* gettext-tools/src/xgettext.c: Include x-rust.h.
	(main): Invoke init_flag_table_rust, x_rust_extract_all, x_rust_keyword.
	(usage): Document the -L Rust option.
	(xgettext_record_flag): Support format_rust.
	(language_to_extractor, extension_to_language): Support Rust.
	* gettext-tools/src/FILES: Mention format-rust.c, x-rust.h, x-rust.c.
	* gettext-tools/src/Makefile.am (noinst_LIBRARIES): New variable.
	(noinst_HEADERS): Add x-rust.h.
	(AM_CPPFLAGS): Add a -I option for tree-sitter.
	(FORMAT_SOURCE): Add format-rust.c.
	(LIBXGETTEXTTS): New variable.
	(libxgettextts1_a_SOURCES, libxgettextts1_a_CPPFLAGS): New variables.
	(libxgettextts2_a_SOURCES, libxgettextts2_a_CPPFLAGS): New variables.
	(xgettext_SOURCES): Add x-rust.c.
	(xgettext_LDADD, xgettext_DEPENDENCIES): Add $(LIBXGETTEXTTS).
	* gettext-tools/libgettextpo/Makefile.am (libgettextpo_la_AUXSOURCES): Add
	format-rust.c.
	* gettext-tools/woe32dll/gettextsrc-exports.c: Export formatstring_rust.
	* gettext-tools/tests/format-rust-1: New file.
	* gettext-tools/tests/format-rust-2: New file.
	* gettext-tools/tests/xgettext-rust-1: Fix string literal concatenation test.
	Fix -k options.
	* gettext-tools/tests/xgettext-rust-2: Fix gettext invocations.
	* gettext-tools/tests/xgettext-rust-3: Fix string literal concatenation test.
	Test multiline strings.
	* gettext-tools/tests/xgettext-rust-4: Tweak.
	* gettext-tools/tests/xgettext-rust-5: Fix test identifier.
	* gettext-tools/tests/xgettext-rust-6: New file.
	* gettext-tools/tests/xgettext-rust-7: New file.
	* gettext-tools/tests/xgettext-rust-stackovfl-1: New file.
	* gettext-tools/tests/xgettext-rust-stackovfl-2: New file.
	* gettext-tools/tests/xgettext-rust-stackovfl-3: New file.
	* gettext-tools/tests/xgettext-rust-stackovfl-4: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add the new tests.
	* check-copyright-headers (func_check_file): Ignore tree-sitter files.
	* NEWS: Mention the Rust support.

2025-01-28  Kévin Commaille  <zecakeh@tedomum.fr>

	Prepare for Rust support.
	* gettext-tools/tests/xgettext-rust-1: New file, based on
	gettext-tools/tests/xgettext-csharp-1.
	* gettext-tools/tests/xgettext-rust-2: New file, based on
	gettext-tools/tests/xgettext-csharp-2.
	* gettext-tools/tests/xgettext-rust-3: New file, based on
	gettext-tools/tests/xgettext-csharp-3.
	* gettext-tools/tests/xgettext-rust-4: New file, based on
	gettext-tools/tests/xgettext-csharp-4.
	* gettext-tools/tests/xgettext-rust-5: New file, based on
	gettext-tools/tests/xgettext-csharp-7.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	examples: Improve autoclean.sh.
	* gettext-tools/examples/hello-c-gnome3/autoclean.sh: Do also the equivalent of
	"make maintainer-clean".
	* gettext-tools/examples/hello-c++-gnome3/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c++-kde/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-csharp/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-csharp-forms/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-pascal/autoclean.sh: Likewise.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	examples: Assume autoconf >= 2.60.
	* gettext-tools/examples/hello-clisp/configure.ac: Compute localedir based on
	${datarootdir}, not ${datadir}.
	* gettext-tools/examples/hello-gawk/configure.ac: Likewise.
	* gettext-tools/examples/hello-guile/configure.ac: Likewise.
	* gettext-tools/examples/hello-librep/configure.ac: Likewise.
	* gettext-tools/examples/hello-pascal/configure.ac: Likewise.
	* gettext-tools/examples/hello-perl/configure.ac: Likewise.
	* gettext-tools/examples/hello-php/configure.ac: Likewise.
	* gettext-tools/examples/hello-python/configure.ac: Likewise.
	* gettext-tools/examples/hello-ruby/configure.ac: Likewise.
	* gettext-tools/examples/hello-sh/configure.ac: Likewise.
	* gettext-tools/examples/hello-smalltalk/configure.ac: Likewise.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Update after 2025-01-24 change.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	format-ruby: Fix error handling.
	* gettext-tools/src/format-ruby.c (format_parse): Respect FDI_SET constraint.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	format-python-brace: Fix error handling.
	* gettext-tools/src/format.h (FDI_SET): Improve comment.
	* gettext-tools/src/format-python-brace.c (parse_directive): Improve error
	messages. Respect FDI_SET constraint.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	Mention the GNU make requirement more prominently.
	* NEWS: Mention the GNU make requirement.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	build: Update package version handling after gnulib changed.
	* configure.ac: Drop postprocessing of git-version-gen output.
	* gettext-runtime/configure.ac: Likewise.
	* gettext-runtime/intl/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.
	* gettext-tools/examples/configure.ac: Likewise.

2025-01-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-01-25  Bruno Haible  <bruno@clisp.org>

	build: Update package version handling after gnulib changed.
	* configure.ac: Invoke AC_INIT with arguments. Invoke gl_INIT_PACKAGE_VERSION
	instead of gl_INIT_PACKAGE.
	* gettext-runtime/configure.ac: Likewise.
	* gettext-runtime/intl/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.
	* gettext-tools/examples/configure.ac: Likewise.
	* libtextstyle/configure.ac: Likewise.

2025-01-25  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-01-24  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Improve package version handling.
	* libtextstyle/autogen.sh: Copy also m4/init-package-version.m4.
	* libtextstyle/m4/init-package-version.m4: Remove file, moved to gnulib.

2025-01-24  Bruno Haible  <bruno@clisp.org>

	Temporarily revert "po: Rename Makefile.in.in to Makefile.in."

2025-01-24  Bruno Haible  <bruno@clisp.org>

	build: Update release-steps after problem with .version has been fixed.

2025-01-23  Bruno Haible  <bruno@clisp.org>

	build: Improve package version handling.
	* autogen.sh: Copy also m4/init-package-version.m4, m4/version-stamp.m4.
	* configure.ac: Use gl_INIT_PACKAGE and gl_CONFIG_VERSION_STAMP.
	* gettext-runtime/configure.ac: Use gl_INIT_PACKAGE.
	* gettext-runtime/intl/configure.ac: Likewise.
	* gettext-tools/configure.ac: Likewise.
	* gettext-tools/examples/configure.ac: Likewise.
	* Makefile.am (dist-tarball-version): New target.
	($(top_srcdir)/.version): Remove target.

2025-01-23  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-01-12  Bruno Haible  <bruno@clisp.org>

	format-kde-kuit: Fix test program.
	* gettext-tools/src/format-kde-kuit.c: Fix compile-command.
	(format_print): Make it compile. Print a '*' for each argument.

2025-01-12  Bruno Haible  <bruno@clisp.org>

	format-kde: Fix test program.
	* gettext-tools/src/format-kde.c (format_print): Print a '*' for each argument.

2025-01-09  Bruno Haible  <bruno@clisp.org>

	Update .gitignore after the recent refactorings.

2025-01-08  Bruno Haible  <bruno@clisp.org>

	Fix a test failure when LC_ALL is set to a non-English locale.
	Reported by Simon Josefsson <simon@josefsson.org>
	in <https://lists.gnu.org/archive/html/bug-gettext/2025-01/msg00008.html>.

	* gettext-tools/tests/xgettext-its-2: When setting LC_MESSAGES, also unset
	LC_ALL.

2025-01-08  Bruno Haible  <bruno@clisp.org>

	xgettext: JavaScript: Parse recursive JSX expressions correctly.
	Reported by <fiurgeist@gmail.com> at <https://savannah.gnu.org/bugs/?66643>.

	* gettext-tools/src/x-javascript.c (phase5_get): Treat a '<' character in
	level type level_embedded_js_in_xml like in the other level types.
	* gettext-tools/tests/xgettext-javascript-6: Add another test case.
	* NEWS: Mention the fix.

2025-01-08  Bruno Haible  <bruno@clisp.org>

	build: Achieve better tarball compression ratios in "make dist".
	Suggested by Lasse Collin <lasse.collin@tukaani.org>
	in <https://lists.gnu.org/archive/html/bug-gettext/2025-01/msg00011.html>.

	* configure.ac (am__tar): Sort the files by basename.

2025-01-08  Bruno Haible  <bruno@clisp.org>

	Refactor: Use function str_endswith.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c (term_ostream_create): Use
	str_endswith.
	* libtextstyle/gnulib-local/modules/term-ostream (Depends-on): Add
	str_endswith.

2025-01-08  Bruno Haible  <bruno@clisp.org>

	Refactor: Use function str_startswith.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c (should_enable_hyperlinks):
	Use str_startswith.
	* libtextstyle/gnulib-local/modules/term-ostream (Depends-on): Add
	str_startswith.
	* gettext-tools/src/cldr-plural.y (yylex): Use str_startswith.
	* gettext-tools/src/format-java.c (message_format_parse, choice_format_parse):
	Likewise.
	* gettext-tools/src/msgl-check.c (plural_help, check_header_entry): Likewise.
	* gettext-tools/src/read-catalog-abstract.c (parse_comment_filepos): Likewise.
	* gettext-tools/src/read-csharp.c (msgdomain_read_csharp): Likewise.
	* gettext-tools/src/write-csharp.c (msgdomain_write_csharp): Likewise.
	* gettext-tools/src/x-perl.c (skip_pod): Likewise.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC, GNULIB_MODULES_LIBGETTEXTPO): Add
	str_startswith.

2025-01-03  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-01-03  Bruno Haible  <bruno@clisp.org>

	Refactor: Use GNU coding style.
	* gnulib-local/lib/markup.c (slow_name_validate, unescape_string_inplace,
	clear_attributes, markup_parse_context_parse): Break lines before the operator.

2025-01-03  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Recognize number of colours in TERM=*-direct.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c (term_ostream_create): Fix
	recognition of TERM values that end in "-direct".

2025-01-03  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Add comments.
	* libtextstyle/gnulib-local/lib/term-ostream.oo.c (term_ostream_create): Add
	comments.

2025-01-02  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-runtime/src/envsubst.c (subst_from_stdin): Use sd_ function prefix
	instead of string_desc_ function prefix.
	* gettext-tools/src/its.c (set_doc_encoding_utf8, _its_is_valid_simple_gen_xml,
	is_valid_xhtml_element, is_valid_html_element, is_no_end_html_element):
	Likewise.
	* gettext-tools/src/msgl-ascii.c (is_ascii_string_desc): Likewise.
	* gettext-tools/src/msgl-iconv.c (convert_string_desc_directly): Likewise.
	* gettext-tools/src/read-desktop.c (desktop_lex): Likewise.
	* gettext-tools/src/x-awk.c (phase2_getc, phase3_get): Likewise.
	* gettext-tools/src/x-c.c (phase5_get): Likewise.
	* gettext-tools/src/x-perl.c (get_here_document, extract_quotelike_pass1,
	extract_quotelike_pass1_utf8, extract_quotelike, extract_triple_quotelike,
	extract_quotelike_pass3, extract_variable, interpolate_keywords, x_perl_prelex):
	Likewise.
	* gettext-tools/src/x-php.c (phase4_get): Likewise.
	* gettext-tools/src/x-rst.c (parse_integer): Likewise.
	* gettext-tools/src/x-ycp.c (phase2_getc, phase5_get): Likewise.
	* gettext-tools/src/xg-encoding.c (string_desc_from_current_source_encoding):
	Likewise.

2025-01-02  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2025-01-01  Bruno Haible  <bruno@clisp.org>

	msgfmt: Fix python-brace-format checking.
	Reported at <https://savannah.gnu.org/bugs/index.php?48872>.

	* gettext-tools/src/format-python-brace.c (format_check): Fix comment. Do the
	cmp > 0 check also if equality==false.
	* gettext-tools/src/format-python.c (format_check): Fix comment.
	* gettext-tools/src/format-ruby.c (format_check): Likewise.
	* gettext-tools/src/format-sh.c (format_check): Likewise.

2024-12-31  Bruno Haible  <bruno@clisp.org>

	When reading PO files, treat CRLF line terminators like LF, part 2.
	* gettext-tools/tests/Makefile.am (EXTRA_DIST): Add testdata/crlf.pot.

2024-12-31  Bruno Haible  <bruno@clisp.org>

	Merge from 0.23.x branch: Prepare for 0.23.1 release.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:2:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:3:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:12:5.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.23.1.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.23.1.

2024-12-31  Bruno Haible  <bruno@clisp.org>

	Merge from 0.23.x branch: Update NEWS file for release 0.23.1.

2024-12-31  Bruno Haible  <bruno@clisp.org>

	doc: Update list of dependencies.

2024-12-31  Bruno Haible  <bruno@clisp.org>

	When reading PO files, treat CRLF line terminators like LF.
	Reported by Hendy Irawan <hendy@hendyirawan.com> at
	<https://savannah.gnu.org/bugs/?52395>.

	* gettext-tools/src/read-po-internal.h (MBFILE_MAX_PUSHBACK): Renamed from
	NPUSHBACK. Increase by 1.
	(struct mbfile): Rename field 'have_pushback' to 'pushback_count'.
	* gettext-tools/src/read-po-lex.c (mbfile_init): Update.
	(mbfile_getc): Read pushed-back character before testing for sticky EOF.
	(mbfile_ungetc): Update.
	(mbfile_getc_normalized): New function.
	(lex_getc): Invoke mbfile_getc_normalized instead of mbfile_getc.
	* gettext-tools/tests/testdata/crlf.pot: New file.
	* gettext-tools/tests/msgcat-23: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2024-12-28  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* autogen.sh (GNULIB_MODULES_RUNTIME_FOR_SRC, GNULIB_MODULES_TOOLS_FOR_SRC,
	GNULIB_MODULES_TOOLS_FOR_SRC_COMMON_DEPENDENCIES, GNULIB_MODULES_TOOLS_OTHER,
	GNULIB_MODULES_LIBGETTEXTPO): Use the new names of renamed gnulib modules.
	* gnulib-local/modules/backupfile (Depends-on): Likewise.
	* gnulib-local/modules/closeout (Depends-on): Likewise.
	* gnulib-local/modules/libtextstyle-dummy (Depends-on): Likewise.
	* gnulib-local/modules/libxml (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/fd-ostream (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/html-styled-ostream (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/iconv-ostream (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/memory-ostream (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/noop-styled-ostream (Depends-on): Likewise.
	* libtextstyle/gnulib-local/modules/term-ostream (Depends-on): Likewise.

2024-12-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2024-12-27  Bruno Haible  <bruno@clisp.org>

	build: Fix "make dist" result when run in a VPATH build.
	Suggested by Simon Josefsson in
	<https://lists.gnu.org/archive/html/bug-gnulib/2024-12/msg00181.html>.

	* Makefile.am (gen-ChangeLogs): Consider $(srcdir).

2024-12-24  Bruno Haible  <bruno@clisp.org>

	intl: Support the UTF-8 environment on native Windows.
	Reported by Lasse Collin <lasse.collin@tukaani.org> in
	<https://lists.gnu.org/archive/html/bug-gettext/2024-12/msg00111.html>.

	* gettext-runtime/intl/setlocale.c: Include <windows.h>.
	(setlocale_unixlike): In the UTF-8 environment, append a suffix ".65001"
	to the locale names passed to the native setlocale().

2024-12-24  Bruno Haible  <bruno@clisp.org>

	intl: Handle LC_MESSAGES correctly on native Windows.
	* gettext-runtime/intl/setlocale.c (libintl_setlocale): Revamp the LC_ALL case
	if LC_MESSAGES is 1729.

2024-12-24  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2024-12-24  Bruno Haible  <bruno@clisp.org>

	lang-python-*: Fix test failures on mingw with UCRT.
	* gettext-tools/tests/lang-python-1: Disable ISO8859_LOCALE_UNSUPPORTED for
	Python 3. Set PYTHONIOENCODING environment variable.
	* gettext-tools/tests/lang-python-2: Likewise.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix a test failure on MSYS2.
	* libtextstyle/gnulib-local/tests/test-term-ostream-xterm-msys2.out: New file.
	* libtextstyle/gnulib-local/tests/test-term-ostream-xterm.sh: Use it as an
	expected test result.
	* libtextstyle/gnulib-local/modules/term-ostream-tests (Files): Add it.
	* libtextstyle/Makefile.am (EXTRA_DIST): Likewise.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	Fix test failure of lang-ruby.
	* gettext-tools/tests/lang-ruby: Skip the test if 'rxgettext' is not installed.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	examples: Don't fail build if rxgettext is not installed.
	* gettext-tools/examples/po/xsmallpot.sh: Ignore a 'make' failure in the
	hello-ruby example.
	* gettext-tools/examples/po/hello-ruby.pot: New generated file.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	examples: Don't fail configuration of hello-objc if no Objective-C compiler is found, part 2.
	* gettext-tools/examples/po/xsmallpot.sh: Don't remove the m4_pushdef, m4_popdef
	lines from hello-objc*/configure.ac.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	examples: Find the Objective-C compiler out-of-the-box on AlmaLinux 9 systems.
	* gettext-tools/examples/hello-objc-gnome2/configure.ac: Invoke AC_PROG_OBJC
	with a customized search list. Don't invoke AC_PROC_CC.

2024-12-23  Bruno Haible  <bruno@clisp.org>

	examples: Don't fail configuration of hello-objc if no Objective-C compiler is found.
	* gettext-tools/examples/hello-objc/configure.ac: Map AC_MSG_FAILURE to
	AC_MSG_WARN.

2024-12-20  Bruno Haible  <bruno@clisp.org>

	po: Remove a comment that is not valid any more since 2002-01-07.
	The comment "Target 'all' must not depend on target '$(DOMAIN).pot-update'"
	does not hold any more:
	  all <- all-yes <- $(srcdir)/stamp-po <- $(srcdir)/$(DOMAIN).pot
	and the latter rule executes
	  $(MAKE) $(DOMAIN).pot-update

	* gettext-runtime/po/Makefile.in: Remove comment.
	* gettext-tools/examples/po/Makefile.am: Likewise.
	* gettext-tools/examples/*/po/Makefile.am: Likewise.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile: Likewise.

2024-12-18  Bruno Haible  <bruno@clisp.org>

	New example 'hello-c++-gnome3'.
	* gettext-tools/examples/hello-c++-gnome3: New directory, based on
	gettext-tools/examples/hello-c-gnome3.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Update.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS,
	SMALLPOFILES_FOR_lang): Update.
	* gettext-tools/examples/README: Update.
	* gettext-tools/examples/check-examples: Handle this directory as well.
	* NEWS: Mention the new example.
	* HACKING: Mention the gtkmm dependency.

2024-12-18  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Document build dependencies.
	* HACKING: Mention Gtk3 dependency.

2024-12-18  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Add a simpler "hello world" program.
	* gettext-tools/examples/hello-c-gnome3/README: New file.
	* gettext-tools/examples/hello-c-gnome3/hello2.c: New file, based on
	gettext-tools/examples/hello-c-gnome3/hello.c.
	* gettext-tools/examples/hello-c-gnome3/hello2.desktop.in.in: New file, based on
	gettext-tools/examples/hello-c-gnome3/hello.desktop.in.in.
	* gettext-tools/examples/hello-c-gnome3/hello2.gresource.xml: New file, based on
	gettext-tools/examples/hello-c-gnome3/hello.gresource.xml.
	* gettext-tools/examples/hello-c-gnome3/hello2.ui: Renamed from
	gettext-tools/examples/hello-c-gnome3/hello.ui.
	* gettext-tools/examples/hello-c-gnome3/hello2.gschema.xml: New file, based on
	gettext-tools/examples/hello-c-gnome3/hello.gschema.xml.
	* gettext-tools/examples/hello-c-gnome3/hello.c: Greatly simplified.
	* gettext-tools/examples/hello-c-gnome3/hello.ui: Use an <object> element
	instead of a <template> element.
	* gettext-tools/examples/hello-c-gnome3/hello.gschema.xml: Remove file.
	* gettext-tools/examples/hello-c-gnome3/Makefile.am (bin_PROGRAMS): Add hello2.
	(hello-resources.c): Renamed from resources.c.
	(hello2_SOURCES): New variable.
	(hello2-resources.c): New target.
	(desktop_DATA): Add hello2.desktop.
	(hello2.desktop.in, hello2.desktop): New targets.
	(BUILT_SOURCES, CLEANFILES, MAINTAINERCLEANFILES): Update.
	(EXTRA_DIST): Remove hello.gschema.xml. Add hello2.desktop.in.in,
	hello2.desktop.in, hello2.gresource.xml, hello2.ui, hello2.gschema.xml.
	* gettext-tools/examples/hello-c-gnome3/po/POTFILES.in: Update.
	* gettext-tools/examples/hello-c-gnome3/autoclean.sh: Update.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES): Update.
	* gettext-tools/examples/po/Makefile.am (POTFILES): Update.

2024-12-18  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Make more robust.
	* gettext-tools/examples/hello-c-gnome3/hello.c (hello_application_window_init):
	Initialize label_id explicitly.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Fix "make distcheck".
	* gettext-tools/examples/hello-c-gnome3/Makefile.am (BUILT_SOURCES): Add
	hello.desktop.
	(gschemas.compiled): Make it work in VPATH builds.
	(CLEANFILES): Remove resources.c. Don't mention hello.desktop twice.
	(MAINTAINERCLEANFILES): Add resources.c.
	* gettext-tools/examples/hello-c-gnome3/autoclean.sh: Remove also resources.c,
	hello.desktop.in.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Avoid translator mistakes regarding markup (e.g. in de.po).
	* gettext-tools/examples/hello-c-gnome3/hello.c (hello_application_window_init):
	Move HTML markup outside of translatable strings.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Fix an error "Settings schema 'org.gnu.gettext.examples.hello' is not installed".
	* gettext-tools/examples/hello-c-gnome3/configure.ac: Invoke
	gl_BUILD_TO_HOST_LOCALEDIR, gl_BUILD_TO_HOST_PKGDATADIR.
	* gettext-tools/examples/hello-c-gnome3/Makefile.am (DEFS): Define also
	PKGDATADIR.
	(pkgdata_DATA): New variable.
	* gettext-tools/examples/hello-c-gnome3/hello.c (main): Add PKGDATADIR to the
	GSETTINGS_SCHEMA_DIR value.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	hello-c-gnome3: Exit when the window's close button is clicked.
	* gettext-tools/examples/hello-c-gnome3/hello.c
	(hello_application_window_dispose): Remove function.
	(hello_application_window_class_init): Don't overwrite the 'dispose' field.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	Rename some examples.
	* gettext-tools/examples/hello-c-gnome2: Renamed from
	gettext-tools/examples/hello-c-gnome.
	* gettext-tools/examples/hello-c++-gnome2: Renamed from
	gettext-tools/examples/hello-c++-gnome.
	* gettext-tools/examples/hello-objc-gnome2: Renamed from
	gettext-tools/examples/hello-objc-gnome.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Update.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS,
	SMALLPOFILES_FOR_lang): Update.
	* gettext-tools/examples/README: Update.
	* gettext-tools/examples/check-examples: Update.
	* check-copyright-headers: Update.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	New example 'hello-ruby'.
	* gettext-tools/examples/hello-ruby: New directory, based on
	gettext-tools/examples/hello-php.
	* gettext-tools/examples/Makefile.am (EXAMPLESFILES, EXAMPLESDIRS): Update.
	* gettext-tools/examples/po/Makefile.am (POTFILES, SMALLPOTS,
	SMALLPOFILES_FOR_lang): Update.
	* gettext-tools/examples/README: Update.
	* gettext-tools/examples/check-examples: Handle this directory as well.
	* NEWS: Mention the new example.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	Ruby: Add unit test for Ruby support.
	* gettext-tools/tests/lang-ruby: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	doc: Update list of dependencies.
	* gettext-tools/doc/lang-csharp.texi: Mention dotnet8 as alternative.
	* gettext-tools/tests/lang-csharp: Likewise.
	* gettext-tools/doc/lang-pascal.texi: Replace fpk with fpc.
	* gettext-tools/tests/lang-pascal: Likewise.
	* gettext-tools/doc/lang-wxwidgets.texi: Mention libwxgtk3.2-dev as alternative.
	* gettext-tools/tests/lang-objc: Mention the gobjc package.
	* gettext-tools/tests/lang-rst: Mention the fp-utils package.
	* gettext-tools/tests/lang-vala: Mention valac as alternative.

2024-12-16  Bruno Haible  <bruno@clisp.org>

	Fix "make distcheck" failure (regression from "po: Rename Makefile.in.in to Makefile.in.").
	* gettext-runtime/po/Makefile.in (DISTFILES.common): Remove Makefile.in.

2024-12-15  Bruno Haible  <bruno@clisp.org>

	doc: Update reference to lua-gettext package.
	* gettext-tools/doc/lang-lua.texi: Update lua-gettext installation instructions.
	* HACKING: Update lua version requirements and lua-gettext installation
	instructions.

2024-12-12  Bruno Haible  <bruno@clisp.org>

	intl-java: Fix a deprecation warning.
	* gettext-runtime/intl-java/gnu/gettext/GettextResource.java (ngettextnull): Use
	Long.valueOf(n) instead of new Long(n).

2024-12-12  Bruno Haible  <bruno@clisp.org>

	libtextstyle: Fix a gcc 13 -Wunused-result warning.
	* libtextstyle/gnulib-local/lib/glib/gstrfuncs.c (g_strdup_vprintf): Don't
	assume that vasprintf leaves the pointed-to variable unchanged when it fails.

2024-12-12  Bruno Haible  <bruno@clisp.org>

	libxml: Fix a gcc 13 -Wformat-truncation warning.
	* gnulib-local/lib/libxml/uri.c (xmlURIEscape): Use a buffer of size 12, not 10.

2024-12-12  Bruno Haible  <bruno@clisp.org>

	Silence -Wstack-protector warnings from Ubuntu gcc 13 and 14.
	* m4/more-warnings.m4 (gt_MORE_WARNINGS): Silence -Wstack-protector also
	for newer gcc versions.

2024-12-12  Bruno Haible  <bruno@clisp.org>

	doc: Update list of dependencies.
	* DEPENDENCIES: Add libattr.
	* HACKING: Stop mentioning XEmacs. Add note regarding GNU Smalltalk.
	Mention dotnet as alternative to Mono. Mention wxgtk version 3.2.

2024-12-10  Bruno Haible  <bruno@clisp.org>

	po: Rename Makefile.in.in to Makefile.in.
	* gettext-runtime/po/Makefile.in: Renamed from gettext-runtime/po/Makefile.in.in.
	(distclean): Don't remove Makefile.in.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Remove the 'po-directories'
	commands.
	* gettext-runtime/configure.ac: Update AC_OUTPUT invocation.
	* gettext-runtime/Makefile.am (maintainer-update-po): Update.
	* gettext-tools/configure.ac: Update AC_OUTPUT invocation.
	* gettext-tools/Makefile.am (maintainer-update-po): Update.
	* gettext-tools/doc/gettext.texi (Translator advice, po/Rules-*, configure.ac,
	Files under Version Control, Maintainers for other Languages): Update.
	* gettext-tools/doc/gettextize.texi: Update.
	* gettext-tools/examples/README: Update.
	* gettext-tools/examples/hello-c/autoclean.sh: Update.
	* gettext-tools/examples/hello-c-gnome/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c-gnome3/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c++/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c++-gnome/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c++-kde/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-c++20/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-objc/autoclean.sh: Likewise.
	* gettext-tools/examples/hello-objc-gnome/autoclean.sh: Likewise.
	* gettext-tools/misc/autopoint.in: Update search for po directories.
	* gettext-tools/misc/gettextize.in: Treat Makefile.in like Makefile.in.in
	before. Treat Makefile.in.in as a removed file.
	* gettext-tools/tests/autopoint-2: Prepare for bumping ARCHIVE_VERSION.
	* gettext-tools/tests/autopoint-3: Likewise.
	* autogen.sh: Copy po/Makefile.in instead of po/Makefile.in.in.
	* Makefile.am (distcheck-hook): Update.
	* NEWS: Mention the change.

2024-12-10  Bruno Haible  <bruno@clisp.org>

	build: Read LINGUAS at 'make' time, not at 'configure' time, part 2.
	* gettext-tools/examples/hello-csharp*/po/Makefile.am: Remove a comment.
	* gettext-tools/examples/hello-tcl*/po/Makefile.am: Likewise.

2024-12-09  Bruno Haible  <bruno@clisp.org>

	Use new approach for gnulib localizations.
	* gettext-runtime/po/POTFILES.in: Remove files that come from gnulib.
	* gettext-tools/po/POTFILES.in: Likewise.
	* gettext-runtime/src/envsubst.c (main): Invoke bindtextdomain for the domain
	'gnulib'.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.

2024-12-08  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/src/Makefile.am (DEFS): Remove definition of BISON_LOCALEDIR,
	now present in config.h.

2024-12-08  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2024-12-07  Bruno Haible  <bruno@clisp.org>

	build: Include the Rules-* files at 'make' time, not at 'configure' time.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Don't splice in the Rules-* files
	here.
	* gettext-runtime/po/Makefile.in.in: Collect and include the Rules-* files
	explicitly.

2024-12-07  Bruno Haible  <bruno@clisp.org>

	po: Support more than 3 Rules-* extensions.
	* gettext-runtime/po/Makefile.in.in (DISTFILES.common): Add placeholders for
	extensions 4..6.
	(DISTFILES): Likewise.

2024-12-07  Bruno Haible  <bruno@clisp.org>

	build: Include Makevars at 'make' time, not at 'configure' time.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Don't splice in Makevars here.
	* gettext-runtime/po/Makefile.in.in: Include Makevars explicitly.

2024-12-07  Bruno Haible  <bruno@clisp.org>

	build: No more need to rebuild a Makefile after POTFILES.in or LINGUAS changed.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Don't set or substitute
	POMAKEFILEDEPS.
	(AM_POSTPROCESS_PO_MAKEFILE): Remove dependency from Makefile on LINGUAS.
	* gettext-runtime/po/Makefile.in.in (Makefile): Remove dependency on
	@POMAKEFILEDEPS@.

2024-12-07  Bruno Haible  <bruno@clisp.org>

	build: Read LINGUAS at 'make' time, not at 'configure' time.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Move the obsolete ALL_LINGUAS check.
	Define DESIRED_LINGUAS. Don't compute ALL_LINGUAS, POFILES, UPDATEPOFILES,
	DUMMYPOFILES, GMOFILES, INST_LINGUAS, CATALOGS any more.
	(AM_POSTPROCESS_PO_MAKEFILE): Don't compute and substitute ALL_LINGUAS, POFILES,
	UPDATEPOFILES, DUMMYPOFILES, GMOFILES, PROPERTIESFILES, CLASSFILES, QMFILES,
	MSGFILES, RESOURCESDLLFILES, INST_LINGUAS, CATALOGS, JAVACATALOGS, QTCATALOGS,
	TCLCATALOGS, CSHARPCATALOGS any more. Don't add rules for Tcl and C# catalogs
	any more.
	* gettext-runtime/po/Makefile.in.in (ALL_LINGUAS, POFILES, GMOFILES,
	UPDATEPOFILES, DUMMYPOFILES): Define with a computed value.
	(DESIRED_LINGUAS): New macro.
	(INST_LINGUAS, CATALOGS): Define with a computed value.
	* gettext-tools/examples/po/Makefile.am (ALL_LINGUAS, POFILES, UPDATEPOFILES,
	DUMMYPOFILES): Define with a computed value.
	* gettext-tools/examples/hello-*/po/Makefile.am (ALL_LINGUAS, POFILES, GMOFILES,
	UPDATEPOFILES, DUMMYPOFILES): Define with a computed value.
	(DESIRED_LINGUAS): New macro.
	(INST_LINGUAS, CATALOGS): Define with a computed value.
	* gettext-tools/examples/hello-csharp*/po/Makefile.am (ALL_LINGUAS, POFILES,
	UPDATEPOFILES, DUMMYPOFILES, RESOURCESDLLFILES): Define with a computed value.
	Include .csharp-rules.
	(DESIRED_LINGUAS): New macro.
	(INST_LINGUAS, CATALOGS): Define with a computed value.
	(DISTCLEANFILES): New variable.
	* gettext-tools/examples/hello-tcl*/po/Makefile.am (ALL_LINGUAS, POFILES,
	UPDATEPOFILES, DUMMYPOFILES, MSGFILES): Define with a computed value.
	Include .tcl-rules.
	(DESIRED_LINGUAS): New macro.
	(INST_LINGUAS, CATALOGS): Define with a computed value.
	(DISTCLEANFILES): New variable.

2024-12-06  Bruno Haible  <bruno@clisp.org>

	build: Read POTFILES.in at 'make' time, not at 'configure' time.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Bump GETTEXT_MACRO_VERSION to 0.24.
	Don't create POTFILES any more.
	(AM_POSTPROCESS_PO_MAKEFILE): Don't substitute POTFILES_DEPS any more.
	* gettext-runtime/po/Makefile.in.in (GETTEXT_MACRO_VERSION): Bump to 0.24.
	Mention 'make' requirements.
	(POTFILES, POTFILES_DEPS): Define with a computed value.
	($(DOMAIN).pot-update): Depend on POTFILES_DEPS, not POTFILES.
	(distclean): Don't remove POTFILES any more.
	* gettext-tools/examples/README: Mention 'make' requirements.
	* gettext-tools/examples/po/Makefile.am (POTFILES_DEPS): Define with a computed
	value.
	* gettext-tools/examples/hello-*/po/Makefile.am (POTFILES_DEPS): Likewise.

2024-12-06  Bruno Haible  <bruno@clisp.org>

	examples: hello-python: Make it work with Python 3.
	* gettext-tools/examples/hello-python/hello.py.in: Add parenthese around print's
	arguments.

2024-12-06  Bruno Haible  <bruno@clisp.org>

	build: Remove left-overs from remove-potcdate.sin.
	* gettext-runtime/po/Makefile.in.in (.SUFFIXES): Remove '.sed'.
	* gettext-tools/examples/po/Makefile.am (.SUFFIXES): Remove '.sed' and '.sin'.
	(.sin.sed): Remove rule.
	* gettext-tools/examples/hello-*/po/Makefile.am: Likewise.

2024-12-04  Bruno Haible  <bruno@clisp.org>

	intl: Fix a gcc 14 -Wmissing-variable-declarations warning.
	* gettext-runtime/intl/gettextP.h (_nl_state_lock): New declaration.
	* gettext-runtime/intl/bindtextdom.c (_nl_state_lock): Remove declaration.
	* gettext-runtime/intl/textdomain.c (_nl_state_lock): Remove declaration.

2024-12-04  Bruno Haible  <bruno@clisp.org>

	Refactor: Fix some gcc 14 -Wshadow warnings.
	* gettext-tools/src/x-c.c (phase5_get): Rename some local variables.
	* gettext-tools/src/x-php.c (phase4_get): Likewise.

2024-12-03  Bruno Haible  <bruno@clisp.org>

	Refactor: Use 'const' in a few more places.
	* gnulib-local/lib/mem-hash-map.h (hash_find_entry): Mark htab as a 'const' pointer.
	* gnulib-local/lib/mem-hash-map.c (lookup, hash_find_entry): Likewise.
	* gettext-tools/src/message.h (message_list_search): Mark mlp as a 'const' pointer.
	* gettext-tools/src/message.c (message_list_search): Likewise.
	* gettext-tools/src/msgl-ascii.h (is_ascii_string_list): Mark slp as a 'const' pointer.
	(is_ascii_message): Mark mp as a 'const' pointer.
	(is_ascii_message_list): Mark mlp as a 'const' pointer.
	(is_ascii_msgdomain_list): Mark mdlp as a 'const' pointer.
	* gettext-tools/src/msgl-ascii.c (is_ascii_string_list): Mark slp as a 'const' pointer.
	(is_ascii_message): Mark mp as a 'const' pointer.
	(is_ascii_message_list): Mark mlp as a 'const' pointer.
	(is_ascii_msgdomain_list): Mark mdlp as a 'const' pointer.
	* gettext-tools/src/msgl-ofn.h (message_has_filenames_with_spaces): Mark mp as a 'const' pointer.
	(message_list_has_filenames_with_spaces): Mark mlp as a 'const' pointer.
	(msgdomain_list_has_filenames_with_spaces): Mark mdlp as a 'const' pointer.
	* gettext-tools/src/msgl-ofn.c (message_has_filenames_with_spaces): Mark mp as a 'const' pointer.
	(message_list_has_filenames_with_spaces): Mark mlp as a 'const' pointer.
	(msgdomain_list_has_filenames_with_spaces): Mark mdlp as a 'const' pointer.
	* gettext-tools/src/msgl-check.h (check_message_list): Mark mlp as a 'const' pointer.
	* gettext-tools/src/msgl-check.c (check_plural, check_message_list): Likewise.

2024-12-03  Bruno Haible  <bruno@clisp.org>

	Update packaging instructions.
	* PACKAGING: Update file list. Update C# explanations.

2024-12-02  Bruno Haible  <bruno@clisp.org>

	Use a warranty disclaimer in all-permissive license notices.
	* gnulib-local/m4/*.m4: Update.
	* libtextstyle/gnulib-local/m4/*.m4: Update.
	* gettext-runtime/m4/*.m4: Update.
	* gettext-tools/m4/*.m4: Update.
	* m4/woe32-dll.m4: Update.

2024-12-02  Bruno Haible  <bruno@clisp.org>

	tests: Add lang-c++26 test.
	* gettext-tools/tests/lang-c++26: New file, based on
	gettext-tools/tests/lang-c++20.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2024-12-02  Bruno Haible  <bruno@clisp.org>

	tests: Fix lang-c++20 failure with g++ >= 14 or clang++ >= 19.
	* gettext-tools/tests/lang-c++20: Support newer C++ versions. Try option
	-std=gnu++26, necessary for newer C++ versions.

2024-12-02  Bruno Haible  <bruno@clisp.org>

	examples: Update hello-c++20 to work with g++ >= 14 and clang++ >= 19.
	* gettext-tools/examples/hello-c++20/configure.ac: Support newer C++ versions.
	Try option -std=gnu++26, necessary for newer C++ versions.
	* gettext-tools/examples/hello-c++20/hello.cc (main): Use different code in
	newer C++.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Fix compilation error with libxml2 >= 2.12.0 and gcc >= 14.
	Reported by Sam James <sam@gentoo.org>
	at <https://savannah.gnu.org/bugs/?66506>.

	* gettext-tools/src/its.c: Include <libxml/xmlversion.h>.
	(structured_error): Adapt to API change.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Update NEWS.
	* NEWS: Move an entry.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	examples: Use infrastructure from gettext version 0.23.
	* gettext-tools/examples/hello-*/configure.ac: Use AM_GNU_GETTEXT_VERSION with
	version 0.23.
	* gettext-tools/examples/hello-c++-kde/configure.in.in: Likewise.
	* gettext-tools/examples/hello-*/m4/Makefile.am: Update .m4 file list.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Update translations from TP.
	* gettext-runtime/po/*.po: Update from TP.
	* gettext-tools/po/*.po: Update from TP.
	* gettext-tools/po/LINGUAS: Add ka.
	* gettext-tools/examples/po/*.po: Update from TP.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Prepare for 0.23 release.
	* gettext-runtime/doc/matrix.texi: Update from TP.
	* gettext-runtime/doc/nls.texi (STATUS): Update.
	* gettext-runtime/po/Makefile.in.in: Bump Origin version and
	GETTEXT_MACRO_VERSION.
	* gettext-runtime/m4/po.m4 (AM_PO_SUBDIRS): Bump GETTEXT_MACRO_VERSION
	accordingly.
	* gettext-runtime/m4/gettext.m4: Update comments.
	* gettext-runtime/intl/libgnuintl.in.h (LIBINTL_VERSION): Bump.
	* libtextstyle/version.sh: Update VERSION_NUMBER, RELEASE_DATE.
	* gettext-tools/libgettextpo/gettext-po.in.h (LIBGETTEXTPO_VERSION): Bump.
	* gettext-runtime/intl/Makefile.am (LTV_*): Bump to 12:1:4.
	* libtextstyle/lib/Makefile.am (LTV_*): Bump to 2:2:2.
	* gettext-tools/libgettextpo/Makefile.am (LTV_*): Bump to 5:11:5.
	* gettext-runtime/src/envsubst.c (main): Update copyright year in --version
	output.
	* gettext-runtime/src/gettext.c (main): Likewise.
	* gettext-runtime/src/gettext.sh.in (func_version): Likewise.
	* gettext-runtime/src/ngettext.c (main): Likewise.
	* gettext-tools/src/cldr-plurals.c (main): Likewise.
	* gettext-tools/src/hostname.c (main): Likewise.
	* gettext-tools/src/msgattrib.c (main): Likewise.
	* gettext-tools/src/msgcat.c (main): Likewise.
	* gettext-tools/src/msgcmp.c (main): Likewise.
	* gettext-tools/src/msgcomm.c (main): Likewise.
	* gettext-tools/src/msgconv.c (main): Likewise.
	* gettext-tools/src/msgen.c (main): Likewise.
	* gettext-tools/src/msgexec.c (main): Likewise.
	* gettext-tools/src/msgfilter.c (main): Likewise.
	* gettext-tools/src/msgfmt.c (main): Likewise.
	* gettext-tools/src/msggrep.c (main): Likewise.
	* gettext-tools/src/msginit.c (main): Likewise.
	* gettext-tools/src/msgmerge.c (main): Likewise.
	* gettext-tools/src/msgunfmt.c (main): Likewise.
	* gettext-tools/src/msguniq.c (main): Likewise.
	* gettext-tools/src/recode-sr-latin.c (main): Likewise.
	* gettext-tools/src/urlget.c (main): Likewise.
	* gettext-tools/src/xgettext.c (main): Likewise.
	* gettext-tools/misc/convert-archive.in (func_version): Likewise.
	* gettext-tools/misc/gettextize.in (func_version): Likewise.
	* gettext-tools/misc/autopoint.in: Likewise. Accept version 0.23.
	* gettext-tools/configure.ac (ARCHIVE_VERSION): Bump to 0.23.
	* NEWS, gettext-runtime/NEWS: Update.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2024-12-01  Bruno Haible  <bruno@clisp.org>

	xgettext: C: Revisit "hexadecimal escape sequence out of range" warnings.
	Reported by Vaclav Slavik <vaclav@slavik.io>
	at <https://savannah.gnu.org/bugs/?65053>.

	* gettext-tools/src/x-c.c (get_string_element): Add context argument. Don't warn
	for character literals. For wide strings, use a different warning and complain
	about "out of range" only for values >= 0x110000.
	(phase5_get): Distinguish normal string literals and wide string literals.

2024-11-30  Bruno Haible  <bruno@clisp.org>

	intl: Fix lang-c++ failure on MSVC, caused by last commit.
	* gettext-runtime/intl/libgnuintl.in.h (_INTL_HAS_FORCE_INLINE,
	_INTL_FORCE_INLINE): New macros.
	(_INTL_REDIRECT_INLINE): Don't define in C++ mode when _INTL_HAS_FORCE_INLINE
	is not set.

2024-11-28  Bruno Haible  <bruno@clisp.org>

	intl: Avoid conflict between libintl.h and some C++ header files.
	Reported Pierre Ossman <ossman@cendio.se>
	at <https://savannah.gnu.org/bugs/?64006>.

	* gettext-runtime/intl/libgnuintl.in.h (*printf, newlocale, duplocale,
	freelocale, setlocale): Use _INTL_REDIRECT_INLINE or _INTL_ASM as alternatives
	to _INTL_REDIRECT_MACROS, avoiding conflicts with inline functions in mingw
	and MSVC <stdio.h>.

2024-11-28  Bruno Haible  <bruno@clisp.org>

	intl: Avoid possible error from libintl.h in C++ mode.
	* gettext-runtime/intl/libgnuintl.in.h (gettext, dgettext, dcgettext, ngettext,
	dngettext, dcngettext, textdomain, bindtextdomain, wbindtextdomain,
	bind_textdomain_codeset): In the _INTL_REDIRECT_INLINE redirects, in C++ mode,
	avoid a compilation error if the function is globally declared in some .h file.

2024-11-27  Bruno Haible  <bruno@clisp.org>

	doc: Avoid @table, as it cannot be used to produce decent-looking output.

2024-11-27  Bruno Haible  <bruno@clisp.org>

	doc: Mention C.UTF-8 locale.
	Reported by nl6720 at <https://savannah.gnu.org/bugs/?62815>.

	* gettext-tools/doc/gettext.texi (Locale Names): Mention the C.UTF-8 locale.

2024-11-27  Bruno Haible  <bruno@clisp.org>

	Add installation information for the tarball users and from a git checkout.
	We want to have an INSTALL file that contains installation instructions for
	the tarball users. These instructions are necessarily package specific,
	because they need to list the prerequisites or reference the DEPENDENCIES
	file.

	Additionally, many people who are not aware that tarballs are the primary
	means for source code distribution of GNU packages check out the git repository
	and then expect to see instructions for installing from that git checkout
	in the INSTALL file. See e.g. <https://savannah.gnu.org/bugs/?62196>.

	Unfortunately, both Automake (with strictness option = 'gnu') and 'bootstrap'
	both contain code to copy the generic (not package specific) installation
	instructions to the file 'INSTALL'. This is not what we want, so we disable
	it. (Other packages handle this issue by putting part of the installation
	instructions into the README file. This is suboptimal, because this is not
	what the README file is for.)

	* autogen.sh: Import INSTALL.generic from gnulib.
	* INSTALL: Entirely rewritten, based on poke/INSTALL.
	* Makefile.am (EXTRA_DIST): Add INSTALL.generic.
	* libtextstyle/autogen.sh: Import INSTALL.generic from gnulib.
	* libtextstyle/INSTALL: Entirely rewritten, based on poke/INSTALL.
	* libtextstyle/Makefile.am (EXTRA_DIST): Add INSTALL.generic.

2024-11-27  Bruno Haible  <bruno@clisp.org>

	lang-perl-*: Avoid FAIL on macOS.
	Reported by Hanspeter Niederstrasser <nieder@users.sourceforge.net>
	at <https://savannah.gnu.org/bugs/?66461>.

	* gettext-tools/tests/lang-perl-1: On macOS, don't test the ISO-8859-1 locale.
	* gettext-tools/tests/lang-perl-2: Likewise.

2024-11-24  Bruno Haible  <bruno@clisp.org>

	Fix compilation error when pgettext is used.
	Reported by Friedrich Beckmann <friedrich.beckmann@posteo.de> in
	<https://lists.gnu.org/archive/html/bug-gnulib/2024-11/msg00189.html>.

	* gnulib-local/lib/gettext.h: Include <locale.h>.

2024-11-22  Bruno Haible  <bruno@clisp.org>

	Upgrade to libtool 2.5.4.
	* m4/libtool.m4: Update from libtool-2.5.4.
	* m4/ltversion.m4: Likewise.
	* build-aux/ltmain.sh: Likewise.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	po: Fix build failure with parallel make.
	Reported by Lubomir Rintel <lkundrak@v3.sk> in
	<https://lists.gnu.org/archive/html/bug-gettext/2022-06/msg00022.html>.

	* gettext-runtime/po/Makefile.in.in (.NOTPARALLEL): Add this special target.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	doc: Improve typography in man pages.
	Patch by наб <nabijaczleweli@nabijaczleweli.xyz> in
	<https://lists.gnu.org/archive/html/bug-gettext/2022-01/msg00019.html>.

	* gettext-runtime/man/bind_textdomain_codeset.3.in: After "e.g." or "i.e.",
	use \&.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	doc: Use GNU coding style in man pages.
	Reported by наб <nabijaczleweli@nabijaczleweli.xyz> in
	<https://lists.gnu.org/archive/html/bug-gettext/2022-01/msg00019.html>.

	* gettext-runtime/man/gettext.3.in: In C code snippets, put a space before '('
	and after ','.
	* gettext-runtime/man/bind_textdomain_codeset.3.in: Likewise.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	xgettext: PHP: Stop recognizing ASP tags <% and %> (removed in PHP 7.0).
	Reported by David Robinson <dave@netterra.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2021-10/msg00000.html>.

	* gettext-tools/src/x-php.c (skip_html): Don't recognize '<%' and '<%='
	any more.
	(phase2_getc, phase3_getc, phase4_get): In comments, don't treat '%>' like '?>'
	any more.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	libgettextpo: Extend the function po_message_set_format.
	Reported by Alexander Potashev <aspotashev@gmail.com>
	at <https://savannah.gnu.org/bugs/?61160>.

	* gettext-tools/libgettextpo/gettext-po.c (po_message_set_format): Support a
	negative value.
	* gettext-tools/libgettextpo/gettext-po.in.h (po_message_set_format): Mention
	effects of po_message_set_format (..., -1).
	* gettext-tools/doc/gettext.texi (po_message_t API): Likewise.
	* NEWS: Mention the change.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	Improve comments.
	* gettext-tools/src/locating-rules.h (locating_rule_list_locate): Improve
	specification.
	* gettext-tools/src/sentence.h (sentence_end): Likewise.

2024-11-19  Bruno Haible  <bruno@clisp.org>

	Avoid undefined behaviour.
	* gettext-tools/src/quote.h (scan_quoted): Add comment. Avoid undefined
	behaviour if length==0.

2024-11-16  Bruno Haible  <bruno@clisp.org>

	Fix "gcc -Wzero-as-null-pointer-constant" warnings.
	* libtextstyle/gnulib-local/lib/libcroco/cr-enc-handler.c (gv_default_aliases):
	Use NULL, not 0, to denote a null pointer.
	* libtextstyle/gnulib-local/lib/libcroco/cr-om-parser.c
	(cr_om_parser_parse_paths_to_cascade): Likewise.
	* gettext-tools/libgrep/kwset.c (kwsalloc, kwsincr, kwsprep, cwexec, kwsexec):
	Likewise.

2024-11-08  Bruno Haible  <bruno@clisp.org>

	Refactor.
	* gettext-tools/src/cldr-plural-exp.c: Don't include <unistd.h>, unistr.h.
	* gettext-tools/src/cldr-plural.y: Don't include <unistd.h>.

2024-11-08  Bruno Haible  <bruno@clisp.org>

	Refactor.
	* gettext-tools/src/cldr-plural.y: Untabify.
	(struct cldr_plural_parse_args): New type, moved here from
	gettext-tools/src/cldr-plural-exp.h.
	(cldr_plural_parse): New function, moved here from
	gettext-tools/src/cldr-plural-exp.c.
	* gettext-tools/src/cldr-plural-exp.h: Reorder declarations.
	(struct cldr_plural_parse_args): Remove declaration.
	* gettext-tools/src/cldr-plural-exp.c: Don't include cldr-plural.h. Reorder
	functions.
	(cldr_plural_parse): Remove function.

2024-11-07  Bruno Haible  <bruno@clisp.org>

	Update the GFDL text.
	* libtextstyle/doc/fdl.texi: Update from gnulib/doc/fdl-1.3.texi.

2024-11-07  Bruno Haible  <bruno@clisp.org>

	Upgrade from GFDL 1.2 to GFDL 1.3.
	* gettext-runtime/libasprintf/fdl.texi: Update from gnulib/doc/fdl-1.3.texi.
	* gettext-tools/doc/fdl.texi: Likewise.
	* gettext-runtime/libasprintf/autosprintf.texi: Update reference.
	* gettext-tools/doc/gettext.texi: Likewise.

2024-11-07  Bruno Haible  <bruno@clisp.org>

	Update the GPL and LGPL text.
	* gettext-runtime/intl/COPYING.LIB: Update from
	<https://ftp.gnu.org/gnu/Licenses/lgpl-2.1.txt>.
	* gettext-runtime/libasprintf/COPYING.LIB: Likewise.
	* gettext-runtime/libasprintf/gpl.texi: Update from gnulib/doc/gpl-2.0.texi.
	* gettext-runtime/libasprintf/lgpl.texi: Update from gnulib/doc/lgpl-2.1.texi.
	* gettext-tools/doc/gpl.texi: Update from gnulib/doc/gpl-2.0.texi.
	* gettext-tools/doc/lgpl.texi: Update from gnulib/doc/lgpl-2.1.texi.

2024-11-06  Bruno Haible  <bruno@clisp.org>

	build: Fix "make distcheck" after the line-breaking algorithm changed, part 2.
	* gettext-tools/configure.ac (MSGMERGE): Test $cross_compiling, since
	$CROSS_COMPILING is not set at this point.

2024-10-28  Bruno Haible  <bruno@clisp.org>

	Update legally relevant info.
	* AUTHORS: Incorporate records from gnu.org:/gd/gnuorg/copyright.list.

2024-10-28  Bruno Haible  <bruno@clisp.org>

	doc: Improve usability of generated PDF.
	* gettext-tools/doc/gettext.texi: Use a brown colour for interactive links.

2024-10-25  Bruno Haible  <bruno@clisp.org>

	build: Fix "make distcheck" failure (regression 2024-10-23).
	* check-copyright-headers (func_check_file): Update after DISCLAIM was renamed.

2024-10-24  Bruno Haible  <bruno@clisp.org>

	doc: Add some words about dialects.
	Reported by John Cowan <cowan@ccil.org>
	at <https://savannah.gnu.org/bugs/?47838>.

	* gettext-tools/doc/gettext.texi (The LANGUAGE variable): Add a paragraph
	about Chinese.
	(Dialects): New section.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	doc: Tweaks.
	* gettext-tools/doc/gettext.texi (Responsibilities): Tweaks, from
	Benno Schulenberg.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	doc: Revise "Translators" chapter.
	* gettext-tools/doc/gettext.texi (Trans Intro 0, Trans Intro 1, Discussions,
	Organization, Information Flow): Remove sections.
	(Organization, Responsibilities): New sections.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	Rename and distribute the disclaimer file.
	* gettext-tools/misc/disclaim-translations.txt: Renamed from
	gettext-tools/misc/DISCLAIM.
	* gettext-tools/Makefile.am (EXTRA_DIST): Update.
	(pkgdata_DATA): New variable.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	build: Simplify.
	* gettext-tools/Makefile.am (gettextsrcdir): Remove variable.
	(pkgdata_SCRIPTS): Renamed from gettextsrc_SCRIPTS.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	Fix test failure of autopoint-3 on Cygwin.
	It was broken since commit "tests: Use libtool in autopoint-3 test" (2014-09-05):
	The Makefile specified to link the 'hello' program without libtool
	(and thus Automake generated a direct link command without libtool),
	but the LDADD variable used @LTLIBINTL@. On Cygwin, this led to a use of
	the -R option, which the compiler does not understand:
	x86_64-pc-cygwin-gcc: error: unrecognized command line option ‘-R’; did you mean ‘-R’?

	* gettext-tools/tests/autopoint-3: Don't invoke LT_INIT. Use @LIBINTL@,
	not @LTLIBINTL@. Don't touch ltmain.sh.

2024-10-23  Bruno Haible  <bruno@clisp.org>

	Improve handling of Windows DLL directories when executing programs.
	Reported by Michele Locati <mlocati@gmail.com>
	at <https://savannah.gnu.org/bugs/?66356>.

	Revert commit e2839b591c from 2019-05-01. Instead, use gnulib's new feature.

	* gettext-tools/src/Makefile.am (DEFS): Define BINDIR.
	* gettext-tools/src/msginit.c: Don't include configmake.h.
	(main): Don't add BINDIR to PATH globally.
	(get_user_email, language_team_address, plural_forms): Pass a dll_dirs argument
	to create_pipe_in.
	* autogen.sh (GNULIB_MODULES_TOOLS_FOR_SRC): Remove configmake.

2024-10-22  Bruno Haible  <bruno@clisp.org>

	Update after gnulib changed.
	* gettext-tools/src/msgexec.c (process_string): Update create_pipe_out
	invocation.
	* gettext-tools/src/write-resources.c (execute_writing_input): Likewise.
	* gettext-tools/src/msginit.c (project_id, project_id_version, get_user_email,
	language_team_address, plural_forms): Update create_pipe_in invocations.
	* gettext-tools/src/read-csharp.c (execute_and_read_po_output): Likewise.
	* gettext-tools/src/read-java.c (execute_and_read_po_output): Likewise.
	* gettext-tools/src/read-resources.c (execute_and_read_po_output): Likewise.
	* gettext-tools/src/read-tcl.c (msgdomain_read_tcl): Likewise.
	* gettext-tools/src/x-ruby.c (extract_ruby): Likewise.
	* gettext-tools/src/urlget.c (execute_it, fetch): Update execute invocations.

2024-10-22  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.

2024-10-22  Bruno Haible  <bruno@clisp.org>

	Update the translation disclaimer.
	From Craig Topham <copyright-clerk@fsf.org>.

	* gettext-tools/misc/DISCLAIM: Update.

2024-10-21  Bruno Haible  <bruno@clisp.org>

	doc: Update after Automake changed.
	* gettext-tools/doc/gettextize.texi: Update now that Automake with option 'gnu'
	no longer requires ABOUT-NLS. Cf.
	<https://git.savannah.gnu.org/gitweb/?p=automake.git;a=commitdiff;h=a2def8cdef>.

2024-10-18  Bruno Haible  <bruno@clisp.org>

	doc: Add an example regarding xgettext.
	Reported by Andrea G. Monaco <andrea.monaco@autistici.org> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-12/msg00036.html>.

	* gettext-tools/doc/xgettext.texi: Add an example.

2024-10-18  Bruno Haible  <bruno@clisp.org>

	xgettext: Python: Add test for warning that was broken in 0.21.x and 0.22.x.
	Reported by Max Smolens <msmolens@gmail.com> in
	<https://lists.gnu.org/archive/html/bug-gettext/2020-10/msg00001.html>.

	* gettext-tools/tests/xgettext-python-9: New file.
	* gettext-tools/tests/Makefile.am (TESTS): Add it.

2024-10-17  Bruno Haible  <bruno@clisp.org>

	doc: Clarify locale names and language names.
	Reported by Arfrever <arfrever.fta@gmail.com>
	at <https://savannah.gnu.org/bugs/?59062>.

	* gettext-runtime/doc/nls.texi (INSTALL Matters, Using This Package): Mention
	ll_CC as alterntive to ll, and that ll can be a 3-letter code.
	* gettext-tools/doc/gettext.texi (Locale Names, Header Entry, Installers):
	Likewise.

2024-10-15  Bruno Haible  <bruno@clisp.org>

	intl: Fix a memory leak.
	* gettext-runtime/intl/finddomain.c (_nl_find_domain): If there was an alias and
	_nl_explode_name or _nl_make_l10nflist fails, free the allocated memory. Avoid
	'goto'.

2024-10-15  Bruno Haible  <bruno@clisp.org>

	gettext.h: Avoid "warning: ISO C++ forbids variable length array" with -pedantic.
	Both "g++ -pedantic" and "clang++ -pedantic" warn about use of VLAs.
	Since we cannot distinguish "g++" from "g++ -pedantic" through a preprocessor
	macro, it's best to not use a VLA in C++.

	Reported by Jens Seidel <jensseidel@users.sf.net>
	via <https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=547798>
	at <https://savannah.gnu.org/bugs/index.php?55149>.

	* gnulib-local/lib/gettext.h (_LIBGETTEXT_HAVE_VARIABLE_SIZE_ARRAYS): Define
	to 0 in C++ mode.

2024-10-15  Bruno Haible  <bruno@clisp.org>

	msgen: Convert charset=CHARSET to charset=ASCII.
	Reported at <https://savannah.gnu.org/bugs/index.php?20923>.

	* gettext-tools/src/msgen.c: Include msgl-ascii.h, c-strstr.h, xalloc.h.
	(fill_header): New function, based on fill_header in msginit.c.
	(main): Invoke it.
	* gettext-tools/tests/msgen-1: Provide as input a POT file with charset=CHARSET,
	and verify that the output has charset=ASCII.

2024-10-15  Bruno Haible  <bruno@clisp.org>

	Refactor.
	* gettext-tools/src/msgl-header.h (header_set_charset): New declaration.
	* gettext-tools/src/msgl-header.c (header_set_charset): New function.
	* gettext-tools/src/msgl-iconv.c: Include msgl-header.h.
	(iconv_message_list_internal): Use header_set_charset.
	* gettext-tools/src/x-po.c: Include msgl-header.h.
	(extract): Use header_set_charset.
	* gettext-tools/src/FILES: Update.

2024-10-15  Bruno Haible  <bruno@clisp.org>

	its: Add ability to check *.its and *.loc files with XML Schema 1.1.
	* gettext-tools/src/its.xsd10: Renamed from gettext-tools/src/its.xsd.
	(RulesType): Enumerate all possible rules in the ITS namespace, instead of using
	a wildcard.
	(OtherRuleType): New element.
	* gettext-tools/src/its.xsd11: Copied from gettext-tools/src/its.xsd.
	(LocNoteRuleType): Enable assertion.
	* gettext-tools/src/locating-rules.xsd10: Renamed from
	gettext-tools/src/locating-rules.xsd.
	* gettext-tools/src/locating-rules.xsd11: Copied from
	gettext-tools/src/locating-rules.xsd.
	(LocatingRuleType): Enable assertion.
	* gettext-tools/src/Makefile.am (schema_DATA): Add its.xsd10, its.xsd11,
	locating-rules.xsd10, locating-rules.xsd11. Remove its.xsd, locating-rules.xsd.
	* gettext-tools/build-aux/xml-validate-10.in: New file.
	* gettext-tools/build-aux/xml-validate-11.in: New file.
	* gettext-tools/configure.ac: Substitute HAVE_JAVAEXEC.
	(AC_CONFIG_FILES): Create build-aux/xml-validate-10, build-aux/xml-validate-11.
	* gettext-tools/Makefile.am (DISTCLEANFILES): Add build-aux/xml-validate-10,
	build-aux/xml-validate-11.
	* gettext-tools/its/Makefile.am: Revert last commit.
	(check-local): Check each file both using the XML Schema 1.0 and the XML Schema
	1.1.
	* gettext-tools/doc/gettext.texi (ITS Rules): Mention the two versions of
	its.xsd.
	(Location Rules): Mention the two versions of locating-rules.xsd.
	* HACKING: Mention Xerces2-J.

2024-10-14  Bruno Haible  <bruno@clisp.org>

	its: Work around xmllint bug.
	* gettext-tools/its/Makefile.am (check-local): Skip the ITS_FILES checks if
	xmllint cannot grok the its.xsd schema.

2024-10-14  Bruno Haible  <bruno@clisp.org>

	po: Add a copyright and license notice to the Rules-quot auxiliary files.
	Reported by Joël Krähemann <jkraehemann@gmail.com>
	at <https://savannah.gnu.org/bugs/?57973>.

	* gettext-runtime/po/quot.sed: Add a copyright and all-permissive license
	notice.
	* gettext-runtime/po/boldquot.sed: Likewise.
	* gettext-runtime/po/en@quot.header: Likewise.
	* gettext-runtime/po/en@boldquot.header: Likewise.
	* gettext-runtime/po/insert-header.sed: Use an all-permissive license notice.
	* gettext-runtime/po/Rules-quot: Likewise.
	(.insert-header.po-update-en): After running the *.insert-header script,
	eliminate lines that start with %%.

2024-10-14  Bruno Haible  <bruno@clisp.org>

	po: Assume a 'sed' that supports '#' for introducing comments.
	This is standardized in POSIX since POSIX:2001 (= SUSv3).
	It is supported on all platforms that I could test:
	GNU, macOS 10.5, FreeBSD 5, NetBSD 7, OpenBSD 6, AIX 7, Solaris 10 and 11,
	busybox (2019).

	* gettext-runtime/po/remove-potcdate.sed: Renamed from
	gettext-runtime/po/remove-potcdate.sin.
	* gettext-runtime/po/Makefile.in.in (DISTFILES.common): Update.
	(.SUFFIXES): Remove .sin.
	(.sin.sed): Remove rule.
	($(DOMAIN).pot-update): Use remove-potcdate.sed in $(srcdir).
	(mostlyclean): Don't remove remove-potcdate.sed.
	* autogen.sh: Update.
	* Makefile.am (distcheck-hook): Update.
	* gettext-tools/examples/po/remove-potcdate.sed: Renamed from
	gettext-tools/examples/po/remove-potcdate.sin.
	* gettext-tools/examples/po/Makefile.am ($(DOMAIN).pot-update): Use
	remove-potcdate.sed in $(srcdir).
	(MOSTLYCLEANFILES): Don't add remove-potcdate.sed.
	(EXTRA_DIST): Update.
	* gettext-tools/examples/hello-*/po/Makefile.am ($(DOMAIN).pot-update): Use
	remove-potcdate.sed in $(srcdir).
	(MOSTLYCLEANFILES): Don't add remove-potcdate.sed.
	(EXTRA_DIST): Update.
	* gettext-tools/examples/hello-objc-gnustep/po/GNUmakefile
	($(DOMAIN).pot-update): Remove dependency on remove-potcdate.sed.
	(internal-clean): Remove rule.
	* gettext-tools/examples/hello-*/autogen.sh: Update.
	* gettext-tools/examples/hello-*/autoclean.sh: Update.

2024-10-14  Bruno Haible  <bruno@clisp.org>

	po: Assume a 'sed' that supports '#' for introducing comments.
	This is standardized in POSIX since POSIX:2001 (= SUSv3).
	It is supported on all platforms that I could test:
	GNU, macOS 10.5, FreeBSD 5, NetBSD 7, OpenBSD 6, AIX 7, Solaris 10 and 11,
	busybox (2019).

	* gettext-runtime/po/insert-header.sed: Renamed from
	gettext-runtime/po/insert-header.sin.
	* gettext-runtime/po/Rules-quot (DISTFILES.common.extra1): Update.
	(en@quot.insert-header, en@boldquot.insert-header): Use insert-header.sed
	instead of insert-header.sin.
	* autogen.sh: Update.
	* Makefile.am (distcheck-hook): Update.
	* gettext-tools/examples/hello-*/autogen.sh: Update.
	* gettext-tools/doc/gettext.texi (po/LINGUAS): Update.

2024-10-14  Bruno Haible  <bruno@clisp.org>

	its: Extend schema so that docbook4.its and docbook5.its pass.
